-----------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Beispielskript 03 - Temporal Table auswerten
-----------------------------------------------------
USE SNEK;
GO


-- Verkaufspreis ArtikelID 7 ndern
UPDATE dbo.Artikel SET Verkaufspreis = 0.97 WHERE ArtikelID = 7;

-- Etwas warten ...

-- Verkaufspreis ArtikelID 7 ndern
UPDATE dbo.Artikel SET Verkaufspreis = 0.99 WHERE ArtikelID = 7;


-- Daten und Gltigkeitszeitraum zu ArtikelID ausgeben
SELECT	ArtikelID, Verkaufspreis, AktuellVon, AktuellBis 
FROM	dbo.Artikel 
WHERE	ArtikelID = 7;

-- Aktuelle und alle historische Daten zu ArtikelID 7 ausgeben
SELECT	ArtikelID, Verkaufspreis, AktuellVon, AktuellBis 
FROM	dbo.Artikel 
		FOR SYSTEM_TIME ALL 
WHERE	ArtikelID  = 7
ORDER BY AktuellVon;



-- Historische Daten zu ArtikelID 7 zu einem bestimmten Zeitpunkt ausgeben
--> Datumsangabe vor dem Ausfhren anpassen
SELECT	ArtikelID, Verkaufspreis, AktuellVon, AktuellBis 
FROM	dbo.Artikel 
		FOR SYSTEM_TIME AS OF '2016-03-15 18:26:47' 
WHERE	ArtikelID = 7;


-- Aktuelle Daten und nderungen der letzten 2 Minuten ausgeben
DECLARE @ZeitpunktVon datetime2(0) = DATEADD(minute, -2, sysutcdatetime());
DECLARE @ZeitpunktBis datetime2(0) = sysutcdatetime();

SELECT	ArtikelID, Verkaufspreis, AktuellVon, AktuellBis
FROM	dbo.Artikel 
		FOR SYSTEM_TIME BETWEEN @ZeitpunktVon AND @ZeitpunktBis
WHERE	ArtikelID = 7
ORDER BY AktuellVon;