-----------------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Beispielskript 04 - Row Level Security - Objekte anlegen
-----------------------------------------------------------
USE SNEK;
GO


-- Inhalt der Tabelle Personal ausgeben
--> SID eines Benutzers in Spalte BenutzerID
--> Datenstze 8 - Kallaman und 9 - Lebhausen
SELECT * FROM dbo.Personal;
GO

-- Tabellenwertfunktion mit Regeldefinition erstellen
CREATE FUNCTION dbo.rlsBenutzerkonto(@PersonalID int)
RETURNS TABLE 
WITH SCHEMABINDING AS
RETURN
	SELECT	
			1 As OK
	FROM
			dbo.Personal 
	WHERE
			(@PersonalID = PersonalID 
			 AND
			 BenutzerID = SUSER_SID())
GO

-- Security Policy erstellen
CREATE SECURITY POLICY dbo.secAuftraege
ADD 
	FILTER PREDICATE dbo.rlsBenutzerkonto(PersonalID) 
		   ON dbo.Auftraege
GO





