-----------------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Beispielskript 04 - Row Level Security - Daten lesen
-----------------------------------------------------------
USE SNEK;
GO


-- Identitt zu Kallaman wechseln und Auftragssumme ermitteln
EXECUTE As USER = 'Kallaman';
SELECT	Nachname, Vorname, sum(Einzelpreis * Menge) As Auftragssumme 
FROM	dbo.Auftraege 
		INNER JOIN dbo.Auftragspositionen 
				ON dbo.Auftraege.AuftragID = dbo.Auftragspositionen.AuftragID
		INNER JOIN dbo.Personal 
				ON dbo.Auftraege.PersonalID = dbo.Personal.PersonalID
GROUP BY Nachname, Vorname;
REVERT;


-- Identitt zu Lebhausen wechseln und Auftragssumme ermitteln
EXECUTE As USER = 'Lebhausen';
SELECT	Nachname, Vorname, sum(Einzelpreis * Menge) As Auftragssumme 
FROM	dbo.Auftraege 
		INNER JOIN dbo.Auftragspositionen 
				ON dbo.Auftraege.AuftragID = dbo.Auftragspositionen.AuftragID
		INNER JOIN dbo.Personal 
				ON dbo.Auftraege.PersonalID = dbo.Personal.PersonalID
GROUP BY Nachname, Vorname;
REVERT;


-- Auftragssumme als dbo ermitteln
SELECT	sum(Einzelpreis * Menge) As Auftragssumme 
FROM	dbo.Auftraege INNER JOIN dbo.Auftragspositionen
		ON dbo.Auftraege.AuftragID = dbo.Auftragspositionen.AuftragID;
--> Ergebnis: NULL


-- Security Policy ausschalten
ALTER SECURITY POLICY dbo.secAuftraege WITH (State = OFF);


-- Auftragssumme als dbo ermitteln
SELECT	sum(Einzelpreis * Menge) As Auftragssumme 
FROM	dbo.Auftraege INNER JOIN dbo.Auftragspositionen
		ON dbo.Auftraege.AuftragID = dbo.Auftragspositionen.AuftragID;
--> Ergebnis: Auftragssumme


-- Identitt zu Lebhausen wechseln und Auftragssumme ermitteln
EXECUTE As USER = 'Lebhausen';
SELECT	Nachname, Vorname, sum(Einzelpreis * Menge) As Auftragssumme 
FROM	dbo.Auftraege 
		INNER JOIN dbo.Auftragspositionen 
				ON dbo.Auftraege.AuftragID = dbo.Auftragspositionen.AuftragID
		INNER JOIN dbo.Personal 
				ON dbo.Auftraege.PersonalID = dbo.Personal.PersonalID
GROUP BY Nachname, Vorname;
REVERT
--> Ergebnis: Auftragssummen aller Mitarbeiter


-- Regeldefinition um Prfung auf dbo erweitern
--> Vorab Security Policy entfernen
DROP SECURITY POLICY IF EXISTS dbo.secAuftraege;
GO
ALTER FUNCTION dbo.rlsBenutzerkonto(@PersonalID int)
RETURNS TABLE 
WITH SCHEMABINDING AS
RETURN
	SELECT	
			1 As Ok 
	FROM
			dbo.Personal 
	WHERE
			(@PersonalID = PersonalID 
			 AND
			 BenutzerID = SUSER_SID())
			OR 
			DATABASE_PRINCIPAL_ID() = 1 -- dbo
GO

-- Security Policy wieder anlegen
CREATE SECURITY POLICY dbo.secAuftraege
ADD 
	FILTER PREDICATE dbo.rlsBenutzerkonto(PersonalID) ON dbo.Auftraege
GO


-- Auftragssumme als dbo ermitteln
SELECT	sum(Einzelpreis * Menge) As Auftragssumme 
FROM	dbo.Auftraege INNER JOIN dbo.Auftragspositionen
		ON dbo.Auftraege.AuftragID = dbo.Auftragspositionen.AuftragID;
--> Ergebnis: Auftragssumme


-- Identitt zu Lebhausen wechseln und Auftragssumme ermitteln
EXECUTE As USER = 'Lebhausen';
SELECT	Nachname, Vorname, sum(Einzelpreis * Menge) As Auftragssumme 
FROM	dbo.Auftraege 
		INNER JOIN dbo.Auftragspositionen 
				ON dbo.Auftraege.AuftragID = dbo.Auftragspositionen.AuftragID
		INNER JOIN dbo.Personal 
				ON dbo.Auftraege.PersonalID = dbo.Personal.PersonalID
GROUP BY Nachname, Vorname;
REVERT
--> Ergebnis: Auftragssumme von Lebhausen