-----------------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Beispielskript 07 - Row Level Security - Block Predicate
-----------------------------------------------------------
USE SNEK;
GO


-- Security Policy um Block Predicate erweitern
ALTER SECURITY POLICY dbo.secAuftraege
ADD
	BLOCK PREDICATE dbo.rlsBenutzerkonto(PersonalID) 
		  ON dbo.Auftraege AFTER INSERT, 
ADD
	BLOCK PREDICATE dbo.rlsBenutzerkonto(PersonalID) 
		  ON dbo.Auftraege AFTER UPDATE;
GO


-- Auftrag als Lebhausen (PersonalID 9) mit PersonalID 1 anlegen
EXECUTE As USER = 'Lebhausen';
INSERT INTO dbo.Auftraege (KontaktID, PersonalID, Auftragsdatum) 
	   VALUES (1, 1, GETDATE());
REVERT;
--> Fehler - ausgelst duch Block Predicate AFTER INSERT


-- Auftrag als Lebhausen (PersonalID 9) mit PersonalID 9 anlegen
EXECUTE As USER = 'Lebhausen';
INSERT INTO dbo.Auftraege (KontaktID, PersonalID, Auftragsdatum) 
	   VALUES (1, 9, GETDATE());
SELECT SCOPE_IDENTITY() As neueID;
REVERT;
--> Kein Fehler


-- Auftrag als Lebhausen (PersonalID 9) in PersonalID 1 ndern
EXECUTE As USER = 'Lebhausen';
UPDATE	dbo.Auftraege 
SET		PersonalID = 1 
WHERE	AuftragID = 5585;
REVERT;
--> Fehler - ausgelst durch Block Predicate AFTER UPDATE