-----------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Beispielskript 10 - Dynamic Data Masking - Umgehen
-----------------------------------------------------
USE SNEK;
GO


-- Daten zu einem bestimmten Geburtsdatum als dbo ausgeben
SELECT	Nachname, Vorname, Geburtsdatum 
FROM	dbo.Personal 
WHERE	Geburtsdatum = '1988-02-08';

-- Daten zu einem bestimmten Geburtsdatum als Benutzer Bundestrojaner ausgeben
EXECUTE AS USER = 'Bundestrojaner';
SELECT	Nachname, Vorname, Geburtsdatum 
FROM	dbo.Personal 
WHERE	Geburtsdatum = '1988-02-08';
REVERT;


-- Ab jetzt erfolgen alle Ausgaben als Benutzer Bundestrojaner


-- Jahr, Monat und Tag von Geburtsdatum ausgeben
EXECUTE AS USER = 'Bundestrojaner';
SELECT	Nachname, Vorname,
		YEAR(Geburtsdatum) As Jahr, 
		MONTH(Geburtsdatum) As Monat, 
		DAY(Geburtsdatum) As Tag
FROM	dbo.Personal;
REVERT;


-- Geburtsdatum in Zeichenfolge konvertieren und ausgeben
EXECUTE AS USER = 'Bundestrojaner';
SELECT	Nachname, Vorname, 
		CAST(Geburtsdatum As varchar(50)) As Geburtsdatum
FROM	dbo.Personal;
REVERT;


-- Summe von Einzelpreis und Menge ausgeben
EXECUTE AS USER = 'Bundestrojaner';
SELECT	AuftragID, PosNr, Einzelpreis, Menge, 
		(Einzelpreis * Menge) As PosSumme
FROM	dbo.Auftragspositionen
WHERE	AuftragID BETWEEN 5580 AND 5585;
REVERT;


-- Geburtsdatum in Zeichenfolge konvertieren und in temporrer Tabelle speichern
EXECUTE AS USER = 'Bundestrojaner';
SELECT	Nachname, Vorname, 
		CAST(Geburtsdatum As varchar(50)) As Geburtsdatum
INTO	##UnmaskedPersonal
FROM	dbo.Personal;
SELECT	* FROM ##UnmaskedPersonal;
REVERT;

-- Inhalt der temporren Tabelle als dbo ausgeben
SELECT	* FROM ##UnmaskedPersonal;

-- Temporre Tabelle lschen
DROP TABLE ##UnmaskedPersonal;