-----------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Beispielskript 11 - T-SQL 
-----------------------------------------------------
USE SNEK;
GO


---------------------------------
-- FORMATMESSAGE
---------------------------------

-- Zeichenfolge mit Parameterwerten ausgeben
DECLARE @Meldung nvarchar(100),
		@Jahr	 nvarchar(4)	= '2016',
		@Nummer	 nvarchar(2)	= '5';

SET @Meldung = FORMATMESSAGE('Willkommen zum Vortrag "SQL Server %s " am ersten Tag der SNEK %s.', @Jahr, @Nummer)

SELECT @Meldung;

-- Zahl mit fhrenden Nullen ausgeben
SELECT FORMATMESSAGE('Fhrende Nullen %04i', 5) As Zahl;
GO


---------------------------------
-- DATEDIFF_BIG
---------------------------------

-- DATEDIFF und DATEDIFF_BIG bei DAY
DECLARE	@Zeitpunkt1 As datetime = '20160312',
		@Zeitpunkt2 As datetime = '20160313';

SELECT DATEDIFF(day, @Zeitpunkt1, @Zeitpunkt2) As Tage;
SELECT DATEDIFF_BIG(day, @Zeitpunkt1, @Zeitpunkt2) As Tage;
GO

-- DATEDIFF und DATEDIFF_BIG bei MICROSECOND
DECLARE	@Zeitpunkt1 As datetime2(7) = '20160312',
		@Zeitpunkt2 As datetime2(7) = '20160313';

SELECT DATEDIFF(MICROSECOND, @Zeitpunkt1, @Zeitpunkt2) As Tage;
SELECT DATEDIFF_BIG(MICROSECOND, @Zeitpunkt1, @Zeitpunkt2) As Tage;
--> Fehler bei DATEDIFF wegen berlauf
GO


---------------------------------
-- AT TIME ZONE
---------------------------------

-- Auftragsdatum in verschiedene Zeitzonen konvertieren und ausgeben
SELECT	AuftragID, Auftragsdatum, 
		Auftragsdatum AT TIME ZONE 'Pacific Standard Time' As Auftragsdatum_Pacific,
		Auftragsdatum AT TIME ZONE 'Central European Standard Time' As Auftragsdatum_Central_Europe
FROM	dbo.Auftraege
WHERE	AuftragID = 2223;
GO


---------------------------------
-- DROP IF EXISTS
---------------------------------

-- Gespeicherte Prozedur anlegen
CREATE PROC dbo.pSelectHallo AS 
BEGIN
	SELECT 'SNEK' As Hallo;
END
GO
-- Gespeicherte Prozedur ausfhren
EXEC dbo.pSelectHallo;

-- Gespeicherte Prozedur lschen, wenn vorhanden - alte Version 1
IF EXISTS (SELECT name FROM sys.objects WHERE name = 'pSelectHallo' AND type_desc = N'SQL_STORED_PROCEDURE')
BEGIN
   DROP PROC dbo.pSelectHallo;
END

-- Gespeicherte Prozedur lschen, wenn vorhanden - alte Version 2
IF Object_ID('pSelectHallo') Is NOT NULL
BEGIN
	DROP PROC dbo.pSelectHallo;
END

-- Gespeicherte Prozedur lschen, wenn vorhanden - neue Version
DROP PROC IF EXISTS dbo.pSelectHallo;


-- Temporre Tabelle anlegen
SELECT	* INTO #Artikel FROM dbo.Artikel;

-- Temporre Tabelle lschen mit DROP IF EXISTS
DROP TABLE IF EXISTS #Artikel;