-----------------------------------------------------
-- Beispielskript zur SNEK 5 im Mrz 2016 in Nrnberg
-- Autor: Bernd Jungbluth
-- Keine Gewhrleistung, keine Haftung

-- Installation Beispieldatenbank SNK5
-----------------------------------------------------

USE [master]
GO
/****** Object:  Database [SNEK]    Script Date: 15.02.2016 17:09:13 ******/
CREATE DATABASE [SNEK]
GO
ALTER DATABASE [SNEK] SET COMPATIBILITY_LEVEL = 130
GO

USE [SNEK]
GO
/****** Object:  Table [dbo].[Ansprechpartner]    Script Date: 15.02.2016 17:09:13 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Ansprechpartner](
	[AnsprechpartnerID] [int] IDENTITY(1,1) NOT NULL,
	[KontaktID] [int] NOT NULL,
	[Nachname] [nvarchar](100) NOT NULL,
	[Vorname] [nvarchar](20) NULL,
	[Anrede] [nvarchar](5) NULL,
	[Position] [nvarchar](100) NULL,
	[Telefon] [nvarchar](25) NULL,
	[Mobil] [nvarchar](15) NULL,
	[Email] [nvarchar](255) NULL,
	[Telefax] [nvarchar](25) NULL,
	[iTS] [timestamp] NOT NULL,
 CONSTRAINT [CIX__dbo_Ansprechpartner_AnsprechpartnerID] PRIMARY KEY CLUSTERED 
(
	[AnsprechpartnerID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO
/****** Object:  Table [dbo].[Artikel]    Script Date: 15.02.2016 17:09:15 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Artikel](
	[ArtikelID] [int] IDENTITY(1,1) NOT NULL,
	[Matchcode] [nvarchar](9) NOT NULL,
	[Artikel] [nvarchar](50) NOT NULL,
	[Artikelbeschreibung] [nvarchar](max) NULL,
	[ArtikelgruppeID] [int] NOT NULL,
	[Verkaufspreis] [money] NULL,
	[LieferantenNr] [int] NULL,
	[Einkaufspreis] [money] NULL,
	[Gre] [nvarchar](5) NULL,
	[Farbe] [nvarchar](10) NULL,
	[Auslaufartikel] [bit] NOT NULL,
	[iTS] [timestamp] NOT NULL,
 CONSTRAINT [CIX__dbo_Artikel_ArtikelID] PRIMARY KEY CLUSTERED 
(
	[ArtikelID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO
/****** Object:  Table [dbo].[Artikelgruppen]    Script Date: 15.02.2016 17:09:15 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Artikelgruppen](
	[ArtikelgruppeID] [int] IDENTITY(1,1) NOT NULL,
	[Artikelgruppe] [nvarchar](50) NOT NULL,
	[AgBeschreibung] [nvarchar](max) NULL,
	[iTS] [timestamp] NOT NULL,
 CONSTRAINT [CIX__dbo_Artikelgruppen_ArtikelgruppeID] PRIMARY KEY CLUSTERED 
(
	[ArtikelgruppeID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO
/****** Object:  Table [dbo].[Auftraege]    Script Date: 15.02.2016 17:09:15 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Auftraege](
	[AuftragID] [int] IDENTITY(1,1) NOT NULL,
	[KontaktID] [int] NOT NULL,
	[PersonalID] [int] NOT NULL,
	[Auftragsdatum] [datetime2](0) NOT NULL,
	[iTS] [timestamp] NOT NULL,
 CONSTRAINT [CIX__dbo_Auftraege_AuftragID] PRIMARY KEY CLUSTERED 
(
	[AuftragID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO
/****** Object:  Table [dbo].[Auftragspositionen]    Script Date: 15.02.2016 17:09:15 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Auftragspositionen](
	[AuftragspositionID] [int] IDENTITY(1,1) NOT NULL,
	[AuftragID] [int] NOT NULL,
	[ArtikelID] [int] NOT NULL,
	[PosNr] [int] NOT NULL,
	[Einzelpreis] [money] NOT NULL,
	[Menge] [smallint] NOT NULL,
	[iTS] [timestamp] NOT NULL,
 CONSTRAINT [CIX__dbo_Auftragspositionen_AuftragspositionID] PRIMARY KEY CLUSTERED 
(
	[AuftragspositionID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO
/****** Object:  Table [dbo].[Kontakte]    Script Date: 15.02.2016 17:09:15 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Kontakte](
	[KontaktID] [int] IDENTITY(1,1) NOT NULL,
	[Kontaktart] [nchar](1) NOT NULL,
	[Firma] [nvarchar](255) NOT NULL,
	[Namenszusatz] [nvarchar](255) NULL,
	[Strasse] [nvarchar](60) NOT NULL,
	[Ort] [nvarchar](100) NOT NULL,
	[Region] [nvarchar](50) NULL,
	[PLZ] [nvarchar](10) NOT NULL,
	[Staat] [nvarchar](15) NULL,
	[Telefon] [nvarchar](25) NULL,
	[Telefax] [nvarchar](25) NULL,
	[Email] [nvarchar](255) NULL,
	[iTS] [timestamp] NOT NULL,
 CONSTRAINT [CIX__dbo_Kontakte_KontaktID] PRIMARY KEY CLUSTERED 
(
	[KontaktID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY]

GO
/****** Object:  Table [dbo].[Personal]    Script Date: 15.02.2016 17:09:16 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE TABLE [dbo].[Personal](
	[PersonalID] [int] IDENTITY(1,1) NOT NULL,
	[Nachname] [nvarchar](20) NOT NULL,
	[Vorname] [nvarchar](10) NOT NULL,
	[Position] [nvarchar](30) NULL,
	[Anrede] [nvarchar](25) NOT NULL,
	[Geburtsdatum] [datetime2](0) NULL,
	[Einstellung] [datetime2](0) NOT NULL,
	[Durchwahl] [nvarchar](4) NULL,
	[Mobil] [nvarchar](4) NULL,
	[Email] [nvarchar](max) NOT NULL,
	[Foto] [nvarchar](255) NULL,
	[Bemerkungen] [nvarchar](max) NULL,
	[Vorgesetzter] [int] NULL,
	[iTS] [timestamp] NOT NULL,
 CONSTRAINT [CIX__dbo_Personal_PersonalID] PRIMARY KEY CLUSTERED 
(
	[PersonalID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, IGNORE_DUP_KEY = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
/****** Object:  Table [dbo].[pSelectAuftragsvolumenArtikelgruppen]    Script Date: 15.02.2016 17:09:16 ******/
CREATE PROC dbo.pSelectAuftragsvolumenArtikelgruppen @VonJahr int, @BisJahr int
AS

SET NOCOUNT ON;

DECLARE	@JahrVon date = DATEFROMPARTS(@VonJahr, 1, 1),
		@JahrBis date = DATEFROMPARTS(@BisJahr, 12, 31)

SELECT	
		YEAR(dbo.Auftraege.Auftragsdatum) As Jahr,
		Artikelgruppe, dbo.Artikel.ArtikelgruppeID,
		SUM(Einzelpreis * Menge) As Auftragsvolumen
FROM	
		dbo.Auftraege 
		INNER JOIN dbo.Auftragspositionen
				ON dbo.Auftraege.AuftragID = dbo.Auftragspositionen.AuftragID 
		INNER JOIN dbo.Artikel 
				ON dbo.Auftragspositionen.ArtikelID = dbo.Artikel.ArtikelID 
		INNER JOIN dbo.Artikelgruppen
				ON dbo.Artikel.ArtikelgruppeID = dbo.Artikelgruppen.ArtikelgruppeID 
WHERE
		Auftragsdatum BETWEEN @JahrVon AND @JahrBis
GROUP BY 
		YEAR(dbo.Auftraege.Auftragsdatum), Artikelgruppe, dbo.Artikel.ArtikelgruppeID
ORDER BY 
		Jahr DESC;
GO
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
/****** Object:  Table [dbo].[pSelectArtikelgruppen]    Script Date: 15.02.2016 17:09:16 ******/
CREATE PROC [dbo].[pSelectArtikelgruppen]
AS
SET NOCOUNT ON;

SELECT	
		ArtikelgruppeID, Artikelgruppe
FROM	
		dbo.Artikelgruppen;
GO

SET IDENTITY_INSERT [dbo].[Ansprechpartner] ON 
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (1, 1, N'Neumann', N'Alfred', N'Herr', N'Inhaber', N'(030) 89 88 00', N'0163/9999999', N'mad@alfreds-sockenladen.de', N'030 89 88 110')
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (2, 1, N'Becker', N'Hilde', N'Frau', N'Geschftsfhrer', N'08798-9993', NULL, N'becker@alfreds-sockenladen.de', N'0812')
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (3, 2, N'Becker', N'Heinz', N'Herr', N'Lehrling', N'0621-08460-12', NULL, N'becker@blauesocke.de', N'0812')
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (4, 4, N'Schmitt', N'Rainer', N'Herr', N'Sachbearbeiter', NULL, NULL, N'rainer.schmitt@franksockenladen.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (5, 3, N'Meier', N'Michael', N'Herr', N'Vertriebsmitarbeiter', N'089-039123', NULL, N'michael@socks.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (6, 2, N'Beckerlein', N'Jens', N'Herr', N'Vertriebsmitarbeiter', N'0621-08460-15', NULL, NULL, NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (7, 3, N'Mller', N'Herbert', N'Herr', N'Vertriebsmitarbeiter', N'089-039123', NULL, N'herbert@socks.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (8, 5, N'Ottoman', N'Frank', N'Herr', N'Inhaber', NULL, NULL, N'ottoman@socktogo.com', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (9, 6, N'Meier', N'Jens', N'Herr', N'Sachbearbeiter', N'069-0245984', NULL, N'jens.meier@lehmann.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (10, 7, N'Morgenstern', N'Johanna', N'Frau', N'Inhaber', NULL, NULL, N'ms@morgenstern.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (11, 8, N'Ottoman', N'Ottilie', N'Frau', N'Inhaber', N'0221-0644327', NULL, N'ottilie.ottoman@hotmail.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (12, 9, N'Strumpf', N'Karl-Heinz', N'Herr', N'Geschftsfhrer', N'0372-035188', NULL, N'strumpf@sockenstop.com', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (13, 10, N'Pfeffer', N'Tom', N'Herr', N'Inhaber', N'0251-031259', NULL, N'pfeffer@online.com', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (14, 11, N'Grnling', N'Claudia', N'Frau', N'Sachbearbeiter', N'0711-020361-8', NULL, N'claudiag@web.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (15, 12, N'Schmitthuber', N'Waltraud', N'Frau', N'Inhaber', NULL, NULL, N'schmitthuber@schmitthuber.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (16, 13, N'Kunze', N'Wilhelm', N'Herr', N'Geschftsfhrer', NULL, NULL, N'kunze@sportwaren-kunze.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (17, 14, N'Meier', N'Karl', N'Herr', N'Inhaber', NULL, NULL, N'meier@karlmeier.com', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (18, 15, N'Federhuhn', N'Barbara', N'Frau', N'Sachbearbeiter', NULL, NULL, N'federhuhn@gmx.de', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (19, 17, N'Hutmann', N'Florian', N'Herr', N'Sachbearbeiter', NULL, NULL, N'hutmann@toffline.com', NULL)
GO
INSERT [dbo].[Ansprechpartner] ([AnsprechpartnerID], [KontaktID], [Nachname], [Vorname], [Anrede], [Position], [Telefon], [Mobil], [Email], [Telefax]) VALUES (20, 16, N'Lffelchen', N'Birgit', N'Frau', N'Inhaber', NULL, NULL, N'loeffel@socksandmore.com', NULL)
GO
SET IDENTITY_INSERT [dbo].[Ansprechpartner] OFF
GO
SET IDENTITY_INSERT [dbo].[Artikel] ON 

GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (1, N'D01BL3538', N'Damensocke "Klassik" - 35-38 - blau', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe blau', 1, 0.7700, 12, 0.5900, N'35-38', N'blau', 1)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (2, N'D01BR3538', N'Damensocke "Klassik" - 35-38 - braun', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe braun', 1, 0.7700, 12, 0.5900, N'35-38', N'braun', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (3, N'D01GR3538', N'Damensocke "Klassik" - 35-38 - grau', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe grau', 1, 0.7700, 12, 0.5900, N'35-38', N'grau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (4, N'D01RO3538', N'Damensocke "Klassik" - 35-38 - rot', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe rot', 1, 0.7700, 12, 0.5900, N'35-38', N'rot', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (5, N'D01SC3538', N'Damensocke "Klassik" - 35-38 - schwarz', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe schwarz', 1, 0.7700, 12, 0.5900, N'35-38', N'schwarz', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (6, N'D01BL3942', N'Damensocke "Klassik" - 39-42 - blau', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe blau', 1, 0.7700, 12, 0.5900, N'39-42', N'blau', 1)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (7, N'D01BR3942', N'Damensocke "Klassik" - 39-42 - braun', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe braun', 1, 0.7700, 12, 0.5900, N'39-42', N'braun', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (8, N'D01GR3942', N'Damensocke "Klassik" - 39-42 - grau', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe grau', 1, 0.7700, 12, 0.5900, N'39-42', N'grau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (9, N'D01RO3942', N'Damensocke "Klassik" - 39-42 - rot', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe rot', 1, 0.7700, 12, 0.5900, N'39-42', N'rot', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (10, N'D01SC3942', N'Damensocke "Klassik" - 39-42 - schwarz', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe schwarz', 1, 0.7700, 12, 0.5900, N'39-42', N'schwarz', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (11, N'D01BL4346', N'Damensocke "Klassik" - 43-46 - blau', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe blau', 1, 0.7700, 12, 0.5900, N'43-46', N'blau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (12, N'D01BR4346', N'Damensocke "Klassik" - 43-46 - braun', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe braun', 1, 0.7700, 12, 0.5900, N'43-46', N'braun', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (13, N'D01GR4346', N'Damensocke "Klassik" - 43-46 - grau', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe grau', 1, 0.7700, 12, 0.5900, N'43-46', N'grau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (14, N'D01RO4346', N'Damensocke "Klassik" - 43-46 - rot', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe rot', 1, 0.7700, 12, 0.5900, N'43-46', N'rot', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (15, N'D01SC4346', N'Damensocke "Klassik" - 43-46 - schwarz', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe schwarz', 1, 0.7700, 12, 0.5900, N'43-46', N'schwarz', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (16, N'H01BL3538', N'Herrensocke "Klassik" - 35-38 - blau', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe blau', 2, 0.7900, 12, 0.6700, N'35-38', N'blau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (17, N'H01BR3538', N'Herrensocke "Klassik" - 35-38 - braun', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe braun', 2, 0.7900, 12, 0.6700, N'35-38', N'braun', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (18, N'H01GR3538', N'Herrensocke "Klassik" - 35-38 - grau', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe grau', 2, 0.7900, 12, 0.6700, N'35-38', N'grau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (19, N'H01RO3538', N'Herrensocke "Klassik" - 35-38 - rot', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe rot', 2, 0.7900, 12, 0.6700, N'35-38', N'rot', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (20, N'H01SC3538', N'Herrensocke "Klassik" - 35-38 - schwarz', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe schwarz', 2, 0.7900, 12, 0.6700, N'35-38', N'schwarz', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (21, N'H01BL3942', N'Herrensocke "Klassik" - 39-42 - blau', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe blau', 2, 0.7900, 12, 0.6700, N'39-42', N'blau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (22, N'H01BR3942', N'Herrensocke "Klassik" - 39-42 - braun', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe braun', 2, 0.7900, 12, 0.6700, N'39-42', N'braun', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (23, N'H01GR3942', N'Herrensocke "Klassik" - 39-42 - grau', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe grau', 2, 0.7900, 12, 0.6700, N'39-42', N'grau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (24, N'H01RO3942', N'Herrensocke "Klassik" - 39-42 - rot', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe rot', 2, 0.7900, 12, 0.6700, N'39-42', N'rot', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (25, N'H01SC3942', N'Herrensocke "Klassik" - 39-42 - schwarz', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe schwarz', 2, 0.7900, 12, 0.6700, N'39-42', N'schwarz', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (26, N'H01BL4346', N'Herrensocke "Klassik" - 43-46 - blau', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe blau', 2, 0.7900, 12, 0.6700, N'43-46', N'blau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (27, N'H01BR4346', N'Herrensocke "Klassik" - 43-46 - braun', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe braun', 2, 0.7900, 12, 0.6700, N'43-46', N'braun', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (28, N'H01GR4346', N'Herrensocke "Klassik" - 43-46 - grau', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe grau', 2, 0.7900, 12, 0.6700, N'43-46', N'grau', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (29, N'H01RO4346', N'Herrensocke "Klassik" - 43-46 - rot', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe rot', 2, 0.7900, 12, 0.6700, N'43-46', N'rot', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (30, N'H01SC4346', N'Herrensocke "Klassik" - 43-46 - schwarz', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe schwarz', 2, 0.7900, 12, 0.6700, N'43-46', N'schwarz', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (31, N'D01G3538 ', N'Damensocke "Klassik" - 35-38 - grn', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe grn', 1, 0.7700, 12, 0.5900, N'35-38', N'grn', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (32, N'D01G3942 ', N'Damensocke "Klassik" - 39-42 - grn', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe grn', 1, 0.7700, 12, 0.5900, N'39-42', N'grn', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (33, N'D01G4346 ', N'Damensocke "Klassik" - 43-46 - grn', N'klassische Damensocke aus 100% Baumwolle, glatt, in der Farbe grn', 1, 0.7700, 12, 0.5900, N'43-46', N'grn', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (34, N'H01G3538 ', N'Herrensocke "Klassik" - 35-38 - grn', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe grn', 2, 0.7900, 12, 0.6700, N'35-38', N'grn', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (35, N'H01G3942 ', N'Herrensocke "Klassik" - 39-42 - grn', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe grn', 2, 0.7900, 12, 0.6700, N'39-42', N'grn', 0)
GO
INSERT [dbo].[Artikel] ([ArtikelID], [Matchcode], [Artikel], [Artikelbeschreibung], [ArtikelgruppeID], [Verkaufspreis], [LieferantenNr], [Einkaufspreis], [Gre], [Farbe], [Auslaufartikel]) VALUES (36, N'H01G4346 ', N'Herrensocke "Klassik" - 43-46 - grn', N'klassische Herrensocke aus 100% Baumwolle, glatt, in der Farbe grn', 2, 0.7900, 12, 0.6700, N'43-46', N'grn', 0)
GO
SET IDENTITY_INSERT [dbo].[Artikel] OFF
GO
SET IDENTITY_INSERT [dbo].[Artikelgruppen] ON 

GO
INSERT [dbo].[Artikelgruppen] ([ArtikelgruppeID], [Artikelgruppe], [AgBeschreibung]) VALUES (1, N'Damensocke "Klassik"', N'klassische Damensocke; 100% Baumwolle, glatt')
GO
INSERT [dbo].[Artikelgruppen] ([ArtikelgruppeID], [Artikelgruppe], [AgBeschreibung]) VALUES (2, N'Herrensocke "Klassik"', N'klassische Herrensocke; 100% Baumwolle, glatt')
GO
INSERT [dbo].[Artikelgruppen] ([ArtikelgruppeID], [Artikelgruppe], [AgBeschreibung]) VALUES (3, N'Sportsocke "Run"', N'klassische Sportsocke; 100% Baumwolle')
GO
SET IDENTITY_INSERT [dbo].[Artikelgruppen] OFF
GO
SET IDENTITY_INSERT [dbo].[Auftraege] ON 

GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2223, 9, 9, CAST(N'2015-03-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2224, 1, 6, CAST(N'2015-03-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2226, 1, 6, CAST(N'2015-03-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2227, 3, 3, CAST(N'2015-03-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2228, 9, 9, CAST(N'2015-03-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2229, 2, 7, CAST(N'2015-03-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2230, 1, 6, CAST(N'2015-03-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2233, 1, 6, CAST(N'2015-03-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2234, 1, 6, CAST(N'2015-03-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2236, 3, 3, CAST(N'2015-03-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2238, 6, 9, CAST(N'2015-03-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2239, 8, 4, CAST(N'2015-03-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2241, 7, 2, CAST(N'2015-04-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2242, 1, 6, CAST(N'2015-04-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2245, 2, 7, CAST(N'2015-04-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2246, 10, 4, CAST(N'2015-04-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2247, 8, 4, CAST(N'2015-04-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2248, 6, 9, CAST(N'2015-04-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2249, 1, 6, CAST(N'2015-04-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2254, 1, 6, CAST(N'2015-04-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2255, 1, 6, CAST(N'2015-04-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2256, 6, 9, CAST(N'2015-04-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2257, 1, 6, CAST(N'2015-04-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2258, 1, 6, CAST(N'2015-04-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2259, 6, 9, CAST(N'2015-04-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2261, 2, 7, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2262, 11, 7, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2265, 1, 6, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2266, 10, 4, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2267, 6, 9, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2268, 9, 9, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2269, 1, 6, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2271, 11, 7, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2273, 11, 7, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2274, 1, 6, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2275, 1, 6, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2276, 9, 9, CAST(N'2015-04-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2277, 3, 3, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2278, 1, 6, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2279, 9, 9, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2280, 9, 9, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2281, 6, 9, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2282, 9, 9, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2285, 1, 6, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2287, 1, 6, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2288, 11, 7, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2289, 4, 6, CAST(N'2015-04-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2290, 4, 6, CAST(N'2015-04-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2291, 8, 4, CAST(N'2015-04-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2293, 1, 6, CAST(N'2015-04-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2296, 1, 6, CAST(N'2015-04-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2298, 1, 6, CAST(N'2015-04-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2300, 1, 6, CAST(N'2015-04-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2301, 5, 8, CAST(N'2015-04-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2302, 7, 2, CAST(N'2015-04-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2303, 1, 6, CAST(N'2015-04-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2305, 1, 6, CAST(N'2015-04-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2306, 1, 6, CAST(N'2015-04-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2307, 11, 7, CAST(N'2015-04-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2309, 9, 9, CAST(N'2015-04-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2310, 1, 6, CAST(N'2015-04-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2311, 1, 6, CAST(N'2015-04-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2312, 6, 9, CAST(N'2015-04-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2317, 1, 6, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2318, 1, 6, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2319, 1, 6, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2320, 1, 6, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2322, 1, 6, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2326, 4, 6, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2329, 1, 6, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2330, 1, 6, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2331, 3, 3, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2332, 1, 6, CAST(N'2015-04-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2333, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2335, 11, 7, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2336, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2337, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2338, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2340, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2341, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2342, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2343, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2345, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2346, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2348, 1, 6, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2349, 8, 4, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2352, 10, 4, CAST(N'2015-04-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2353, 1, 6, CAST(N'2015-04-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2354, 8, 4, CAST(N'2015-04-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2357, 1, 6, CAST(N'2015-04-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2358, 4, 6, CAST(N'2015-04-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2359, 1, 6, CAST(N'2015-04-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2360, 8, 4, CAST(N'2015-04-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2362, 1, 6, CAST(N'2015-04-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2363, 1, 6, CAST(N'2015-04-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2365, 1, 6, CAST(N'2015-04-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2366, 1, 6, CAST(N'2015-04-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2367, 9, 9, CAST(N'2015-04-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2368, 1, 6, CAST(N'2015-04-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2369, 1, 6, CAST(N'2015-04-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2370, 1, 6, CAST(N'2015-04-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2371, 1, 6, CAST(N'2015-04-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2372, 1, 6, CAST(N'2015-04-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2373, 1, 6, CAST(N'2015-04-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2374, 1, 6, CAST(N'2015-04-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2375, 1, 6, CAST(N'2015-04-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2376, 1, 6, CAST(N'2015-04-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2378, 1, 6, CAST(N'2015-04-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2379, 2, 7, CAST(N'2015-04-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2380, 1, 6, CAST(N'2015-04-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2381, 4, 6, CAST(N'2015-04-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2382, 1, 6, CAST(N'2015-04-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2384, 1, 6, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2385, 11, 7, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2386, 1, 6, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2388, 1, 6, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2389, 8, 4, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2390, 1, 6, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2391, 4, 6, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2392, 1, 6, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2393, 1, 6, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2394, 1, 6, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2395, 1, 6, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2396, 9, 9, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2397, 10, 4, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2399, 10, 4, CAST(N'2015-04-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2402, 5, 8, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2404, 10, 4, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2405, 1, 6, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2406, 1, 6, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2407, 1, 6, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2408, 3, 3, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2409, 1, 6, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2410, 8, 4, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2411, 5, 8, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2412, 1, 6, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2413, 1, 6, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2414, 1, 6, CAST(N'2015-04-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2417, 1, 6, CAST(N'2015-04-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2421, 7, 2, CAST(N'2015-04-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2422, 1, 6, CAST(N'2015-04-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2423, 3, 3, CAST(N'2015-04-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2424, 1, 6, CAST(N'2015-04-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2425, 7, 2, CAST(N'2015-04-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2426, 1, 6, CAST(N'2015-04-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2427, 5, 8, CAST(N'2015-04-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2428, 1, 6, CAST(N'2015-04-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2430, 7, 2, CAST(N'2015-04-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2431, 5, 8, CAST(N'2015-04-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2432, 3, 3, CAST(N'2015-04-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2435, 4, 6, CAST(N'2015-04-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2437, 1, 6, CAST(N'2015-04-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2438, 6, 9, CAST(N'2015-04-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2441, 5, 8, CAST(N'2015-04-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2442, 8, 4, CAST(N'2015-04-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2443, 7, 2, CAST(N'2015-04-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2444, 7, 2, CAST(N'2015-04-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2445, 1, 6, CAST(N'2015-04-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2447, 7, 2, CAST(N'2015-04-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2450, 1, 6, CAST(N'2015-04-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2451, 10, 4, CAST(N'2015-04-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2452, 1, 6, CAST(N'2015-04-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2453, 1, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2454, 1, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2456, 11, 7, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2457, 1, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2458, 1, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2459, 1, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2460, 1, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2462, 1, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2463, 1, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2464, 1, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2465, 4, 6, CAST(N'2015-04-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2466, 3, 3, CAST(N'2015-04-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2467, 6, 9, CAST(N'2015-04-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2468, 5, 8, CAST(N'2015-04-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2470, 1, 6, CAST(N'2015-04-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2471, 1, 6, CAST(N'2015-04-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2472, 1, 6, CAST(N'2015-04-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2473, 1, 6, CAST(N'2015-04-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2474, 8, 4, CAST(N'2015-04-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2475, 1, 6, CAST(N'2015-04-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2476, 9, 9, CAST(N'2015-04-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2478, 9, 9, CAST(N'2015-04-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2479, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2480, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2481, 2, 7, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2482, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2483, 3, 3, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2484, 5, 8, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2486, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2487, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2488, 10, 4, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2489, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2490, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2491, 6, 9, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2492, 6, 9, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2493, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2494, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2495, 1, 6, CAST(N'2015-04-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2496, 9, 9, CAST(N'2015-04-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2497, 2, 7, CAST(N'2015-04-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2498, 1, 6, CAST(N'2015-04-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2499, 1, 6, CAST(N'2015-04-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2501, 10, 4, CAST(N'2015-04-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2502, 11, 7, CAST(N'2015-04-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2503, 3, 3, CAST(N'2015-04-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2504, 1, 6, CAST(N'2015-04-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2505, 1, 6, CAST(N'2015-04-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2507, 1, 6, CAST(N'2015-04-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2508, 1, 6, CAST(N'2015-04-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2509, 1, 6, CAST(N'2015-04-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2510, 1, 6, CAST(N'2015-04-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2512, 1, 6, CAST(N'2015-04-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2513, 1, 6, CAST(N'2015-04-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2514, 1, 6, CAST(N'2015-04-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2515, 1, 6, CAST(N'2015-04-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2519, 1, 6, CAST(N'2015-05-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2522, 4, 6, CAST(N'2015-05-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2526, 9, 9, CAST(N'2015-05-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2527, 9, 9, CAST(N'2015-05-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2528, 5, 8, CAST(N'2015-05-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2529, 1, 6, CAST(N'2015-05-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2530, 1, 6, CAST(N'2015-05-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2531, 1, 6, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2532, 1, 6, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2534, 1, 6, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2536, 1, 6, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2537, 1, 6, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2538, 10, 4, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2539, 1, 6, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2540, 1, 6, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2543, 8, 4, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2544, 1, 6, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2547, 11, 7, CAST(N'2015-05-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2548, 10, 4, CAST(N'2015-05-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2550, 4, 6, CAST(N'2015-05-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2551, 1, 6, CAST(N'2015-05-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2555, 1, 6, CAST(N'2015-05-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2556, 11, 7, CAST(N'2015-05-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2557, 6, 9, CAST(N'2015-05-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2558, 1, 6, CAST(N'2015-05-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2559, 8, 4, CAST(N'2015-05-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2561, 1, 6, CAST(N'2015-05-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2562, 1, 6, CAST(N'2015-05-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2567, 1, 6, CAST(N'2015-05-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2569, 1, 6, CAST(N'2015-05-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2570, 10, 4, CAST(N'2015-05-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2572, 1, 6, CAST(N'2015-05-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2573, 1, 6, CAST(N'2015-05-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2574, 2, 7, CAST(N'2015-05-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2575, 1, 6, CAST(N'2015-05-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2576, 5, 8, CAST(N'2015-05-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2579, 1, 6, CAST(N'2015-05-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2580, 1, 6, CAST(N'2015-05-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2582, 2, 7, CAST(N'2015-05-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2583, 1, 6, CAST(N'2015-05-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2585, 4, 6, CAST(N'2015-05-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2586, 7, 2, CAST(N'2015-05-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2587, 8, 4, CAST(N'2015-05-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2588, 6, 9, CAST(N'2015-05-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2589, 11, 7, CAST(N'2015-05-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2591, 1, 6, CAST(N'2015-05-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2595, 3, 3, CAST(N'2015-05-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2598, 1, 6, CAST(N'2015-05-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2599, 1, 6, CAST(N'2015-05-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2600, 11, 7, CAST(N'2015-05-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2601, 9, 9, CAST(N'2015-05-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2603, 1, 6, CAST(N'2015-05-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2606, 1, 6, CAST(N'2015-05-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2610, 1, 6, CAST(N'2015-05-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2611, 1, 6, CAST(N'2015-05-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2612, 1, 6, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2613, 6, 9, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2614, 6, 9, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2615, 1, 6, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2616, 1, 6, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2617, 9, 9, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2618, 5, 8, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2620, 7, 2, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2621, 1, 6, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2622, 1, 6, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2623, 7, 2, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2624, 11, 7, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2625, 1, 6, CAST(N'2015-05-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2626, 11, 7, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2627, 1, 6, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2628, 10, 4, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2629, 3, 3, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2630, 2, 7, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2631, 1, 6, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2632, 1, 6, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2634, 1, 6, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2637, 7, 2, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2638, 10, 4, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2639, 1, 6, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2640, 11, 7, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2641, 1, 6, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2642, 10, 4, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2644, 7, 2, CAST(N'2015-05-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2645, 1, 6, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2646, 2, 7, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2649, 10, 4, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2650, 1, 6, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2651, 6, 9, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2652, 1, 6, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2653, 1, 6, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2654, 1, 6, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2655, 1, 6, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2656, 8, 4, CAST(N'2015-05-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2657, 2, 7, CAST(N'2015-05-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2658, 1, 6, CAST(N'2015-05-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2660, 10, 4, CAST(N'2015-05-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2661, 8, 4, CAST(N'2015-05-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2663, 5, 8, CAST(N'2015-05-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2665, 7, 2, CAST(N'2015-05-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2666, 1, 6, CAST(N'2015-05-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2667, 2, 7, CAST(N'2015-05-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2668, 10, 4, CAST(N'2015-05-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2669, 5, 8, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2670, 6, 9, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2671, 1, 6, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2672, 1, 6, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2673, 1, 6, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2674, 1, 6, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2675, 9, 9, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2676, 1, 6, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2677, 1, 6, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2679, 11, 7, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2680, 1, 6, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2681, 6, 9, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2682, 1, 6, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2683, 8, 4, CAST(N'2015-05-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2684, 1, 6, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2685, 9, 9, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2686, 1, 6, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2687, 1, 6, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2688, 4, 6, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2689, 1, 6, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2690, 1, 6, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2691, 1, 6, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2693, 7, 2, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2694, 10, 4, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2696, 4, 6, CAST(N'2015-05-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2699, 3, 3, CAST(N'2015-05-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2702, 1, 6, CAST(N'2015-05-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2703, 5, 8, CAST(N'2015-05-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2704, 4, 6, CAST(N'2015-05-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2705, 1, 6, CAST(N'2015-05-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2708, 2, 7, CAST(N'2015-05-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2709, 1, 6, CAST(N'2015-05-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2710, 11, 7, CAST(N'2015-05-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2711, 11, 7, CAST(N'2015-05-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2712, 1, 6, CAST(N'2015-05-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2713, 1, 6, CAST(N'2015-05-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2718, 1, 6, CAST(N'2015-05-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2719, 1, 6, CAST(N'2015-05-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2720, 1, 6, CAST(N'2015-05-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2721, 4, 6, CAST(N'2015-05-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2723, 1, 6, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2724, 9, 9, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2725, 1, 6, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2728, 7, 2, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2729, 5, 8, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2730, 3, 3, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2731, 1, 6, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2732, 5, 8, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2733, 6, 9, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2734, 2, 7, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2735, 1, 6, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2737, 2, 7, CAST(N'2015-05-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2738, 1, 6, CAST(N'2015-05-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2739, 6, 9, CAST(N'2015-05-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2742, 10, 4, CAST(N'2015-05-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2743, 9, 9, CAST(N'2015-05-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2745, 2, 7, CAST(N'2015-05-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2746, 1, 6, CAST(N'2015-05-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2747, 6, 9, CAST(N'2015-05-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2751, 4, 6, CAST(N'2015-05-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2752, 6, 9, CAST(N'2015-05-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2753, 1, 6, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2754, 1, 6, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2755, 4, 6, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2756, 6, 9, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2757, 1, 6, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2758, 1, 6, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2760, 5, 8, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2762, 1, 6, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2763, 8, 4, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2765, 1, 6, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2766, 1, 6, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2768, 1, 6, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2770, 1, 6, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2771, 1, 6, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2772, 1, 6, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2774, 11, 7, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2775, 6, 9, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2776, 1, 6, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2777, 1, 6, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2778, 7, 2, CAST(N'2015-05-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2779, 1, 6, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2780, 1, 6, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2782, 1, 6, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2783, 1, 6, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2784, 5, 8, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2786, 1, 6, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2787, 11, 7, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2788, 1, 6, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2789, 1, 6, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2790, 1, 6, CAST(N'2015-05-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2791, 9, 9, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2792, 5, 8, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2793, 3, 3, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2794, 1, 6, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2796, 1, 6, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2797, 10, 4, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2799, 1, 6, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2800, 5, 8, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2801, 1, 6, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2802, 1, 6, CAST(N'2015-05-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2803, 8, 4, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2804, 1, 6, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2805, 1, 6, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2807, 7, 2, CAST(N'2015-05-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2808, 1, 6, CAST(N'2015-06-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2809, 1, 6, CAST(N'2015-06-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2810, 6, 9, CAST(N'2015-06-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2811, 1, 6, CAST(N'2015-06-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2814, 8, 4, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2816, 1, 6, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2817, 1, 6, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2818, 1, 6, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2820, 9, 9, CAST(N'2015-06-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2821, 1, 6, CAST(N'2015-06-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2822, 8, 4, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2823, 1, 6, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2825, 1, 6, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2826, 1, 6, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2827, 1, 6, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2830, 1, 6, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2831, 6, 9, CAST(N'2015-06-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2832, 1, 6, CAST(N'2015-06-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2833, 8, 4, CAST(N'2015-06-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2834, 1, 6, CAST(N'2015-06-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2835, 4, 6, CAST(N'2015-06-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2836, 1, 6, CAST(N'2015-06-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2838, 1, 6, CAST(N'2015-06-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2841, 8, 4, CAST(N'2015-06-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2842, 1, 6, CAST(N'2015-06-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2843, 1, 6, CAST(N'2015-06-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2844, 1, 6, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2845, 1, 6, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2846, 1, 6, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2847, 5, 8, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2849, 1, 6, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2850, 1, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2851, 5, 8, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2852, 1, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2853, 1, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2856, 6, 9, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2857, 4, 6, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2858, 4, 6, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2859, 1, 6, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2861, 5, 8, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2862, 3, 3, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2863, 7, 2, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2864, 1, 6, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2865, 10, 4, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2866, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2867, 2, 7, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2868, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2872, 10, 4, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2873, 9, 9, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2874, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2875, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2876, 6, 9, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2877, 1, 6, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2878, 1, 6, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2879, 2, 7, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2881, 10, 4, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2883, 1, 6, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2884, 7, 2, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2885, 8, 4, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2887, 9, 9, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2889, 11, 7, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2890, 1, 6, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2892, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2893, 7, 2, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2894, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2898, 9, 9, CAST(N'2015-06-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2899, 1, 6, CAST(N'2015-06-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2901, 1, 6, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2902, 1, 6, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2903, 1, 6, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2905, 6, 9, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2906, 6, 9, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2907, 3, 3, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2908, 1, 6, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2909, 5, 8, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2910, 1, 6, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2911, 1, 6, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2912, 2, 7, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2913, 1, 6, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2914, 8, 4, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2915, 1, 6, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2916, 1, 6, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2917, 3, 3, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2921, 8, 4, CAST(N'2015-06-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2924, 4, 6, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2925, 1, 6, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2929, 1, 6, CAST(N'2015-06-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2930, 11, 7, CAST(N'2015-06-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2931, 11, 7, CAST(N'2015-06-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2933, 7, 2, CAST(N'2015-06-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2934, 1, 6, CAST(N'2015-06-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2937, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2938, 8, 4, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2939, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2941, 1, 6, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2942, 11, 7, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2943, 8, 4, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2944, 6, 9, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2945, 4, 6, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2946, 1, 6, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2947, 6, 9, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2948, 1, 6, CAST(N'2015-06-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2950, 6, 9, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2951, 1, 6, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2952, 1, 6, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2953, 1, 6, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2954, 2, 7, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2955, 10, 4, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2956, 1, 6, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2957, 1, 6, CAST(N'2015-06-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2958, 1, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2959, 1, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2960, 10, 4, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2961, 8, 4, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2962, 7, 2, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2963, 1, 6, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2964, 1, 6, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2965, 1, 6, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2966, 11, 7, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2968, 1, 6, CAST(N'2015-06-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2971, 1, 6, CAST(N'2015-06-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2972, 11, 7, CAST(N'2015-06-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2973, 10, 4, CAST(N'2015-06-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2974, 7, 2, CAST(N'2015-06-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2975, 1, 6, CAST(N'2015-06-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2976, 5, 8, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2978, 1, 6, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2980, 11, 7, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2981, 1, 6, CAST(N'2015-06-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2983, 6, 9, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2984, 5, 8, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2985, 5, 8, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2986, 1, 6, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2987, 2, 7, CAST(N'2015-06-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2989, 1, 6, CAST(N'2015-06-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2991, 1, 6, CAST(N'2015-06-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2992, 7, 2, CAST(N'2015-06-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2993, 1, 6, CAST(N'2015-06-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2994, 1, 6, CAST(N'2015-06-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2997, 1, 6, CAST(N'2015-06-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (2999, 2, 7, CAST(N'2015-06-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3000, 1, 6, CAST(N'2015-06-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3002, 9, 9, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3003, 7, 2, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3004, 2, 7, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3006, 1, 6, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3007, 8, 4, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3008, 10, 4, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3009, 1, 6, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3010, 9, 9, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3012, 1, 6, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3013, 8, 4, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3016, 1, 6, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3017, 1, 6, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3018, 1, 6, CAST(N'2015-06-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3020, 10, 4, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3022, 3, 3, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3023, 4, 6, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3025, 1, 6, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3027, 1, 6, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3028, 1, 6, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3030, 9, 9, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3031, 8, 4, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3032, 1, 6, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3033, 1, 6, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3034, 8, 4, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3035, 11, 7, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3038, 1, 6, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3039, 10, 4, CAST(N'2015-06-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3040, 9, 9, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3041, 1, 6, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3043, 1, 6, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3045, 2, 7, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3046, 1, 6, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3048, 1, 6, CAST(N'2015-06-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3051, 4, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3052, 3, 3, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3053, 8, 4, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3054, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3055, 8, 4, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3056, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3058, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3059, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3062, 8, 4, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3063, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3064, 4, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3065, 9, 9, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3066, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3068, 1, 6, CAST(N'2015-06-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3069, 1, 6, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3070, 1, 6, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3071, 1, 6, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3073, 8, 4, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3074, 1, 6, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3075, 1, 6, CAST(N'2015-06-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3081, 7, 2, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3082, 1, 6, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3083, 1, 6, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3084, 1, 6, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3085, 1, 6, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3086, 2, 7, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3087, 7, 2, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3088, 4, 6, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3089, 1, 6, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3090, 6, 9, CAST(N'2015-06-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3091, 1, 6, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3092, 1, 6, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3093, 1, 6, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3094, 1, 6, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3095, 3, 3, CAST(N'2015-06-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3098, 10, 4, CAST(N'2015-06-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3099, 2, 7, CAST(N'2015-06-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3100, 1, 6, CAST(N'2015-06-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3101, 4, 6, CAST(N'2015-06-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3102, 11, 7, CAST(N'2015-06-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3103, 7, 2, CAST(N'2015-06-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3105, 1, 6, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3107, 1, 6, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3108, 3, 3, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3109, 1, 6, CAST(N'2015-06-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3112, 3, 3, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3113, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3114, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3115, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3116, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3117, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3118, 1, 6, CAST(N'2015-06-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3119, 7, 2, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3120, 6, 9, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3121, 1, 6, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3122, 1, 6, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3123, 1, 6, CAST(N'2015-06-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3124, 1, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3126, 10, 4, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3127, 2, 7, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3128, 4, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3129, 4, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3130, 1, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3131, 1, 6, CAST(N'2015-06-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3133, 1, 6, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3134, 1, 6, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3135, 6, 9, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3136, 1, 6, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3137, 6, 9, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3138, 1, 6, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3139, 6, 9, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3140, 10, 4, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3141, 1, 6, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3142, 1, 6, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3143, 5, 8, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3144, 1, 6, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3145, 1, 6, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3146, 5, 8, CAST(N'2015-06-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3147, 8, 4, CAST(N'2015-07-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3148, 1, 6, CAST(N'2015-07-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3149, 10, 4, CAST(N'2015-07-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3150, 10, 4, CAST(N'2015-07-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3151, 10, 4, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3152, 7, 2, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3154, 1, 6, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3155, 1, 6, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3156, 1, 6, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3157, 3, 3, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3158, 1, 6, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3159, 1, 6, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3160, 1, 6, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3162, 1, 6, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3163, 9, 9, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3164, 9, 9, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3165, 7, 2, CAST(N'2015-07-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3167, 1, 6, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3168, 9, 9, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3169, 11, 7, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3171, 1, 6, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3173, 1, 6, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3174, 1, 6, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3176, 1, 6, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3177, 1, 6, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3178, 1, 6, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3179, 11, 7, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3180, 9, 9, CAST(N'2015-07-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3181, 1, 6, CAST(N'2015-07-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3182, 1, 6, CAST(N'2015-07-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3184, 6, 9, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3185, 7, 2, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3187, 10, 4, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3188, 1, 6, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3189, 1, 6, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3191, 11, 7, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3192, 8, 4, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3193, 1, 6, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3194, 1, 6, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3196, 1, 6, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3197, 9, 9, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3198, 10, 4, CAST(N'2015-07-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3200, 1, 6, CAST(N'2015-07-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3201, 4, 6, CAST(N'2015-07-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3204, 7, 2, CAST(N'2015-07-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3205, 11, 7, CAST(N'2015-07-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3206, 1, 6, CAST(N'2015-07-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3209, 4, 6, CAST(N'2015-07-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3211, 1, 6, CAST(N'2015-07-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3213, 1, 6, CAST(N'2015-07-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3214, 1, 6, CAST(N'2015-07-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3215, 3, 3, CAST(N'2015-07-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3218, 10, 4, CAST(N'2015-07-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3221, 8, 4, CAST(N'2015-07-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3224, 7, 2, CAST(N'2015-07-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3227, 1, 6, CAST(N'2015-07-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3228, 1, 6, CAST(N'2015-07-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3231, 1, 6, CAST(N'2015-07-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3232, 1, 6, CAST(N'2015-07-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3233, 3, 3, CAST(N'2015-07-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3234, 2, 7, CAST(N'2015-07-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3237, 1, 6, CAST(N'2015-07-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3238, 1, 6, CAST(N'2015-07-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3239, 1, 6, CAST(N'2015-07-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3240, 1, 6, CAST(N'2015-07-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3241, 2, 7, CAST(N'2015-07-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3243, 1, 6, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3245, 1, 6, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3246, 10, 4, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3247, 6, 9, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3248, 4, 6, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3249, 2, 7, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3250, 6, 9, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3251, 1, 6, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3253, 1, 6, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3254, 1, 6, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3255, 3, 3, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3256, 1, 6, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3257, 1, 6, CAST(N'2015-07-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3258, 1, 6, CAST(N'2015-07-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3260, 11, 7, CAST(N'2015-07-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3261, 5, 8, CAST(N'2015-07-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3262, 8, 4, CAST(N'2015-07-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3263, 3, 3, CAST(N'2015-07-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3265, 7, 2, CAST(N'2015-07-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3266, 1, 6, CAST(N'2015-07-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3268, 1, 6, CAST(N'2015-07-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3271, 3, 3, CAST(N'2015-07-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3272, 11, 7, CAST(N'2015-07-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3273, 10, 4, CAST(N'2015-07-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3274, 8, 4, CAST(N'2015-07-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3276, 1, 6, CAST(N'2015-07-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3277, 1, 6, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3278, 8, 4, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3279, 6, 9, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3280, 3, 3, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3282, 2, 7, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3284, 10, 4, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3285, 1, 6, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3286, 1, 6, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3287, 1, 6, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3288, 1, 6, CAST(N'2015-07-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3289, 1, 6, CAST(N'2015-07-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3290, 7, 2, CAST(N'2015-07-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3295, 1, 6, CAST(N'2015-07-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3296, 1, 6, CAST(N'2015-07-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3297, 4, 6, CAST(N'2015-07-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3298, 9, 9, CAST(N'2015-07-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3303, 8, 4, CAST(N'2015-07-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3304, 1, 6, CAST(N'2015-07-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3305, 1, 6, CAST(N'2015-07-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3306, 2, 7, CAST(N'2015-07-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3307, 7, 2, CAST(N'2015-07-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3309, 1, 6, CAST(N'2015-07-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3310, 11, 7, CAST(N'2015-07-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3312, 11, 7, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3313, 3, 3, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3314, 1, 6, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3315, 7, 2, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3316, 3, 3, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3317, 10, 4, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3319, 1, 6, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3320, 1, 6, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3322, 1, 6, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3323, 7, 2, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3324, 3, 3, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3325, 6, 9, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3326, 1, 6, CAST(N'2015-07-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3327, 1, 6, CAST(N'2015-07-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3328, 1, 6, CAST(N'2015-07-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3329, 1, 6, CAST(N'2015-07-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3332, 7, 2, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3333, 1, 6, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3334, 1, 6, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3335, 3, 3, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3336, 1, 6, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3339, 1, 6, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3340, 1, 6, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3341, 1, 6, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3343, 11, 7, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3344, 9, 9, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3345, 1, 6, CAST(N'2015-07-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3346, 1, 6, CAST(N'2015-07-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3352, 10, 4, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3353, 1, 6, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3354, 1, 6, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3355, 3, 3, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3356, 9, 9, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3357, 1, 6, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3358, 1, 6, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3359, 1, 6, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3360, 6, 9, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3361, 9, 9, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3362, 1, 6, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3363, 2, 7, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3364, 10, 4, CAST(N'2015-07-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3365, 8, 4, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3367, 1, 6, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3368, 9, 9, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3369, 10, 4, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3370, 1, 6, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3371, 2, 7, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3372, 8, 4, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3373, 7, 2, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3375, 3, 3, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3376, 1, 6, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3377, 1, 6, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3378, 1, 6, CAST(N'2015-07-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3380, 1, 6, CAST(N'2015-07-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3382, 1, 6, CAST(N'2015-07-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3383, 7, 2, CAST(N'2015-07-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3384, 5, 8, CAST(N'2015-07-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3385, 1, 6, CAST(N'2015-07-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3388, 8, 4, CAST(N'2015-07-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3390, 1, 6, CAST(N'2015-07-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3391, 1, 6, CAST(N'2015-07-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3392, 9, 9, CAST(N'2015-07-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3393, 1, 6, CAST(N'2015-07-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3394, 1, 6, CAST(N'2015-07-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3396, 9, 9, CAST(N'2015-07-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3397, 1, 6, CAST(N'2015-07-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3398, 9, 9, CAST(N'2015-07-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3399, 1, 6, CAST(N'2015-07-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3400, 1, 6, CAST(N'2015-07-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3401, 7, 2, CAST(N'2015-07-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3403, 1, 6, CAST(N'2015-07-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3404, 2, 7, CAST(N'2015-07-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3407, 1, 6, CAST(N'2015-07-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3409, 1, 6, CAST(N'2015-07-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3410, 8, 4, CAST(N'2015-07-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3411, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3413, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3415, 7, 2, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3416, 5, 8, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3417, 6, 9, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3418, 1, 6, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3419, 1, 6, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3422, 1, 6, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3423, 1, 6, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3426, 8, 4, CAST(N'2015-08-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3429, 1, 6, CAST(N'2015-08-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3430, 11, 7, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3431, 1, 6, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3432, 1, 6, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3433, 1, 6, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3434, 2, 7, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3436, 11, 7, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3437, 1, 6, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3439, 4, 6, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3440, 5, 8, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3441, 2, 7, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3444, 7, 2, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3445, 4, 6, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3449, 4, 6, CAST(N'2015-08-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3450, 5, 8, CAST(N'2015-08-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3451, 6, 9, CAST(N'2015-08-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3453, 1, 6, CAST(N'2015-08-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3454, 5, 8, CAST(N'2015-08-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3455, 8, 4, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3456, 4, 6, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3457, 1, 6, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3458, 10, 4, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3460, 6, 9, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3461, 2, 7, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3462, 9, 9, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3463, 1, 6, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3464, 6, 9, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3465, 6, 9, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3466, 11, 7, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3467, 1, 6, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3468, 4, 6, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3469, 1, 6, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3470, 1, 6, CAST(N'2015-08-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3472, 9, 9, CAST(N'2015-08-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3473, 1, 6, CAST(N'2015-08-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3474, 2, 7, CAST(N'2015-08-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3477, 1, 6, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3479, 6, 9, CAST(N'2015-08-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3480, 9, 9, CAST(N'2015-08-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3481, 5, 8, CAST(N'2015-08-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3482, 3, 3, CAST(N'2015-08-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3485, 4, 6, CAST(N'2015-08-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3487, 4, 6, CAST(N'2015-08-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3489, 1, 6, CAST(N'2015-08-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3491, 1, 6, CAST(N'2015-08-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3493, 6, 9, CAST(N'2015-08-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3494, 2, 7, CAST(N'2015-08-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3495, 7, 2, CAST(N'2015-08-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3496, 1, 6, CAST(N'2015-08-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3497, 3, 3, CAST(N'2015-08-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3499, 7, 2, CAST(N'2015-08-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3500, 11, 7, CAST(N'2015-08-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3502, 1, 6, CAST(N'2015-08-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3503, 1, 6, CAST(N'2015-08-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3504, 1, 6, CAST(N'2015-08-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3505, 5, 8, CAST(N'2015-08-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3506, 1, 6, CAST(N'2015-08-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3507, 2, 7, CAST(N'2015-08-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3508, 6, 9, CAST(N'2015-08-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3510, 1, 6, CAST(N'2015-08-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3511, 6, 9, CAST(N'2015-08-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3512, 1, 6, CAST(N'2015-08-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3513, 9, 9, CAST(N'2015-08-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3515, 11, 7, CAST(N'2015-08-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3516, 9, 9, CAST(N'2015-08-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3517, 1, 6, CAST(N'2015-08-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3518, 9, 9, CAST(N'2015-08-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3519, 7, 2, CAST(N'2015-08-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3520, 1, 6, CAST(N'2015-08-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3522, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3523, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3525, 8, 4, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3526, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3527, 5, 8, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3528, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3529, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3531, 7, 2, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3532, 5, 8, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3533, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3534, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3535, 2, 7, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3536, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3538, 1, 6, CAST(N'2015-08-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3539, 1, 6, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3540, 7, 2, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3541, 2, 7, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3543, 1, 6, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3544, 1, 6, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3545, 1, 6, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3546, 2, 7, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3547, 1, 6, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3549, 2, 7, CAST(N'2015-08-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3552, 7, 2, CAST(N'2015-08-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3554, 11, 7, CAST(N'2015-08-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3556, 1, 6, CAST(N'2015-08-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3557, 5, 8, CAST(N'2015-08-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3558, 1, 6, CAST(N'2015-08-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3559, 11, 7, CAST(N'2015-08-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3560, 11, 7, CAST(N'2015-08-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3562, 8, 4, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3563, 11, 7, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3564, 5, 8, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3565, 1, 6, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3566, 1, 6, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3567, 1, 6, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3569, 1, 6, CAST(N'2015-08-31T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3572, 1, 6, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3574, 1, 6, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3577, 1, 6, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3578, 3, 3, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3579, 7, 2, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3580, 9, 9, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3581, 10, 4, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3583, 2, 7, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3585, 1, 6, CAST(N'2015-08-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3586, 2, 7, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3587, 11, 7, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3588, 1, 6, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3589, 1, 6, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3590, 1, 6, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3592, 1, 6, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3593, 1, 6, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3594, 5, 8, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3595, 5, 8, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3596, 1, 6, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3599, 1, 6, CAST(N'2015-08-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3600, 4, 6, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3601, 1, 6, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3602, 1, 6, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3604, 4, 6, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3605, 5, 8, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3606, 2, 7, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3607, 4, 6, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3608, 10, 4, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3610, 2, 7, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3611, 1, 6, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3612, 6, 9, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3613, 1, 6, CAST(N'2015-08-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3615, 4, 6, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3616, 1, 6, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3618, 4, 6, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3619, 5, 8, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3621, 9, 9, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3622, 1, 6, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3623, 1, 6, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3624, 1, 6, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3625, 1, 6, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3626, 8, 4, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3627, 1, 6, CAST(N'2015-08-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3628, 7, 2, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3629, 2, 7, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3630, 7, 2, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3631, 1, 6, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3632, 11, 7, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3634, 1, 6, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3635, 11, 7, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3637, 1, 6, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3639, 1, 6, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3640, 8, 4, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3641, 1, 6, CAST(N'2015-08-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3642, 2, 7, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3643, 4, 6, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3644, 6, 9, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3645, 1, 6, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3646, 1, 6, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3647, 10, 4, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3648, 9, 9, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3649, 1, 6, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3651, 3, 3, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3652, 1, 6, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3656, 11, 7, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3657, 1, 6, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3658, 3, 3, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3659, 3, 3, CAST(N'2015-08-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3660, 1, 6, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3661, 4, 6, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3662, 10, 4, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3663, 1, 6, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3664, 1, 6, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3665, 1, 6, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3666, 1, 6, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3667, 2, 7, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3668, 9, 9, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3670, 11, 7, CAST(N'2015-08-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3671, 1, 6, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3673, 1, 6, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3674, 1, 6, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3676, 9, 9, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3677, 1, 6, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3678, 1, 6, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3679, 1, 6, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3681, 7, 2, CAST(N'2015-08-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3682, 7, 2, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3684, 8, 4, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3685, 7, 2, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3687, 1, 6, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3689, 2, 7, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3690, 9, 9, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3691, 2, 7, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3692, 3, 3, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3693, 1, 6, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3694, 3, 3, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3696, 1, 6, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3697, 10, 4, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3698, 3, 3, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3699, 1, 6, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3702, 1, 6, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3703, 8, 4, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3704, 4, 6, CAST(N'2015-08-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3706, 6, 9, CAST(N'2015-09-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3707, 1, 6, CAST(N'2015-09-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3709, 1, 6, CAST(N'2015-09-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3711, 8, 4, CAST(N'2015-09-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3712, 1, 6, CAST(N'2015-09-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3714, 2, 7, CAST(N'2015-09-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3715, 1, 6, CAST(N'2015-09-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3716, 1, 6, CAST(N'2015-09-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3717, 5, 8, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3720, 3, 3, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3721, 9, 9, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3722, 1, 6, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3723, 9, 9, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3725, 1, 6, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3729, 11, 7, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3730, 1, 6, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3731, 1, 6, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3732, 1, 6, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3733, 1, 6, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3734, 1, 6, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3735, 1, 6, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3736, 2, 7, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3737, 11, 7, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3738, 1, 6, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3740, 10, 4, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3741, 1, 6, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3742, 5, 8, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3744, 1, 6, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3746, 3, 3, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3747, 1, 6, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3749, 1, 6, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3750, 1, 6, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3751, 10, 4, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3752, 11, 7, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3753, 2, 7, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3754, 1, 6, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3755, 4, 6, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3756, 1, 6, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3758, 1, 6, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3760, 11, 7, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3761, 1, 6, CAST(N'2015-09-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3763, 1, 6, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3764, 9, 9, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3765, 6, 9, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3766, 4, 6, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3769, 2, 7, CAST(N'2015-09-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3770, 1, 6, CAST(N'2015-09-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3771, 7, 2, CAST(N'2015-09-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3772, 11, 7, CAST(N'2015-09-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3773, 1, 6, CAST(N'2015-09-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3774, 8, 4, CAST(N'2015-09-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3775, 1, 6, CAST(N'2015-09-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3776, 1, 6, CAST(N'2015-09-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3778, 1, 6, CAST(N'2015-09-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3779, 4, 6, CAST(N'2015-09-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3780, 1, 6, CAST(N'2015-09-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3781, 1, 6, CAST(N'2015-09-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3783, 1, 6, CAST(N'2015-09-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3784, 11, 7, CAST(N'2015-09-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3786, 1, 6, CAST(N'2015-09-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3787, 1, 6, CAST(N'2015-09-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3788, 1, 6, CAST(N'2015-09-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3789, 8, 4, CAST(N'2015-09-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3790, 1, 6, CAST(N'2015-09-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3793, 9, 9, CAST(N'2015-09-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3794, 1, 6, CAST(N'2015-09-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3795, 10, 4, CAST(N'2015-09-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3796, 1, 6, CAST(N'2015-09-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3798, 10, 4, CAST(N'2015-09-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3799, 10, 4, CAST(N'2015-09-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3800, 7, 2, CAST(N'2015-09-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3802, 1, 6, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3803, 2, 7, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3804, 2, 7, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3805, 1, 6, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3806, 10, 4, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3807, 11, 7, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3808, 5, 8, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3809, 1, 6, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3810, 7, 2, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3812, 3, 3, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3814, 6, 9, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3815, 1, 6, CAST(N'2015-09-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3819, 1, 6, CAST(N'2015-09-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3823, 9, 9, CAST(N'2015-09-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3824, 1, 6, CAST(N'2015-09-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3825, 9, 9, CAST(N'2015-09-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3826, 5, 8, CAST(N'2015-09-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3827, 6, 9, CAST(N'2015-09-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3828, 11, 7, CAST(N'2015-09-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3829, 1, 6, CAST(N'2015-09-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3830, 5, 8, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3831, 1, 6, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3832, 1, 6, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3833, 9, 9, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3834, 6, 9, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3835, 1, 6, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3837, 1, 6, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3838, 5, 8, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3840, 1, 6, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3841, 7, 2, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3842, 6, 9, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3843, 1, 6, CAST(N'2015-09-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3845, 1, 6, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3846, 2, 7, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3847, 4, 6, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3848, 9, 9, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3849, 10, 4, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3850, 1, 6, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3853, 11, 7, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3854, 4, 6, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3856, 3, 3, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3857, 1, 6, CAST(N'2015-09-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3858, 4, 6, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3859, 3, 3, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3860, 5, 8, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3861, 6, 9, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3862, 2, 7, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3863, 10, 4, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3864, 2, 7, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3865, 1, 6, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3867, 1, 6, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3869, 5, 8, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3870, 1, 6, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3872, 1, 6, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3873, 1, 6, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3874, 1, 6, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3875, 4, 6, CAST(N'2015-09-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3876, 3, 3, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3878, 1, 6, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3881, 1, 6, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3882, 8, 4, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3883, 4, 6, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3884, 1, 6, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3885, 1, 6, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3886, 1, 6, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3889, 5, 8, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3890, 1, 6, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3891, 1, 6, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3892, 1, 6, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3893, 10, 4, CAST(N'2015-09-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3894, 2, 7, CAST(N'2015-09-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3895, 4, 6, CAST(N'2015-09-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3898, 4, 6, CAST(N'2015-09-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3900, 1, 6, CAST(N'2015-09-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3901, 1, 6, CAST(N'2015-09-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3902, 4, 6, CAST(N'2015-09-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3903, 1, 6, CAST(N'2015-09-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3905, 7, 2, CAST(N'2015-09-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3906, 3, 3, CAST(N'2015-09-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3907, 1, 6, CAST(N'2015-09-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3908, 7, 2, CAST(N'2015-09-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3909, 1, 6, CAST(N'2015-09-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3910, 6, 9, CAST(N'2015-09-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3911, 1, 6, CAST(N'2015-09-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3912, 1, 6, CAST(N'2015-09-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3915, 5, 8, CAST(N'2015-09-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3917, 5, 8, CAST(N'2015-09-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3918, 3, 3, CAST(N'2015-09-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3920, 6, 9, CAST(N'2015-09-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3921, 1, 6, CAST(N'2015-09-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3922, 1, 6, CAST(N'2015-09-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3924, 1, 6, CAST(N'2015-09-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3925, 1, 6, CAST(N'2015-09-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3927, 1, 6, CAST(N'2015-09-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3928, 3, 3, CAST(N'2015-09-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3929, 1, 6, CAST(N'2015-09-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3930, 1, 6, CAST(N'2015-09-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3931, 1, 6, CAST(N'2015-09-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3933, 1, 6, CAST(N'2015-09-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3938, 8, 4, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3939, 1, 6, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3940, 1, 6, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3942, 1, 6, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3943, 3, 3, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3944, 11, 7, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3945, 5, 8, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3946, 1, 6, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3949, 1, 6, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3950, 5, 8, CAST(N'2015-09-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3952, 1, 6, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3953, 1, 6, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3954, 2, 7, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3955, 1, 6, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3956, 4, 6, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3957, 10, 4, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3958, 1, 6, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3959, 3, 3, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3960, 1, 6, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3961, 7, 2, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3962, 1, 6, CAST(N'2015-09-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3963, 3, 3, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3964, 1, 6, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3965, 6, 9, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3966, 10, 4, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3967, 1, 6, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3968, 6, 9, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3969, 4, 6, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3970, 7, 2, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3971, 1, 6, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3973, 1, 6, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3974, 6, 9, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3975, 5, 8, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3976, 11, 7, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3977, 1, 6, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3978, 11, 7, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3979, 4, 6, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3980, 1, 6, CAST(N'2015-09-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3981, 3, 3, CAST(N'2015-09-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3985, 8, 4, CAST(N'2015-09-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3988, 1, 6, CAST(N'2015-09-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3989, 6, 9, CAST(N'2015-09-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3990, 4, 6, CAST(N'2015-09-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3992, 1, 6, CAST(N'2015-09-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3993, 8, 4, CAST(N'2015-09-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3995, 1, 6, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3996, 7, 2, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3997, 3, 3, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3998, 11, 7, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (3999, 1, 6, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4000, 1, 6, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4002, 1, 6, CAST(N'2015-09-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4003, 3, 3, CAST(N'2015-09-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4004, 1, 6, CAST(N'2015-09-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4005, 9, 9, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4006, 9, 9, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4008, 1, 6, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4009, 1, 6, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4011, 1, 6, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4012, 1, 6, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4013, 6, 9, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4014, 9, 9, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4015, 1, 6, CAST(N'2015-09-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4018, 2, 7, CAST(N'2015-10-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4019, 8, 4, CAST(N'2015-10-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4020, 1, 6, CAST(N'2015-10-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4023, 7, 2, CAST(N'2015-10-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4025, 1, 6, CAST(N'2015-10-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4026, 8, 4, CAST(N'2015-10-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4027, 4, 6, CAST(N'2015-10-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4028, 4, 6, CAST(N'2015-10-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4029, 1, 6, CAST(N'2015-10-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4033, 10, 4, CAST(N'2015-10-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4034, 1, 6, CAST(N'2015-10-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4036, 1, 6, CAST(N'2015-10-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4037, 2, 7, CAST(N'2015-10-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4039, 9, 9, CAST(N'2015-10-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4040, 1, 6, CAST(N'2015-10-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4041, 2, 7, CAST(N'2015-10-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4045, 8, 4, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4047, 6, 9, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4048, 1, 6, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4049, 1, 6, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4051, 9, 9, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4053, 11, 7, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4054, 1, 6, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4055, 3, 3, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4056, 1, 6, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4057, 9, 9, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4058, 6, 9, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4059, 8, 4, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4060, 1, 6, CAST(N'2015-10-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4063, 10, 4, CAST(N'2015-10-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4064, 8, 4, CAST(N'2015-10-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4066, 2, 7, CAST(N'2015-10-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4068, 1, 6, CAST(N'2015-10-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4070, 4, 6, CAST(N'2015-10-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4071, 1, 6, CAST(N'2015-10-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4073, 1, 6, CAST(N'2015-10-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4075, 5, 8, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4076, 8, 4, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4077, 10, 4, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4078, 1, 6, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4079, 1, 6, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4080, 1, 6, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4081, 2, 7, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4082, 6, 9, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4083, 1, 6, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4084, 1, 6, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4085, 10, 4, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4086, 9, 9, CAST(N'2015-10-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4087, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4088, 7, 2, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4089, 8, 4, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4090, 6, 9, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4091, 8, 4, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4092, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4093, 11, 7, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4094, 3, 3, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4095, 4, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4096, 11, 7, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4098, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4099, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4100, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4101, 5, 8, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4102, 9, 9, CAST(N'2015-10-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4103, 6, 9, CAST(N'2015-10-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4104, 8, 4, CAST(N'2015-10-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4106, 1, 6, CAST(N'2015-10-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4107, 1, 6, CAST(N'2015-10-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4110, 3, 3, CAST(N'2015-10-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4111, 1, 6, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4112, 6, 9, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4114, 4, 6, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4115, 1, 6, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4116, 1, 6, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4117, 1, 6, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4118, 7, 2, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4119, 1, 6, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4120, 1, 6, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4121, 9, 9, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4124, 6, 9, CAST(N'2015-10-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4126, 1, 6, CAST(N'2015-10-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4127, 1, 6, CAST(N'2015-10-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4129, 1, 6, CAST(N'2015-10-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4130, 1, 6, CAST(N'2015-10-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4133, 8, 4, CAST(N'2015-10-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4135, 2, 7, CAST(N'2015-10-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4136, 1, 6, CAST(N'2015-10-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4137, 1, 6, CAST(N'2015-10-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4138, 11, 7, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4140, 4, 6, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4141, 6, 9, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4142, 1, 6, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4143, 8, 4, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4146, 1, 6, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4148, 11, 7, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4149, 8, 4, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4150, 1, 6, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4152, 1, 6, CAST(N'2015-10-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4154, 6, 9, CAST(N'2015-10-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4156, 6, 9, CAST(N'2015-10-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4157, 5, 8, CAST(N'2015-10-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4160, 4, 6, CAST(N'2015-10-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4161, 7, 2, CAST(N'2015-10-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4163, 1, 6, CAST(N'2015-10-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4164, 1, 6, CAST(N'2015-10-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4167, 7, 2, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4168, 5, 8, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4169, 1, 6, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4171, 6, 9, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4173, 1, 6, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4174, 1, 6, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4175, 6, 9, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4176, 11, 7, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4177, 1, 6, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4178, 1, 6, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4179, 11, 7, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4180, 10, 4, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4181, 11, 7, CAST(N'2015-10-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4183, 1, 6, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4184, 1, 6, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4187, 1, 6, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4188, 6, 9, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4191, 1, 6, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4192, 4, 6, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4193, 1, 6, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4195, 1, 6, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4196, 1, 6, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4197, 10, 4, CAST(N'2015-10-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4199, 2, 7, CAST(N'2015-10-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4200, 1, 6, CAST(N'2015-10-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4202, 9, 9, CAST(N'2015-10-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4203, 1, 6, CAST(N'2015-10-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4204, 1, 6, CAST(N'2015-10-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4205, 1, 6, CAST(N'2015-10-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4206, 10, 4, CAST(N'2015-10-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4207, 4, 6, CAST(N'2015-10-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4208, 1, 6, CAST(N'2015-10-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4210, 8, 4, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4211, 9, 9, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4212, 4, 6, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4213, 4, 6, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4214, 1, 6, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4215, 1, 6, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4216, 4, 6, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4217, 1, 6, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4219, 1, 6, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4220, 1, 6, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4221, 1, 6, CAST(N'2015-10-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4222, 1, 6, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4223, 11, 7, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4224, 7, 2, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4228, 1, 6, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4229, 5, 8, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4230, 4, 6, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4232, 1, 6, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4234, 6, 9, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4235, 1, 6, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4236, 1, 6, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4237, 1, 6, CAST(N'2015-10-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4238, 1, 6, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4240, 1, 6, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4241, 1, 6, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4244, 2, 7, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4245, 2, 7, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4246, 1, 6, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4247, 11, 7, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4248, 1, 6, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4249, 6, 9, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4250, 1, 6, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4251, 3, 3, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4252, 2, 7, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4253, 1, 6, CAST(N'2015-10-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4254, 5, 8, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4255, 1, 6, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4256, 1, 6, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4257, 5, 8, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4258, 8, 4, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4260, 2, 7, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4261, 10, 4, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4262, 1, 6, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4263, 1, 6, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4264, 1, 6, CAST(N'2015-10-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4266, 8, 4, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4268, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4269, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4270, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4271, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4273, 1, 6, CAST(N'2015-10-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4276, 1, 6, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4277, 1, 6, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4278, 11, 7, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4279, 1, 6, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4280, 6, 9, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4281, 1, 6, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4282, 1, 6, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4283, 5, 8, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4284, 5, 8, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4285, 8, 4, CAST(N'2015-10-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4288, 1, 6, CAST(N'2015-10-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4289, 1, 6, CAST(N'2015-10-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4290, 1, 6, CAST(N'2015-10-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4291, 1, 6, CAST(N'2015-10-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4292, 5, 8, CAST(N'2015-10-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4293, 5, 8, CAST(N'2015-10-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4294, 11, 7, CAST(N'2015-10-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4296, 1, 6, CAST(N'2015-10-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4297, 1, 6, CAST(N'2015-10-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4298, 1, 6, CAST(N'2015-10-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4300, 1, 6, CAST(N'2015-10-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4301, 1, 6, CAST(N'2015-10-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4302, 1, 6, CAST(N'2015-10-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4303, 1, 6, CAST(N'2015-10-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4304, 6, 9, CAST(N'2015-10-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4310, 1, 6, CAST(N'2015-10-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4311, 1, 6, CAST(N'2015-10-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4312, 1, 6, CAST(N'2015-10-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4313, 8, 4, CAST(N'2015-10-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4314, 10, 4, CAST(N'2015-10-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4315, 9, 9, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4316, 1, 6, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4317, 1, 6, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4318, 7, 2, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4319, 1, 6, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4320, 3, 3, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4321, 8, 4, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4322, 5, 8, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4323, 7, 2, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4324, 1, 6, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4325, 5, 8, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4326, 1, 6, CAST(N'2015-11-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4327, 11, 7, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4328, 3, 3, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4329, 8, 4, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4330, 1, 6, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4331, 4, 6, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4333, 3, 3, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4334, 3, 3, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4335, 7, 2, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4336, 1, 6, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4337, 6, 9, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4338, 1, 6, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4339, 9, 9, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4340, 1, 6, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4341, 2, 7, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4342, 1, 6, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4346, 1, 6, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4347, 1, 6, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4348, 2, 7, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4349, 1, 6, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4351, 6, 9, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4353, 6, 9, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4354, 1, 6, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4355, 5, 8, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4357, 1, 6, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4358, 7, 2, CAST(N'2015-11-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4361, 9, 9, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4362, 4, 6, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4363, 1, 6, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4364, 1, 6, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4365, 1, 6, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4366, 1, 6, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4369, 1, 6, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4370, 1, 6, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4371, 7, 2, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4372, 1, 6, CAST(N'2015-11-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4374, 1, 6, CAST(N'2015-11-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4376, 3, 3, CAST(N'2015-11-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4378, 8, 4, CAST(N'2015-11-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4379, 1, 6, CAST(N'2015-11-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4380, 1, 6, CAST(N'2015-11-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4381, 7, 2, CAST(N'2015-11-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4384, 11, 7, CAST(N'2015-11-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4385, 1, 6, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4386, 1, 6, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4387, 11, 7, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4389, 10, 4, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4391, 2, 7, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4392, 10, 4, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4394, 7, 2, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4395, 2, 7, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4396, 1, 6, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4397, 1, 6, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4398, 8, 4, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4400, 8, 4, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4401, 7, 2, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4402, 10, 4, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4403, 7, 2, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4404, 1, 6, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4405, 8, 4, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4406, 1, 6, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4407, 1, 6, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4408, 11, 7, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4409, 1, 6, CAST(N'2015-11-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4410, 1, 6, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4412, 1, 6, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4413, 1, 6, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4414, 8, 4, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4415, 9, 9, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4416, 11, 7, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4417, 1, 6, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4419, 11, 7, CAST(N'2015-11-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4420, 1, 6, CAST(N'2015-11-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4421, 1, 6, CAST(N'2015-11-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4422, 10, 4, CAST(N'2015-11-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4423, 1, 6, CAST(N'2015-11-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4425, 2, 7, CAST(N'2015-11-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4426, 1, 6, CAST(N'2015-11-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4429, 9, 9, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4430, 1, 6, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4431, 10, 4, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4433, 1, 6, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4435, 2, 7, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4436, 1, 6, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4437, 5, 8, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4438, 7, 2, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4439, 9, 9, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4441, 10, 4, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4442, 6, 9, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4444, 1, 6, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4445, 10, 4, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4446, 1, 6, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4447, 1, 6, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4449, 1, 6, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4450, 10, 4, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4451, 1, 6, CAST(N'2015-11-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4453, 9, 9, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4454, 10, 4, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4455, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4456, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4457, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4458, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4459, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4460, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4461, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4462, 1, 6, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4463, 1, 6, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4465, 1, 6, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4466, 11, 7, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4467, 1, 6, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4468, 1, 6, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4469, 8, 4, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4470, 6, 9, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4471, 1, 6, CAST(N'2015-11-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4473, 11, 7, CAST(N'2015-11-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4474, 1, 6, CAST(N'2015-11-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4477, 6, 9, CAST(N'2015-11-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4479, 8, 4, CAST(N'2015-11-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4480, 1, 6, CAST(N'2015-11-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4481, 1, 6, CAST(N'2015-11-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4482, 1, 6, CAST(N'2015-11-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4483, 2, 7, CAST(N'2015-11-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4484, 1, 6, CAST(N'2015-11-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4487, 1, 6, CAST(N'2015-11-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4488, 1, 6, CAST(N'2015-11-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4491, 1, 6, CAST(N'2015-11-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4492, 6, 9, CAST(N'2015-11-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4493, 1, 6, CAST(N'2015-11-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4494, 6, 9, CAST(N'2015-11-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4495, 1, 6, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4496, 10, 4, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4497, 3, 3, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4498, 1, 6, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4499, 1, 6, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4500, 9, 9, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4503, 11, 7, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4504, 2, 7, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4506, 1, 6, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4507, 1, 6, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4508, 11, 7, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4510, 9, 9, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4512, 1, 6, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4513, 11, 7, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4514, 1, 6, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4516, 1, 6, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4517, 1, 6, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4518, 1, 6, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4519, 10, 4, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4520, 9, 9, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4522, 11, 7, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4523, 11, 7, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4524, 1, 6, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4525, 6, 9, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4526, 7, 2, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4529, 8, 4, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4530, 1, 6, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4531, 3, 3, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4534, 2, 7, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4535, 1, 6, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4537, 1, 6, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4538, 11, 7, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4540, 1, 6, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4546, 1, 6, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4547, 11, 7, CAST(N'2015-11-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4549, 1, 6, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4550, 1, 6, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4551, 6, 9, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4553, 1, 6, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4554, 1, 6, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4555, 2, 7, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4556, 7, 2, CAST(N'2015-11-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4558, 7, 2, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4560, 8, 4, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4561, 3, 3, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4562, 9, 9, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4563, 5, 8, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4564, 9, 9, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4565, 11, 7, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4566, 1, 6, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4569, 6, 9, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4570, 10, 4, CAST(N'2015-11-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4571, 1, 6, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4572, 11, 7, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4573, 1, 6, CAST(N'2015-11-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4574, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4577, 5, 8, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4578, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4579, 9, 9, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4580, 8, 4, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4581, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4582, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4583, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4585, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4586, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4587, 8, 4, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4588, 1, 6, CAST(N'2015-11-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4589, 1, 6, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4590, 7, 2, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4591, 1, 6, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4592, 1, 6, CAST(N'2015-11-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4593, 4, 6, CAST(N'2015-11-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4596, 1, 6, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4597, 1, 6, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4598, 11, 7, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4600, 1, 6, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4601, 2, 7, CAST(N'2015-11-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4603, 11, 7, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4604, 5, 8, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4605, 1, 6, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4607, 1, 6, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4608, 1, 6, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4609, 1, 6, CAST(N'2015-11-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4610, 3, 3, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4612, 7, 2, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4613, 1, 6, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4614, 3, 3, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4615, 6, 9, CAST(N'2015-11-24T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4619, 11, 7, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4620, 7, 2, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4623, 1, 6, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4624, 1, 6, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4625, 1, 6, CAST(N'2015-11-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4626, 1, 6, CAST(N'2015-11-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4629, 3, 3, CAST(N'2015-11-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4630, 1, 6, CAST(N'2015-11-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4633, 3, 3, CAST(N'2015-11-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4635, 1, 6, CAST(N'2015-11-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4637, 1, 6, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4638, 1, 6, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4639, 3, 3, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4640, 9, 9, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4641, 1, 6, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4642, 1, 6, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4643, 1, 6, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4644, 1, 6, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4645, 7, 2, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4646, 1, 6, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4647, 1, 6, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4648, 1, 6, CAST(N'2015-11-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4649, 1, 6, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4650, 10, 4, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4651, 1, 6, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4652, 1, 6, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4653, 1, 6, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4654, 1, 6, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4655, 5, 8, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4656, 9, 9, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4657, 1, 6, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4658, 6, 9, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4660, 1, 6, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4661, 8, 4, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4662, 9, 9, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4663, 7, 2, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4664, 1, 6, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4666, 3, 3, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4667, 1, 6, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4668, 1, 6, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4670, 11, 7, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4671, 1, 6, CAST(N'2015-12-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4672, 4, 6, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4673, 1, 6, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4674, 1, 6, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4675, 1, 6, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4676, 5, 8, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4677, 7, 2, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4679, 6, 9, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4681, 1, 6, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4682, 3, 3, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4684, 2, 7, CAST(N'2015-12-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4688, 4, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4689, 1, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4691, 10, 4, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4693, 1, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4694, 1, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4697, 6, 9, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4698, 1, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4701, 1, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4702, 1, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4703, 1, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4704, 2, 7, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4707, 11, 7, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4708, 1, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4709, 4, 6, CAST(N'2015-12-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4710, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4711, 7, 2, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4712, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4714, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4715, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4717, 5, 8, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4718, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4719, 6, 9, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4720, 3, 3, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4722, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4724, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4725, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4726, 8, 4, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4727, 11, 7, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4728, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4729, 2, 7, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4731, 10, 4, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4733, 8, 4, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4734, 2, 7, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4737, 4, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4740, 1, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4741, 9, 9, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4743, 1, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4744, 2, 7, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4745, 1, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4746, 9, 9, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4748, 9, 9, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4749, 1, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4750, 7, 2, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4752, 3, 3, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4753, 1, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4754, 1, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4755, 5, 8, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4756, 1, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4757, 2, 7, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4758, 1, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4759, 1, 6, CAST(N'2015-12-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4760, 6, 9, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4762, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4764, 8, 4, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4766, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4767, 1, 6, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4769, 11, 7, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4770, 9, 9, CAST(N'2015-12-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4771, 8, 4, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4772, 1, 6, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4773, 11, 7, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4776, 1, 6, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4779, 1, 6, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4780, 1, 6, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4781, 2, 7, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4783, 10, 4, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4784, 1, 6, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4785, 6, 9, CAST(N'2015-12-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4786, 1, 6, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4787, 3, 3, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4788, 1, 6, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4790, 7, 2, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4791, 1, 6, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4792, 5, 8, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4793, 6, 9, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4794, 1, 6, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4796, 1, 6, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4797, 1, 6, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4798, 9, 9, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4800, 7, 2, CAST(N'2015-12-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4801, 1, 6, CAST(N'2015-12-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4803, 1, 6, CAST(N'2015-12-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4805, 1, 6, CAST(N'2015-12-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4808, 7, 2, CAST(N'2015-12-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4809, 2, 7, CAST(N'2015-12-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4810, 5, 8, CAST(N'2015-12-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4813, 1, 6, CAST(N'2015-12-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4814, 1, 6, CAST(N'2015-12-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4815, 5, 8, CAST(N'2015-12-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4816, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4817, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4818, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4819, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4821, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4822, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4823, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4824, 10, 4, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4825, 6, 9, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4826, 2, 7, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4827, 10, 4, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4828, 10, 4, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4829, 1, 6, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4831, 10, 4, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4832, 11, 7, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4833, 9, 9, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4834, 1, 6, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4835, 1, 6, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4836, 3, 3, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4837, 9, 9, CAST(N'2015-12-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4838, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4839, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4840, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4841, 2, 7, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4842, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4843, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4844, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4845, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4847, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4849, 6, 9, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4850, 1, 6, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4851, 10, 4, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4852, 1, 6, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4853, 3, 3, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4855, 10, 4, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4856, 5, 8, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4857, 11, 7, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4859, 6, 9, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4862, 4, 6, CAST(N'2015-12-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4864, 1, 6, CAST(N'2015-12-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4865, 10, 4, CAST(N'2015-12-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4866, 1, 6, CAST(N'2015-12-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4867, 1, 6, CAST(N'2015-12-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4869, 4, 6, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4870, 1, 6, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4874, 3, 3, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4875, 1, 6, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4878, 1, 6, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4879, 1, 6, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4881, 8, 4, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4882, 1, 6, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4884, 2, 7, CAST(N'2015-12-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4886, 9, 9, CAST(N'2015-12-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4887, 1, 6, CAST(N'2015-12-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4888, 7, 2, CAST(N'2015-12-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4889, 11, 7, CAST(N'2015-12-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4890, 1, 6, CAST(N'2015-12-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4891, 1, 6, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4892, 6, 9, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4893, 1, 6, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4894, 8, 4, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4895, 5, 8, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4896, 3, 3, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4898, 1, 6, CAST(N'2015-12-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4899, 1, 6, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4900, 2, 7, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4901, 5, 8, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4902, 1, 6, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4903, 5, 8, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4904, 1, 6, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4906, 1, 6, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4907, 1, 6, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4908, 1, 6, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4909, 10, 4, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4910, 1, 6, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4911, 8, 4, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4912, 1, 6, CAST(N'2015-12-30T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4914, 7, 2, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4915, 1, 6, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4917, 1, 6, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4918, 1, 6, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4920, 9, 9, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4921, 1, 6, CAST(N'2015-12-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4922, 10, 4, CAST(N'2015-12-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4923, 1, 6, CAST(N'2015-12-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4925, 1, 6, CAST(N'2015-12-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4926, 6, 9, CAST(N'2015-12-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4931, 3, 3, CAST(N'2015-12-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4932, 10, 4, CAST(N'2015-12-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4933, 10, 4, CAST(N'2015-12-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4934, 2, 7, CAST(N'2015-12-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4936, 9, 9, CAST(N'2015-12-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4937, 1, 6, CAST(N'2015-12-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4938, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4939, 5, 8, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4941, 9, 9, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4943, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4944, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4945, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4946, 5, 8, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4948, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4949, 4, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4950, 4, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4951, 11, 7, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4952, 8, 4, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4953, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4954, 7, 2, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4955, 1, 6, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4956, 5, 8, CAST(N'2015-12-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4957, 5, 8, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4958, 7, 2, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4959, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4960, 4, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4961, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4962, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4963, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4964, 2, 7, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4966, 6, 9, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4967, 1, 6, CAST(N'2015-12-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4968, 1, 6, CAST(N'2015-12-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4970, 9, 9, CAST(N'2015-12-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4971, 6, 9, CAST(N'2015-12-23T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4973, 11, 7, CAST(N'2015-01-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4974, 1, 6, CAST(N'2015-01-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4976, 1, 6, CAST(N'2015-01-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4978, 1, 6, CAST(N'2015-01-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4980, 6, 9, CAST(N'2015-01-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4981, 7, 2, CAST(N'2015-01-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4983, 10, 4, CAST(N'2015-01-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4987, 4, 6, CAST(N'2015-01-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4988, 1, 6, CAST(N'2015-01-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4989, 1, 6, CAST(N'2015-01-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4991, 8, 4, CAST(N'2015-01-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4994, 10, 4, CAST(N'2015-01-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4995, 10, 4, CAST(N'2015-01-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4996, 4, 6, CAST(N'2015-01-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4998, 7, 2, CAST(N'2015-01-06T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (4999, 2, 7, CAST(N'2015-01-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5000, 1, 6, CAST(N'2015-01-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5001, 1, 6, CAST(N'2015-01-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5003, 1, 6, CAST(N'2015-01-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5004, 1, 6, CAST(N'2015-01-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5006, 7, 2, CAST(N'2015-01-07T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5009, 1, 6, CAST(N'2015-01-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5010, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5011, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5012, 5, 8, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5013, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5015, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5016, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5017, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5019, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5020, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5021, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5022, 1, 6, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5024, 11, 7, CAST(N'2015-01-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5025, 1, 6, CAST(N'2015-01-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5026, 8, 4, CAST(N'2015-01-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5027, 1, 6, CAST(N'2015-01-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5028, 1, 6, CAST(N'2015-01-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5029, 1, 6, CAST(N'2015-01-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5030, 3, 3, CAST(N'2015-01-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5032, 3, 3, CAST(N'2015-01-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5034, 10, 4, CAST(N'2015-01-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5035, 8, 4, CAST(N'2015-01-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5036, 11, 7, CAST(N'2015-01-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5037, 1, 6, CAST(N'2015-01-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5038, 10, 4, CAST(N'2015-01-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5039, 5, 8, CAST(N'2015-01-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5040, 7, 2, CAST(N'2015-01-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5041, 1, 6, CAST(N'2015-01-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5043, 1, 6, CAST(N'2015-01-13T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5044, 10, 4, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5045, 1, 6, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5046, 1, 6, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5047, 1, 6, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5048, 1, 6, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5049, 3, 3, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5051, 9, 9, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5053, 1, 6, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5055, 5, 8, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5057, 1, 6, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5058, 10, 4, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5062, 1, 6, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5063, 5, 8, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5064, 7, 2, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5065, 3, 3, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5066, 11, 7, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5067, 1, 6, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5069, 1, 6, CAST(N'2015-01-14T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5071, 1, 6, CAST(N'2015-01-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5072, 1, 6, CAST(N'2015-01-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5073, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5074, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5075, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5076, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5077, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5078, 11, 7, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5079, 8, 4, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5080, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5083, 4, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5084, 2, 7, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5085, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5086, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5088, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5089, 1, 6, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5091, 3, 3, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5092, 7, 2, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5093, 6, 9, CAST(N'2015-01-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5095, 1, 6, CAST(N'2015-01-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5096, 1, 6, CAST(N'2015-01-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5097, 4, 6, CAST(N'2015-01-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5098, 1, 6, CAST(N'2015-01-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5099, 1, 6, CAST(N'2015-01-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5105, 7, 2, CAST(N'2015-01-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5106, 2, 7, CAST(N'2015-01-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5107, 4, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5108, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5109, 6, 9, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5110, 2, 7, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5112, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5113, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5114, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5115, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5116, 2, 7, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5117, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5118, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5119, 9, 9, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5120, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5121, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5123, 6, 9, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5124, 1, 6, CAST(N'2015-01-20T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5128, 3, 3, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5129, 10, 4, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5130, 5, 8, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5131, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5132, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5133, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5134, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5135, 4, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5136, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5137, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5139, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5140, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5141, 5, 8, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5142, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5143, 2, 7, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5144, 1, 6, CAST(N'2015-01-21T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5145, 11, 7, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5148, 3, 3, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5149, 1, 6, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5150, 1, 6, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5152, 1, 6, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5153, 1, 6, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5155, 1, 6, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5158, 6, 9, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5159, 5, 8, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5160, 8, 4, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5162, 4, 6, CAST(N'2015-01-22T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5163, 1, 6, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5166, 1, 6, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5167, 9, 9, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5168, 7, 2, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5169, 1, 6, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5170, 1, 6, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5172, 8, 4, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5173, 11, 7, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5174, 1, 6, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5175, 1, 6, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5176, 10, 4, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5178, 7, 2, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5179, 9, 9, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5180, 1, 6, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5181, 5, 8, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5182, 1, 6, CAST(N'2015-01-25T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5183, 10, 4, CAST(N'2015-01-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5184, 5, 8, CAST(N'2015-01-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5185, 1, 6, CAST(N'2015-01-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5188, 1, 6, CAST(N'2015-01-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5189, 1, 6, CAST(N'2015-01-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5190, 1, 6, CAST(N'2015-01-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5191, 1, 6, CAST(N'2015-01-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5193, 1, 6, CAST(N'2015-01-26T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5195, 1, 6, CAST(N'2015-01-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5197, 1, 6, CAST(N'2015-01-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5198, 11, 7, CAST(N'2015-01-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5199, 6, 9, CAST(N'2015-01-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5202, 3, 3, CAST(N'2015-01-27T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5203, 9, 9, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5204, 6, 9, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5205, 9, 9, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5207, 10, 4, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5208, 1, 6, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5209, 1, 6, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5210, 10, 4, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5211, 9, 9, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5212, 6, 9, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5213, 9, 9, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5214, 5, 8, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5215, 7, 2, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5217, 1, 6, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5219, 1, 6, CAST(N'2015-01-28T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5221, 7, 2, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5222, 1, 6, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5223, 9, 9, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5224, 1, 6, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5226, 2, 7, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5227, 7, 2, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5228, 1, 6, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5229, 1, 6, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5230, 1, 6, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5231, 1, 6, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5232, 1, 6, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5233, 6, 9, CAST(N'2015-01-29T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5234, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5235, 11, 7, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5236, 9, 9, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5237, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5238, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5239, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5240, 8, 4, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5241, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5242, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5243, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5244, 10, 4, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5245, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5246, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5247, 3, 3, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5248, 5, 8, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5249, 6, 9, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5250, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5252, 5, 8, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5253, 8, 4, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5254, 9, 9, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5258, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5259, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5261, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5262, 5, 8, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5263, 8, 4, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5264, 4, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5266, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5267, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5269, 10, 4, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5270, 5, 8, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5272, 6, 9, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5273, 11, 7, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5274, 4, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5275, 2, 7, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5276, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5277, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5278, 1, 6, CAST(N'2015-02-01T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5280, 5, 8, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5281, 4, 6, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5282, 5, 8, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5283, 1, 6, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5287, 1, 6, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5288, 1, 6, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5289, 8, 4, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5290, 4, 6, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5293, 8, 4, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5294, 5, 8, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5296, 1, 6, CAST(N'2015-02-02T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5298, 1, 6, CAST(N'2015-02-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5299, 10, 4, CAST(N'2015-02-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5302, 1, 6, CAST(N'2015-02-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5303, 10, 4, CAST(N'2015-02-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5304, 1, 6, CAST(N'2015-02-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5306, 1, 6, CAST(N'2015-02-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5307, 8, 4, CAST(N'2015-02-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5308, 1, 6, CAST(N'2015-02-03T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5309, 9, 9, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5312, 4, 6, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5313, 3, 3, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5314, 1, 6, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5315, 1, 6, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5316, 1, 6, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5317, 3, 3, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5318, 5, 8, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5320, 1, 6, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5322, 1, 6, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5324, 5, 8, CAST(N'2015-02-04T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5327, 6, 9, CAST(N'2015-02-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5328, 11, 7, CAST(N'2015-02-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5329, 1, 6, CAST(N'2015-02-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5330, 1, 6, CAST(N'2015-02-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5331, 1, 6, CAST(N'2015-02-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5333, 9, 9, CAST(N'2015-02-05T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5334, 8, 4, CAST(N'2016-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5335, 1, 6, CAST(N'2016-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5336, 6, 9, CAST(N'2016-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5337, 1, 6, CAST(N'2016-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5338, 11, 7, CAST(N'2016-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5339, 2, 7, CAST(N'2016-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5341, 1, 6, CAST(N'2016-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5342, 6, 9, CAST(N'2016-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5343, 1, 6, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5344, 9, 9, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5345, 2, 7, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5346, 1, 6, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5347, 1, 6, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5348, 1, 6, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5349, 2, 7, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5350, 1, 6, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5351, 1, 6, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5353, 9, 9, CAST(N'2015-02-08T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5354, 1, 6, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5355, 1, 6, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5356, 7, 2, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5359, 3, 3, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5360, 1, 6, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5362, 1, 6, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5363, 5, 8, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5364, 7, 2, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5366, 8, 4, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5367, 1, 6, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5368, 1, 6, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5369, 8, 4, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5370, 1, 6, CAST(N'2015-02-09T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5371, 9, 9, CAST(N'2015-02-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5372, 1, 6, CAST(N'2015-02-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5376, 1, 6, CAST(N'2015-02-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5377, 1, 6, CAST(N'2015-02-10T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5378, 1, 6, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5379, 1, 6, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5380, 1, 6, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5382, 1, 6, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5383, 1, 6, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5384, 1, 6, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5388, 1, 6, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5389, 1, 6, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5391, 4, 6, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5395, 9, 9, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5396, 2, 7, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5398, 6, 9, CAST(N'2015-02-11T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5400, 1, 6, CAST(N'2015-02-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5401, 6, 9, CAST(N'2015-02-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5402, 1, 6, CAST(N'2015-02-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5403, 1, 6, CAST(N'2015-02-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5404, 6, 9, CAST(N'2015-02-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5406, 11, 7, CAST(N'2015-02-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5407, 11, 7, CAST(N'2015-02-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5408, 11, 7, CAST(N'2015-02-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5409, 11, 7, CAST(N'2015-02-12T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5412, 4, 6, CAST(N'2016-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5413, 1, 6, CAST(N'2016-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5414, 1, 6, CAST(N'2016-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5415, 1, 6, CAST(N'2016-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5416, 1, 6, CAST(N'2016-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5417, 4, 6, CAST(N'2016-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5419, 1, 6, CAST(N'2016-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5421, 2, 7, CAST(N'2016-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5422, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5423, 2, 7, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5424, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5425, 9, 9, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5426, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5427, 11, 7, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5428, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5432, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5433, 2, 7, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5435, 7, 2, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5436, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5437, 2, 7, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5438, 5, 8, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5440, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5441, 11, 7, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5443, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5444, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5445, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5448, 11, 7, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5449, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5450, 8, 4, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5451, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5452, 1, 6, CAST(N'2015-02-15T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5454, 1, 6, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5455, 11, 7, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5456, 11, 7, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5457, 3, 3, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5459, 1, 6, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5460, 1, 6, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5462, 1, 6, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5463, 6, 9, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5464, 5, 8, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5465, 11, 7, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5466, 1, 6, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5467, 1, 6, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5468, 9, 9, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5470, 10, 4, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5472, 1, 6, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5473, 1, 6, CAST(N'2015-02-16T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5474, 1, 6, CAST(N'2015-02-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5475, 1, 6, CAST(N'2015-02-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5477, 1, 6, CAST(N'2015-02-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5479, 1, 6, CAST(N'2015-02-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5480, 5, 8, CAST(N'2015-02-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5481, 1, 6, CAST(N'2015-02-17T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5483, 10, 4, CAST(N'2015-02-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5484, 10, 4, CAST(N'2015-02-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5485, 1, 6, CAST(N'2015-02-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5486, 1, 6, CAST(N'2015-02-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5487, 1, 6, CAST(N'2015-02-18T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5488, 1, 6, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5489, 3, 3, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5491, 1, 6, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5492, 1, 6, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5493, 1, 6, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5494, 9, 9, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5495, 11, 7, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5496, 7, 2, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5497, 1, 6, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5498, 8, 4, CAST(N'2015-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5568, 10, 4, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5569, 1, 6, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5572, 1, 6, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5574, 3, 3, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5576, 2, 7, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5577, 1, 6, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5578, 11, 7, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5579, 1, 6, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5580, 10, 4, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5581, 1, 6, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
INSERT [dbo].[Auftraege] ([AuftragID], [KontaktID], [PersonalID], [Auftragsdatum]) VALUES (5582, 1, 6, CAST(N'2016-02-19T00:00:00.0000000' AS DateTime2))
GO
SET IDENTITY_INSERT [dbo].[Auftraege] OFF
GO
SET IDENTITY_INSERT [dbo].[Auftragspositionen] ON 

GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3087, 5582, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3088, 5582, 11, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3089, 5582, 25, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3090, 5581, 11, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3091, 5581, 21, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3092, 5580, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3093, 5579, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3094, 5579, 18, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3095, 5578, 15, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3096, 5577, 1, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3097, 5577, 2, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3098, 5577, 5, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3099, 5576, 13, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3100, 5574, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3101, 5574, 12, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3102, 5574, 21, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3103, 5572, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3104, 5572, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3105, 5569, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3106, 5568, 26, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3205, 5498, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3206, 5498, 5, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3207, 5498, 24, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3208, 5497, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3209, 5496, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3210, 5495, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3211, 5495, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3212, 5494, 17, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3213, 5493, 13, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3214, 5492, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3215, 5492, 12, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3216, 5492, 14, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3217, 5491, 27, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3218, 5491, 28, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3219, 5489, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3220, 5489, 17, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3221, 5488, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3222, 5487, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3223, 5487, 14, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3224, 5486, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3225, 5485, 26, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3226, 5484, 19, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3227, 5483, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3228, 5483, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3229, 5483, 23, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3230, 5481, 26, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3231, 5480, 10, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3232, 5480, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3233, 5479, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3234, 5479, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3235, 5477, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3236, 5477, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3237, 5477, 9, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3238, 5477, 27, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3239, 5477, 28, 5, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3240, 5475, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3241, 5475, 17, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3242, 5474, 23, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3243, 5474, 28, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3244, 5473, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3245, 5472, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3246, 5472, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3247, 5470, 13, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3248, 5470, 25, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3249, 5468, 23, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3250, 5468, 28, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3251, 5467, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3252, 5466, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3253, 5465, 16, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3254, 5465, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3255, 5465, 23, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3256, 5464, 27, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3257, 5463, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3258, 5463, 28, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3259, 5462, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3260, 5460, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3261, 5460, 19, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3262, 5460, 24, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3263, 5459, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3264, 5459, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3265, 5459, 21, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3266, 5457, 3, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3267, 5457, 11, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3268, 5457, 13, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3269, 5457, 23, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3270, 5457, 29, 5, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3271, 5456, 19, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3272, 5456, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3273, 5455, 16, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3274, 5454, 16, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3275, 5452, 6, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3276, 5451, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3277, 5451, 8, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3278, 5451, 15, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3279, 5451, 17, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3280, 5451, 23, 5, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3281, 5450, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3282, 5450, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3283, 5450, 18, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3284, 5450, 25, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3285, 5449, 21, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3286, 5448, 29, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3287, 5445, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3288, 5444, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3289, 5444, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3290, 5443, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3291, 5441, 26, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3292, 5440, 12, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3293, 5438, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3294, 5437, 25, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3295, 5436, 19, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3296, 5435, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3297, 5433, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3298, 5432, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3299, 5432, 25, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3300, 5428, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3301, 5428, 25, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3302, 5427, 26, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3303, 5426, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3304, 5426, 26, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3305, 5426, 29, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3306, 5425, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3307, 5425, 22, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3308, 5424, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3309, 5424, 27, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3310, 5423, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3311, 5423, 15, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3312, 5422, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3313, 5421, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3314, 5419, 12, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3315, 5419, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3316, 5419, 24, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3317, 5419, 29, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3318, 5417, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3319, 5417, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3320, 5417, 20, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3321, 5416, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3322, 5416, 22, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3323, 5416, 29, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3324, 5415, 21, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3325, 5414, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3326, 5414, 19, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3327, 5414, 24, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3328, 5413, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3329, 5413, 22, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3330, 5413, 24, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3331, 5412, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3332, 5409, 28, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3333, 5408, 26, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3334, 5407, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3335, 5407, 12, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3336, 5407, 29, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3337, 5406, 18, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3338, 5404, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3339, 5404, 14, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3340, 5403, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3341, 5402, 13, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3342, 5402, 27, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3343, 5401, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3344, 5401, 27, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3345, 5400, 19, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3346, 5398, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3347, 5398, 13, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3348, 5398, 29, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3349, 5396, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3350, 5396, 29, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3351, 5395, 9, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3352, 5391, 13, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3353, 5391, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3354, 5389, 15, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3355, 5389, 24, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3356, 5388, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3357, 5388, 21, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3358, 5388, 22, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3359, 5388, 25, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3360, 5384, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3361, 5383, 15, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3362, 5382, 9, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3363, 5380, 9, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3364, 5380, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3365, 5380, 20, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3366, 5379, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3367, 5379, 13, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3368, 5378, 18, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3369, 5378, 26, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3370, 5377, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3371, 5377, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3372, 5376, 19, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3373, 5372, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3374, 5372, 25, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3375, 5371, 15, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3376, 5371, 16, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3377, 5370, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3378, 5370, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3379, 5369, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3380, 5369, 12, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3381, 5369, 14, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3382, 5369, 16, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3383, 5368, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3384, 5367, 20, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3385, 5366, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3386, 5366, 6, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3387, 5366, 27, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3388, 5364, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3389, 5363, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3390, 5363, 8, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3391, 5362, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3392, 5362, 14, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3393, 5360, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3394, 5360, 11, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3395, 5360, 12, 3, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3396, 5359, 29, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3397, 5356, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3398, 5355, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3399, 5355, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3400, 5354, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3401, 5354, 14, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3402, 5354, 22, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3403, 5353, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3404, 5353, 7, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3405, 5351, 10, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3406, 5351, 25, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3407, 5351, 28, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3408, 5350, 26, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3409, 5349, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3410, 5349, 14, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3411, 5349, 19, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3412, 5348, 15, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3413, 5347, 25, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3414, 5346, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3415, 5346, 29, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3416, 5345, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3417, 5345, 6, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3418, 5345, 12, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3419, 5345, 23, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3420, 5345, 29, 5, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3421, 5344, 13, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3422, 5344, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3423, 5344, 25, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3424, 5343, 18, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3425, 5342, 20, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3426, 5341, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3427, 5341, 25, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3428, 5341, 28, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3429, 5339, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3430, 5339, 14, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3431, 5339, 18, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3432, 5339, 19, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3433, 5338, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3434, 5338, 13, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3435, 5338, 14, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3436, 5338, 23, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3437, 5337, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3438, 5336, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3439, 5335, 11, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3440, 5335, 14, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3441, 5335, 24, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3442, 5334, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3443, 5333, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3444, 5331, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3445, 5331, 25, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3446, 5330, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3447, 5329, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3448, 5329, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3449, 5328, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3450, 5327, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3451, 5327, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3452, 5324, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3453, 5324, 17, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3454, 5322, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3455, 5320, 21, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3456, 5320, 28, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3457, 5318, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3458, 5318, 23, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3459, 5318, 29, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3460, 5317, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3461, 5317, 20, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3462, 5317, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3463, 5316, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3464, 5315, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3465, 5315, 14, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3466, 5315, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3467, 5314, 15, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3468, 5313, 15, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3469, 5312, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3470, 5312, 13, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3471, 5309, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3472, 5308, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3473, 5308, 6, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3474, 5308, 8, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3475, 5307, 26, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3476, 5306, 22, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3477, 5304, 19, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3478, 5303, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3479, 5303, 20, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3480, 5302, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3481, 5299, 17, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3482, 5299, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3483, 5299, 29, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3484, 5298, 16, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3485, 5298, 29, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3486, 5296, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3487, 5296, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3488, 5294, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3489, 5293, 13, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3490, 5293, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3491, 5290, 18, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3492, 5289, 22, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3493, 5288, 20, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3494, 5287, 18, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3495, 5287, 21, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3496, 5283, 25, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3497, 5283, 27, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3498, 5282, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3499, 5281, 11, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3500, 5281, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3501, 5280, 29, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3502, 5278, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3503, 5278, 17, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3504, 5278, 18, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3505, 5278, 19, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3506, 5278, 28, 5, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3507, 5278, 29, 6, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3508, 5277, 25, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3509, 5276, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3510, 5275, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3511, 5275, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3512, 5275, 21, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3513, 5275, 28, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3514, 5275, 29, 5, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3515, 5274, 25, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3516, 5273, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3517, 5272, 8, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3518, 5272, 18, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3519, 5270, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3520, 5270, 5, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3521, 5269, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3522, 5269, 7, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3523, 5269, 18, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3524, 5269, 29, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3525, 5267, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3526, 5267, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3527, 5267, 17, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3528, 5266, 8, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3529, 5266, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3530, 5266, 29, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3531, 5264, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3532, 5264, 20, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3533, 5263, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3534, 5263, 16, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3535, 5262, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3536, 5261, 5, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3537, 5261, 20, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3538, 5259, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3539, 5259, 28, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3540, 5258, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3541, 5258, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3542, 5258, 11, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3543, 5254, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3544, 5254, 6, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3545, 5254, 19, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3546, 5253, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3547, 5253, 3, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3548, 5253, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3549, 5252, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3550, 5252, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3551, 5250, 28, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3552, 5249, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3553, 5249, 22, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3554, 5248, 27, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3555, 5247, 25, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3556, 5246, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3557, 5245, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3558, 5245, 20, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3559, 5244, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3560, 5244, 11, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3561, 5243, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3562, 5243, 23, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3563, 5242, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3564, 5242, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3565, 5241, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3566, 5240, 28, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3567, 5239, 29, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3568, 5238, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3569, 5238, 5, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3570, 5238, 12, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3571, 5237, 23, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3572, 5236, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3573, 5235, 16, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3574, 5235, 26, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3575, 5235, 28, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3576, 5234, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3577, 5234, 15, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3578, 5233, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3579, 5233, 7, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3580, 5233, 22, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3581, 5232, 16, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3582, 5231, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3583, 5231, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3584, 5230, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3585, 5229, 24, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3586, 5228, 26, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3587, 5227, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3588, 5226, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3589, 5226, 18, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3590, 5226, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3591, 5224, 23, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3592, 5223, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3593, 5223, 7, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3594, 5222, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3595, 5221, 23, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3596, 5219, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3597, 5217, 29, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3598, 5215, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3599, 5215, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3600, 5215, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3601, 5214, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3602, 5214, 6, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3603, 5214, 21, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3604, 5214, 24, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3605, 5214, 28, 5, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3606, 5213, 16, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3607, 5213, 26, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3608, 5212, 8, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3609, 5212, 10, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3610, 5211, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3611, 5211, 14, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3612, 5210, 14, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3613, 5210, 15, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3614, 5210, 16, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3615, 5209, 6, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3616, 5209, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3617, 5208, 11, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3618, 5207, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3619, 5205, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3620, 5205, 28, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3621, 5204, 13, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3622, 5203, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3623, 5202, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3624, 5202, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3625, 5199, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3626, 5198, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3627, 5197, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3628, 5197, 5, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3629, 5197, 10, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3630, 5195, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3631, 5193, 22, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3632, 5191, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3633, 5191, 14, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3634, 5191, 29, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3635, 5190, 21, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3636, 5190, 24, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3637, 5189, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3638, 5189, 2, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3639, 5189, 9, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3640, 5189, 16, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3641, 5188, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3642, 5185, 14, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3643, 5185, 19, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3644, 5184, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3645, 5183, 21, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3646, 5182, 19, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3647, 5181, 25, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3648, 5180, 24, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3649, 5180, 27, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3650, 5179, 8, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3651, 5179, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3652, 5179, 27, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3653, 5178, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3654, 5178, 28, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3655, 5176, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3656, 5175, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3657, 5174, 19, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3658, 5174, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3659, 5173, 1, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3660, 5173, 2, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3661, 5173, 18, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3662, 5172, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3663, 5172, 19, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3664, 5172, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3665, 5170, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3666, 5170, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3667, 5169, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3668, 5169, 3, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3669, 5169, 7, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3670, 5169, 12, 4, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3671, 5169, 19, 5, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3672, 5168, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3673, 5167, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3674, 5167, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3675, 5167, 22, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3676, 5166, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3677, 5166, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3678, 5163, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3679, 5163, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3680, 5162, 24, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3681, 5162, 25, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3682, 5160, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3683, 5160, 18, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3684, 5159, 23, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3685, 5159, 25, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3686, 5158, 11, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3687, 5155, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3688, 5153, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3689, 5153, 17, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3690, 5152, 28, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3691, 5150, 24, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3692, 5149, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3693, 5149, 10, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3694, 5149, 11, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3695, 5148, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3696, 5148, 17, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3697, 5148, 22, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3698, 5148, 28, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3699, 5145, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3700, 5145, 21, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3701, 5144, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3702, 5143, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3703, 5143, 19, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3704, 5142, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3705, 5141, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3706, 5141, 12, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3707, 5140, 18, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3708, 5140, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3709, 5139, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3710, 5139, 27, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3711, 5139, 28, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3712, 5137, 15, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3713, 5137, 29, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3714, 5136, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3715, 5136, 8, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3716, 5136, 29, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3717, 5135, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3718, 5135, 23, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3719, 5134, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3720, 5133, 29, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3721, 5132, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3722, 5131, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3723, 5130, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3724, 5130, 28, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3725, 5129, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3726, 5128, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3727, 5124, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3728, 5123, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3729, 5123, 16, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3730, 5123, 26, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3731, 5121, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3732, 5120, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3733, 5120, 16, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3734, 5120, 28, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3735, 5119, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3736, 5118, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3737, 5118, 29, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3738, 5117, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3739, 5117, 11, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3740, 5116, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3741, 5115, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3742, 5114, 1, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3743, 5114, 18, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3744, 5113, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3745, 5113, 24, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3746, 5113, 26, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3747, 5112, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3748, 5112, 21, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3749, 5112, 27, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3750, 5110, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3751, 5110, 24, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3752, 5109, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3753, 5109, 5, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3754, 5108, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3755, 5108, 10, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3756, 5108, 22, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3757, 5107, 14, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3758, 5106, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3759, 5106, 11, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3760, 5105, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3761, 5099, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3762, 5099, 7, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3763, 5098, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3764, 5098, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3765, 5097, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3766, 5097, 15, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3767, 5096, 16, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3768, 5096, 24, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3769, 5096, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3770, 5095, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3771, 5095, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3772, 5093, 15, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3773, 5093, 18, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3774, 5092, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3775, 5092, 12, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3776, 5091, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3777, 5091, 8, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3778, 5091, 15, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3779, 5091, 17, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3780, 5089, 29, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3781, 5088, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3782, 5086, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3783, 5086, 22, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3784, 5085, 22, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3785, 5085, 28, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3786, 5084, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3787, 5084, 20, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3788, 5084, 22, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3789, 5083, 26, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3790, 5080, 1, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3791, 5079, 11, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3792, 5079, 13, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3793, 5079, 21, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3794, 5079, 28, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3795, 5078, 17, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3796, 5078, 18, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3797, 5078, 22, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3798, 5077, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3799, 5077, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3800, 5076, 10, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3801, 5075, 29, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3802, 5074, 22, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3803, 5073, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3804, 5073, 11, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3805, 5072, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3806, 5072, 20, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3807, 5072, 21, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3808, 5071, 27, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3809, 5069, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3810, 5069, 20, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3811, 5067, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3812, 5066, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3813, 5066, 27, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3814, 5065, 20, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3815, 5064, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3816, 5064, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3817, 5063, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3818, 5063, 12, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3819, 5062, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3820, 5058, 8, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3821, 5058, 21, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3822, 5058, 22, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3823, 5058, 27, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3824, 5057, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3825, 5055, 13, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3826, 5053, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3827, 5051, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3828, 5051, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3829, 5051, 23, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3830, 5049, 11, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3831, 5049, 24, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3832, 5049, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3833, 5048, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3834, 5048, 5, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3835, 5048, 16, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3836, 5047, 23, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3837, 5046, 21, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3838, 5045, 10, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3839, 5044, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3840, 5043, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3841, 5043, 25, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3842, 5041, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3843, 5041, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3844, 5041, 24, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3845, 5041, 26, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3846, 5041, 28, 5, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3847, 5040, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3848, 5039, 19, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3849, 5038, 12, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3850, 5038, 13, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3851, 5038, 23, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3852, 5038, 24, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3853, 5037, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3854, 5036, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3855, 5036, 18, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3856, 5036, 22, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3857, 5035, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3858, 5035, 22, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3859, 5035, 23, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3860, 5035, 26, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3861, 5034, 29, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3862, 5032, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3863, 5032, 23, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3864, 5032, 26, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3865, 5032, 27, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3866, 5030, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3867, 5030, 18, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3868, 5029, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3869, 5029, 29, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3870, 5028, 18, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3871, 5027, 29, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3872, 5026, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3873, 5026, 20, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3874, 5025, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3875, 5024, 12, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3876, 5024, 29, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3877, 5022, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3878, 5021, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3879, 5021, 10, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3880, 5021, 18, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3881, 5020, 19, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3882, 5020, 20, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3883, 5019, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3884, 5017, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3885, 5017, 7, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3886, 5017, 24, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3887, 5017, 29, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3888, 5016, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3889, 5016, 12, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3890, 5016, 27, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3891, 5015, 22, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3892, 5013, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3893, 5013, 23, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3894, 5012, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3895, 5012, 26, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3896, 5011, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3897, 5010, 5, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3898, 5010, 14, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3899, 5010, 22, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3900, 5009, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3901, 5006, 26, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3902, 5004, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3903, 5003, 12, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3904, 5003, 17, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3905, 5001, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3906, 5001, 17, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3907, 5000, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3908, 4999, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3909, 4999, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3910, 4998, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3911, 4998, 17, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3912, 4998, 18, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3913, 4996, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3914, 4995, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3915, 4995, 23, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3916, 4994, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3917, 4994, 10, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3918, 4991, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3919, 4989, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3920, 4989, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3921, 4989, 27, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3922, 4988, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3923, 4988, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3924, 4987, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3925, 4983, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3926, 4983, 26, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3927, 4981, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3928, 4980, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3929, 4980, 27, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3930, 4978, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3931, 4976, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3932, 4974, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3933, 4973, 29, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3934, 4971, 17, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3935, 4971, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3936, 4970, 29, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3937, 4968, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3938, 4968, 18, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3939, 4968, 19, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3940, 4968, 20, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3941, 4968, 24, 5, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3942, 4967, 17, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3943, 4966, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3944, 4966, 25, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3945, 4966, 26, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3946, 4964, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3947, 4964, 29, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3948, 4963, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3949, 4962, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3950, 4961, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3951, 4961, 11, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3952, 4960, 17, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3953, 4960, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3954, 4959, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3955, 4958, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3956, 4958, 4, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3957, 4958, 17, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3958, 4957, 25, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3959, 4956, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3960, 4955, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3961, 4954, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3962, 4954, 10, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3963, 4954, 19, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3964, 4953, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3965, 4952, 8, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3966, 4952, 20, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3967, 4952, 23, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3968, 4951, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3969, 4951, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3970, 4951, 29, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3971, 4950, 5, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3972, 4950, 7, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3973, 4950, 8, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3974, 4950, 15, 4, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3975, 4950, 26, 5, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3976, 4949, 17, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3977, 4949, 24, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3978, 4948, 29, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3979, 4946, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3980, 4945, 25, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3981, 4944, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3982, 4944, 26, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3983, 4943, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3984, 4941, 5, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3985, 4941, 7, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3986, 4941, 15, 3, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3987, 4939, 8, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3988, 4939, 20, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3989, 4938, 18, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3990, 4938, 27, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3991, 4937, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3992, 4937, 28, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3993, 4936, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3994, 4936, 9, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3995, 4936, 10, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3996, 4936, 11, 4, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3997, 4936, 15, 5, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3998, 4936, 23, 6, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (3999, 4934, 21, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4000, 4934, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4001, 4933, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4002, 4933, 13, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4003, 4933, 24, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4004, 4933, 27, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4005, 4932, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4006, 4931, 23, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4007, 4926, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4008, 4925, 29, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4009, 4923, 16, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4010, 4922, 22, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4011, 4921, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4012, 4921, 13, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4013, 4921, 14, 3, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4014, 4921, 18, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4015, 4920, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4016, 4920, 10, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4017, 4918, 18, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4018, 4917, 21, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4019, 4915, 15, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4020, 4915, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4021, 4914, 10, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4022, 4914, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4023, 4912, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4024, 4912, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4025, 4911, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4026, 4911, 15, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4027, 4910, 16, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4028, 4909, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4029, 4909, 10, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4030, 4909, 20, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4031, 4908, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4032, 4908, 16, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4033, 4907, 15, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4034, 4907, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4035, 4907, 20, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4036, 4907, 21, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4037, 4906, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4038, 4906, 15, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4039, 4906, 24, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4040, 4904, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4041, 4903, 12, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4042, 4902, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4043, 4902, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4044, 4901, 29, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4045, 4900, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4046, 4899, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4047, 4899, 12, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4048, 4899, 15, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4049, 4899, 28, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4050, 4898, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4051, 4898, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4052, 4898, 22, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4053, 4898, 24, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4054, 4896, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4055, 4896, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4056, 4896, 23, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4057, 4895, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4058, 4895, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4059, 4895, 27, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4060, 4894, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4061, 4893, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4062, 4892, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4063, 4892, 16, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4064, 4892, 17, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4065, 4891, 23, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4066, 4891, 28, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4067, 4890, 25, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4068, 4889, 14, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4069, 4888, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4070, 4888, 19, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4071, 4887, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4072, 4886, 24, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4073, 4884, 19, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4074, 4884, 29, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4075, 4882, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4076, 4882, 20, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4077, 4881, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4078, 4881, 14, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4079, 4879, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4080, 4879, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4081, 4879, 19, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4082, 4878, 18, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4083, 4875, 21, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4084, 4874, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4085, 4874, 17, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4086, 4870, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4087, 4870, 18, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4088, 4869, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4089, 4867, 21, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4090, 4866, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4091, 4866, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4092, 4866, 19, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4093, 4865, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4094, 4865, 20, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4095, 4865, 21, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4096, 4864, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4097, 4864, 28, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4098, 4862, 18, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4099, 4859, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4100, 4857, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4101, 4857, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4102, 4856, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4103, 4855, 8, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4104, 4855, 13, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4105, 4853, 5, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4106, 4852, 3, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4107, 4852, 4, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4108, 4852, 6, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4109, 4852, 25, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4110, 4851, 29, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4111, 4850, 25, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4112, 4849, 25, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4113, 4847, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4114, 4847, 28, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4115, 4845, 28, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4116, 4844, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4117, 4844, 23, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4118, 4843, 14, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4119, 4843, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4120, 4842, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4121, 4841, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4122, 4840, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4123, 4839, 18, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4124, 4838, 13, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4125, 4838, 28, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4126, 4837, 12, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4127, 4837, 16, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4128, 4837, 27, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4129, 4836, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4130, 4835, 10, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4131, 4834, 1, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4132, 4833, 18, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4133, 4832, 18, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4134, 4831, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4135, 4831, 21, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4136, 4831, 22, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4137, 4831, 27, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4138, 4829, 23, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4139, 4828, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4140, 4828, 7, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4141, 4827, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4142, 4826, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4143, 4825, 21, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4144, 4825, 24, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4145, 4824, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4146, 4823, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4147, 4823, 25, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4148, 4822, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4149, 4822, 11, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4150, 4822, 12, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4151, 4822, 26, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4152, 4821, 27, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4153, 4819, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4154, 4819, 29, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4155, 4818, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4156, 4818, 10, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4157, 4817, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4158, 4816, 26, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4159, 4815, 24, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4160, 4815, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4161, 4814, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4162, 4814, 7, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4163, 4813, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4164, 4813, 5, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4165, 4813, 14, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4166, 4813, 24, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4167, 4810, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4168, 4810, 8, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4169, 4810, 18, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4170, 4809, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4171, 4809, 27, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4172, 4808, 21, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4173, 4805, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4174, 4803, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4175, 4801, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4176, 4801, 12, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4177, 4800, 13, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4178, 4800, 15, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4179, 4800, 24, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4180, 4798, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4181, 4798, 21, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4182, 4798, 24, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4183, 4797, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4184, 4796, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4185, 4796, 29, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4186, 4794, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4187, 4794, 27, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4188, 4793, 23, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4189, 4792, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4190, 4792, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4191, 4791, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4192, 4791, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4193, 4791, 27, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4194, 4790, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4195, 4788, 21, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4196, 4787, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4197, 4786, 16, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4198, 4785, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4199, 4785, 3, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4200, 4785, 15, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4201, 4784, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4202, 4784, 24, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4203, 4783, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4204, 4783, 11, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4205, 4783, 21, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4206, 4783, 28, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4207, 4781, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4208, 4780, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4209, 4779, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4210, 4779, 18, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4211, 4776, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4212, 4776, 7, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4213, 4773, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4214, 4773, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4215, 4773, 28, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4216, 4772, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4217, 4772, 22, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4218, 4771, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4219, 4771, 28, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4220, 4770, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4221, 4770, 12, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4222, 4769, 25, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4223, 4767, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4224, 4767, 5, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4225, 4767, 7, 3, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4226, 4767, 13, 4, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4227, 4766, 18, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4228, 4764, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4229, 4762, 14, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4230, 4762, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4231, 4760, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4232, 4759, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4233, 4759, 29, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4234, 4758, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4235, 4758, 8, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4236, 4757, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4237, 4757, 19, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4238, 4757, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4239, 4756, 5, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4240, 4756, 10, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4241, 4756, 11, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4242, 4756, 19, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4243, 4755, 18, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4244, 4755, 29, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4245, 4754, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4246, 4754, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4247, 4754, 21, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4248, 4753, 28, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4249, 4752, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4250, 4750, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4251, 4750, 20, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4252, 4750, 29, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4253, 4749, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4254, 4749, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4255, 4748, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4256, 4748, 5, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4257, 4746, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4258, 4745, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4259, 4745, 10, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4260, 4745, 24, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4261, 4744, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4262, 4744, 29, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4263, 4743, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4264, 4741, 16, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4265, 4740, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4266, 4737, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4267, 4737, 7, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4268, 4737, 20, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4269, 4734, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4270, 4733, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4271, 4733, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4272, 4733, 9, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4273, 4731, 16, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4274, 4731, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4275, 4729, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4276, 4729, 14, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4277, 4728, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4278, 4728, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4279, 4728, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4280, 4727, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4281, 4726, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4282, 4725, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4283, 4725, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4284, 4724, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4285, 4722, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4286, 4722, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4287, 4722, 11, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4288, 4720, 26, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4289, 4720, 29, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4290, 4719, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4291, 4719, 7, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4292, 4718, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4293, 4718, 19, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4294, 4717, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4295, 4715, 21, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4296, 4715, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4297, 4715, 25, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4298, 4714, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4299, 4712, 16, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4300, 4712, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4301, 4712, 27, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4302, 4711, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4303, 4711, 13, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4304, 4710, 19, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4305, 4709, 23, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4306, 4708, 22, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4307, 4707, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4308, 4707, 10, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4309, 4707, 16, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4310, 4704, 23, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4311, 4703, 19, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4312, 4702, 15, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4313, 4702, 24, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4314, 4701, 10, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4315, 4701, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4316, 4701, 27, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4317, 4698, 27, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4318, 4697, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4319, 4697, 12, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4320, 4697, 21, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4321, 4694, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4322, 4694, 10, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4323, 4694, 18, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4324, 4693, 13, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4325, 4693, 18, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4326, 4693, 23, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4327, 4691, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4328, 4691, 20, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4329, 4689, 11, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4330, 4689, 21, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4331, 4689, 25, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4332, 4689, 28, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4333, 4688, 23, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4334, 4684, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4335, 4684, 12, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4336, 4682, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4337, 4682, 7, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4338, 4682, 24, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4339, 4682, 25, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4340, 4682, 27, 5, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4341, 4681, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4342, 4681, 19, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4343, 4681, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4344, 4679, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4345, 4679, 12, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4346, 4679, 13, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4347, 4679, 19, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4348, 4677, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4349, 4676, 17, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4350, 4675, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4351, 4675, 5, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4352, 4675, 11, 3, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4353, 4674, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4354, 4674, 17, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4355, 4673, 16, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4356, 4673, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4357, 4672, 9, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4358, 4672, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4359, 4671, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4360, 4670, 22, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4361, 4668, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4362, 4668, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4363, 4668, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4364, 4668, 29, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4365, 4667, 11, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4366, 4667, 19, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4367, 4666, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4368, 4666, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4369, 4666, 26, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4370, 4664, 12, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4371, 4663, 16, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4372, 4662, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4373, 4661, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4374, 4660, 9, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4375, 4658, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4376, 4658, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4377, 4657, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4378, 4657, 28, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4379, 4656, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4380, 4656, 16, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4381, 4655, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4382, 4655, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4383, 4655, 26, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4384, 4654, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4385, 4654, 12, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4386, 4654, 23, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4387, 4653, 21, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4388, 4653, 22, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4389, 4652, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4390, 4651, 20, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4391, 4650, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4392, 4649, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4393, 4648, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4394, 4647, 21, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4395, 4646, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4396, 4646, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4397, 4646, 17, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4398, 4646, 20, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4399, 4645, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4400, 4644, 13, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4401, 4643, 19, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4402, 4643, 25, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4403, 4643, 27, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4404, 4642, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4405, 4642, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4406, 4642, 18, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4407, 4642, 19, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4408, 4641, 29, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4409, 4640, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4410, 4640, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4411, 4640, 10, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4412, 4640, 27, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4413, 4639, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4414, 4638, 3, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4415, 4638, 24, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4416, 4637, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4417, 4635, 10, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4418, 4635, 14, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4419, 4633, 8, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4420, 4633, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4421, 4630, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4422, 4629, 16, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4423, 4626, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4424, 4626, 20, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4425, 4625, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4426, 4625, 11, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4427, 4624, 21, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4428, 4623, 13, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4429, 4620, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4430, 4620, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4431, 4620, 19, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4432, 4620, 23, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4433, 4619, 14, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4434, 4619, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4435, 4619, 26, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4436, 4615, 16, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4437, 4614, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4438, 4614, 5, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4439, 4614, 14, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4440, 4613, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4441, 4612, 22, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4442, 4612, 28, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4443, 4610, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4444, 4609, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4445, 4608, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4446, 4608, 26, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4447, 4607, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4448, 4605, 8, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4449, 4605, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4450, 4605, 21, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4451, 4604, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4452, 4604, 17, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4453, 4604, 27, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4454, 4603, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4455, 4601, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4456, 4601, 20, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4457, 4601, 28, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4458, 4600, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4459, 4600, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4460, 4598, 13, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4461, 4598, 17, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4462, 4597, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4463, 4597, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4464, 4597, 22, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4465, 4596, 20, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4466, 4593, 26, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4467, 4593, 27, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4468, 4593, 29, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4469, 4592, 10, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4470, 4591, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4471, 4590, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4472, 4590, 6, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4473, 4589, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4474, 4589, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4475, 4588, 27, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4476, 4587, 12, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4477, 4587, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4478, 4587, 27, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4479, 4586, 9, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4480, 4585, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4481, 4585, 7, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4482, 4585, 15, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4483, 4585, 21, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4484, 4583, 16, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4485, 4583, 27, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4486, 4582, 26, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4487, 4581, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4488, 4581, 12, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4489, 4581, 23, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4490, 4580, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4491, 4579, 26, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4492, 4579, 27, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4493, 4578, 8, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4494, 4578, 9, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4495, 4578, 22, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4496, 4577, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4497, 4577, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4498, 4574, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4499, 4574, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4500, 4573, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4501, 4573, 15, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4502, 4572, 24, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4503, 4571, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4504, 4571, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4505, 4570, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4506, 4570, 10, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4507, 4570, 20, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4508, 4570, 25, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4509, 4569, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4510, 4566, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4511, 4565, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4512, 4565, 25, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4513, 4564, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4514, 4563, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4515, 4563, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4516, 4563, 20, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4517, 4563, 24, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4518, 4563, 25, 5, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4519, 4562, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4520, 4561, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4521, 4561, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4522, 4560, 20, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4523, 4558, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4524, 4558, 7, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4525, 4558, 12, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4526, 4558, 13, 4, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4527, 4556, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4528, 4556, 19, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4529, 4555, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4530, 4554, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4531, 4553, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4532, 4551, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4533, 4551, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4534, 4550, 16, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4535, 4549, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4536, 4549, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4537, 4547, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4538, 4547, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4539, 4547, 28, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4540, 4546, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4541, 4546, 18, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4542, 4546, 20, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4543, 4540, 12, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4544, 4538, 8, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4545, 4537, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4546, 4537, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4547, 4537, 21, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4548, 4535, 28, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4549, 4534, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4550, 4534, 15, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4551, 4534, 26, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4552, 4534, 27, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4553, 4531, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4554, 4531, 11, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4555, 4530, 15, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4556, 4530, 17, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4557, 4529, 19, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4558, 4526, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4559, 4526, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4560, 4526, 25, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4561, 4525, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4562, 4525, 11, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4563, 4525, 18, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4564, 4524, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4565, 4523, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4566, 4522, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4567, 4522, 15, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4568, 4520, 13, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4569, 4519, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4570, 4519, 19, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4571, 4518, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4572, 4517, 13, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4573, 4517, 17, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4574, 4516, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4575, 4516, 25, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4576, 4514, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4577, 4514, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4578, 4513, 23, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4579, 4512, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4580, 4512, 24, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4581, 4510, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4582, 4508, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4583, 4507, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4584, 4507, 18, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4585, 4507, 24, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4586, 4506, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4587, 4504, 10, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4588, 4504, 19, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4589, 4503, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4590, 4503, 4, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4591, 4503, 18, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4592, 4500, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4593, 4500, 15, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4594, 4500, 27, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4595, 4499, 18, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4596, 4498, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4597, 4497, 17, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4598, 4497, 23, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4599, 4496, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4600, 4496, 24, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4601, 4496, 25, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4602, 4495, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4603, 4495, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4604, 4494, 14, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4605, 4494, 23, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4606, 4494, 25, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4607, 4493, 14, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4608, 4493, 16, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4609, 4492, 22, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4610, 4491, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4611, 4491, 25, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4612, 4488, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4613, 4488, 23, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4614, 4487, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4615, 4487, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4616, 4487, 28, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4617, 4484, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4618, 4484, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4619, 4484, 25, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4620, 4483, 11, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4621, 4482, 12, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4622, 4482, 17, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4623, 4482, 22, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4624, 4482, 25, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4625, 4482, 28, 5, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4626, 4481, 23, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4627, 4480, 13, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4628, 4480, 15, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4629, 4480, 28, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4630, 4479, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4631, 4477, 19, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4632, 4474, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4633, 4474, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4634, 4474, 27, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4635, 4473, 15, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4636, 4473, 17, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4637, 4473, 27, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4638, 4471, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4639, 4471, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4640, 4470, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4641, 4470, 26, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4642, 4469, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4643, 4469, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4644, 4468, 14, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4645, 4467, 19, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4646, 4466, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4647, 4465, 19, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4648, 4463, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4649, 4463, 8, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4650, 4462, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4651, 4461, 25, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4652, 4460, 26, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4653, 4459, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4654, 4459, 17, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4655, 4459, 29, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4656, 4458, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4657, 4458, 11, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4658, 4457, 23, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4659, 4456, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4660, 4455, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4661, 4455, 10, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4662, 4454, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4663, 4453, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4664, 4451, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4665, 4450, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4666, 4449, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4667, 4449, 8, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4668, 4449, 27, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4669, 4447, 9, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4670, 4447, 16, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4671, 4446, 24, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4672, 4445, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4673, 4445, 21, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4674, 4445, 22, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4675, 4444, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4676, 4442, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4677, 4442, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4678, 4442, 29, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4679, 4441, 22, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4680, 4439, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4681, 4438, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4682, 4438, 6, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4683, 4437, 12, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4684, 4436, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4685, 4436, 5, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4686, 4436, 13, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4687, 4436, 16, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4688, 4435, 6, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4689, 4433, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4690, 4431, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4691, 4431, 29, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4692, 4430, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4693, 4430, 12, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4694, 4429, 8, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4695, 4426, 24, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4696, 4425, 11, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4697, 4425, 18, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4698, 4423, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4699, 4423, 7, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4700, 4423, 11, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4701, 4423, 12, 4, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4702, 4422, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4703, 4421, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4704, 4421, 21, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4705, 4421, 24, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4706, 4420, 26, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4707, 4420, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4708, 4419, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4709, 4419, 11, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4710, 4419, 12, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4711, 4419, 28, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4712, 4417, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4713, 4416, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4714, 4416, 14, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4715, 4416, 27, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4716, 4415, 22, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4717, 4414, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4718, 4414, 16, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4719, 4413, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4720, 4413, 23, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4721, 4412, 19, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4722, 4412, 23, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4723, 4410, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4724, 4409, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4725, 4409, 21, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4726, 4409, 27, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4727, 4408, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4728, 4408, 27, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4729, 4407, 16, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4730, 4406, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4731, 4406, 12, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4732, 4405, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4733, 4405, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4734, 4404, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4735, 4403, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4736, 4403, 4, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4737, 4402, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4738, 4401, 13, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4739, 4400, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4740, 4398, 21, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4741, 4397, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4742, 4397, 19, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4743, 4396, 23, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4744, 4395, 12, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4745, 4394, 21, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4746, 4392, 24, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4747, 4391, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4748, 4391, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4749, 4389, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4750, 4389, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4751, 4387, 11, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4752, 4387, 25, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4753, 4386, 28, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4754, 4385, 14, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4755, 4384, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4756, 4381, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4757, 4380, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4758, 4380, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4759, 4379, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4760, 4379, 24, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4761, 4378, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4762, 4376, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4763, 4376, 17, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4764, 4374, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4765, 4374, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4766, 4374, 22, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4767, 4374, 24, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4768, 4372, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4769, 4371, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4770, 4370, 24, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4771, 4370, 25, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4772, 4369, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4773, 4369, 9, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4774, 4366, 20, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4775, 4365, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4776, 4364, 19, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4777, 4363, 14, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4778, 4362, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4779, 4361, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4780, 4358, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4781, 4358, 7, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4782, 4358, 25, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4783, 4357, 8, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4784, 4355, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4785, 4354, 29, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4786, 4353, 6, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4787, 4353, 17, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4788, 4351, 15, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4789, 4351, 21, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4790, 4349, 14, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4791, 4348, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4792, 4347, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4793, 4347, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4794, 4347, 10, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4795, 4347, 23, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4796, 4346, 25, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4797, 4342, 5, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4798, 4341, 5, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4799, 4341, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4800, 4340, 26, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4801, 4339, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4802, 4338, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4803, 4337, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4804, 4337, 22, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4805, 4337, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4806, 4336, 23, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4807, 4335, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4808, 4335, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4809, 4334, 27, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4810, 4333, 20, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4811, 4331, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4812, 4331, 21, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4813, 4330, 16, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4814, 4330, 26, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4815, 4329, 18, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4816, 4329, 29, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4817, 4328, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4818, 4328, 25, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4819, 4327, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4820, 4326, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4821, 4326, 12, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4822, 4325, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4823, 4324, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4824, 4323, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4825, 4323, 6, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4826, 4323, 8, 3, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4827, 4323, 10, 4, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4828, 4323, 27, 5, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4829, 4322, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4830, 4322, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4831, 4322, 25, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4832, 4322, 27, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4833, 4321, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4834, 4321, 5, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4835, 4321, 7, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4836, 4321, 8, 4, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4837, 4320, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4838, 4319, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4839, 4318, 10, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4840, 4317, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4841, 4316, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4842, 4316, 17, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4843, 4315, 21, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4844, 4314, 15, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4845, 4313, 28, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4846, 4312, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4847, 4312, 15, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4848, 4311, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4849, 4311, 21, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4850, 4311, 26, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4851, 4310, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4852, 4310, 20, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4853, 4310, 21, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4854, 4304, 9, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4855, 4304, 20, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4856, 4303, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4857, 4303, 5, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4858, 4303, 12, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4859, 4302, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4860, 4302, 9, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4861, 4302, 14, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4862, 4301, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4863, 4301, 25, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4864, 4300, 16, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4865, 4298, 11, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4866, 4297, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4867, 4296, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4868, 4294, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4869, 4294, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4870, 4293, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4871, 4293, 14, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4872, 4293, 27, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4873, 4292, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4874, 4291, 16, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4875, 4290, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4876, 4290, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4877, 4290, 26, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4878, 4290, 27, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4879, 4289, 17, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4880, 4288, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4881, 4288, 19, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4882, 4285, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4883, 4284, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4884, 4283, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4885, 4283, 11, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4886, 4282, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4887, 4282, 23, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4888, 4281, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4889, 4281, 28, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4890, 4280, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4891, 4279, 20, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4892, 4278, 14, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4893, 4277, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4894, 4276, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4895, 4273, 9, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4896, 4273, 22, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4897, 4271, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4898, 4271, 27, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4899, 4270, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4900, 4269, 18, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4901, 4268, 3, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4902, 4268, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4903, 4266, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4904, 4266, 7, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4905, 4266, 18, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4906, 4264, 20, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4907, 4263, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4908, 4263, 29, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4909, 4262, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4910, 4262, 15, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4911, 4261, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4912, 4260, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4913, 4260, 21, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4914, 4258, 14, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4915, 4257, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4916, 4256, 12, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4917, 4256, 19, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4918, 4256, 20, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4919, 4256, 21, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4920, 4255, 19, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4921, 4254, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4922, 4254, 9, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4923, 4254, 25, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4924, 4254, 27, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4925, 4253, 15, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4926, 4252, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4927, 4251, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4928, 4251, 9, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4929, 4251, 10, 3, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4930, 4251, 16, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4931, 4250, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4932, 4249, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4933, 4249, 9, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4934, 4248, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4935, 4248, 5, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4936, 4248, 16, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4937, 4247, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4938, 4247, 11, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4939, 4247, 17, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4940, 4246, 25, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4941, 4246, 29, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4942, 4245, 29, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4943, 4244, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4944, 4244, 23, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4945, 4241, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4946, 4240, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4947, 4240, 22, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4948, 4238, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4949, 4238, 20, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4950, 4237, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4951, 4237, 19, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4952, 4236, 15, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4953, 4236, 25, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4954, 4235, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4955, 4234, 27, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4956, 4232, 18, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4957, 4230, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4958, 4230, 3, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4959, 4230, 5, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4960, 4230, 12, 4, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4961, 4229, 13, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4962, 4229, 21, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4963, 4229, 27, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4964, 4228, 26, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4965, 4224, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4966, 4223, 13, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4967, 4222, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4968, 4222, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4969, 4222, 19, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4970, 4222, 24, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4971, 4221, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4972, 4221, 9, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4973, 4221, 15, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4974, 4221, 21, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4975, 4220, 21, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4976, 4220, 27, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4977, 4219, 19, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4978, 4217, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4979, 4216, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4980, 4216, 19, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4981, 4215, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4982, 4214, 23, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4983, 4213, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4984, 4213, 13, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4985, 4213, 23, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4986, 4213, 29, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4987, 4212, 24, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4988, 4211, 16, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4989, 4211, 19, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4990, 4210, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4991, 4210, 25, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4992, 4208, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4993, 4207, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4994, 4207, 11, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4995, 4207, 13, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4996, 4206, 16, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4997, 4206, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4998, 4205, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (4999, 4204, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5000, 4203, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5001, 4203, 21, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5002, 4202, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5003, 4200, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5004, 4200, 13, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5005, 4200, 19, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5006, 4199, 10, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5007, 4199, 14, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5008, 4199, 15, 3, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5009, 4197, 19, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5010, 4196, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5011, 4195, 16, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5012, 4195, 21, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5013, 4193, 18, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5014, 4192, 8, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5015, 4192, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5016, 4191, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5017, 4191, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5018, 4191, 23, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5019, 4188, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5020, 4188, 12, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5021, 4187, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5022, 4187, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5023, 4187, 27, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5024, 4184, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5025, 4184, 28, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5026, 4183, 23, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5027, 4181, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5028, 4181, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5029, 4180, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5030, 4180, 12, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5031, 4180, 26, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5032, 4179, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5033, 4179, 9, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5034, 4178, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5035, 4178, 6, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5036, 4178, 16, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5037, 4178, 21, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5038, 4177, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5039, 4177, 13, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5040, 4176, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5041, 4175, 8, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5042, 4175, 16, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5043, 4174, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5044, 4174, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5045, 4174, 29, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5046, 4173, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5047, 4173, 17, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5048, 4171, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5049, 4171, 17, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5050, 4171, 22, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5051, 4169, 20, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5052, 4168, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5053, 4167, 20, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5054, 4167, 29, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5055, 4164, 21, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5056, 4163, 29, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5057, 4161, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5058, 4161, 12, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5059, 4160, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5060, 4160, 10, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5061, 4160, 19, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5062, 4157, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5063, 4157, 23, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5064, 4156, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5065, 4154, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5066, 4154, 6, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5067, 4154, 12, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5068, 4154, 15, 4, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5069, 4154, 17, 5, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5070, 4152, 11, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5071, 4152, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5072, 4150, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5073, 4149, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5074, 4148, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5075, 4146, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5076, 4146, 12, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5077, 4146, 16, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5078, 4143, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5079, 4142, 29, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5080, 4141, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5081, 4141, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5082, 4140, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5083, 4138, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5084, 4138, 5, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5085, 4138, 18, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5086, 4137, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5087, 4137, 26, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5088, 4136, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5089, 4136, 11, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5090, 4136, 29, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5091, 4135, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5092, 4135, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5093, 4133, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5094, 4133, 10, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5095, 4130, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5096, 4130, 20, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5097, 4130, 22, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5098, 4130, 25, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5099, 4130, 26, 5, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5100, 4129, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5101, 4129, 25, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5102, 4127, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5103, 4127, 9, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5104, 4127, 21, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5105, 4126, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5106, 4126, 18, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5107, 4126, 27, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5108, 4124, 18, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5109, 4121, 11, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5110, 4121, 28, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5111, 4120, 18, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5112, 4120, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5113, 4120, 23, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5114, 4119, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5115, 4119, 12, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5116, 4118, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5117, 4117, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5118, 4117, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5119, 4116, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5120, 4115, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5121, 4114, 29, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5122, 4112, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5123, 4111, 10, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5124, 4111, 13, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5125, 4111, 23, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5126, 4110, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5127, 4110, 29, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5128, 4107, 19, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5129, 4107, 25, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5130, 4106, 21, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5131, 4104, 21, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5132, 4104, 27, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5133, 4103, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5134, 4102, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5135, 4102, 16, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5136, 4102, 18, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5137, 4101, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5138, 4100, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5139, 4100, 7, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5140, 4099, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5141, 4098, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5142, 4098, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5143, 4098, 14, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5144, 4096, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5145, 4096, 5, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5146, 4095, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5147, 4094, 24, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5148, 4093, 11, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5149, 4092, 21, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5150, 4091, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5151, 4090, 17, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5152, 4089, 28, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5153, 4088, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5154, 4088, 9, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5155, 4088, 19, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5156, 4087, 16, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5157, 4087, 23, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5158, 4086, 23, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5159, 4085, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5160, 4084, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5161, 4084, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5162, 4083, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5163, 4083, 22, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5164, 4082, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5165, 4082, 8, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5166, 4082, 12, 3, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5167, 4082, 16, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5168, 4082, 27, 5, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5169, 4081, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5170, 4081, 10, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5171, 4081, 11, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5172, 4081, 12, 4, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5173, 4081, 21, 5, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5174, 4081, 24, 6, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5175, 4080, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5176, 4079, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5177, 4079, 6, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5178, 4078, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5179, 4078, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5180, 4077, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5181, 4077, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5182, 4077, 21, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5183, 4077, 22, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5184, 4076, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5185, 4075, 9, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5186, 4075, 14, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5187, 4073, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5188, 4073, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5189, 4071, 17, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5190, 4070, 16, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5191, 4068, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5192, 4068, 12, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5193, 4066, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5194, 4066, 10, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5195, 4066, 22, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5196, 4064, 20, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5197, 4063, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5198, 4063, 14, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5199, 4063, 17, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5200, 4063, 25, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5201, 4060, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5202, 4060, 25, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5203, 4059, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5204, 4058, 29, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5205, 4057, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5206, 4057, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5207, 4056, 5, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5208, 4056, 27, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5209, 4056, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5210, 4055, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5211, 4055, 20, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5212, 4055, 23, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5213, 4054, 22, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5214, 4053, 22, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5215, 4051, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5216, 4051, 4, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5217, 4051, 8, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5218, 4049, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5219, 4048, 5, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5220, 4047, 24, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5221, 4045, 15, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5222, 4045, 20, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5223, 4045, 21, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5224, 4045, 25, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5225, 4045, 28, 5, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5226, 4041, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5227, 4040, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5228, 4039, 26, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5229, 4037, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5230, 4037, 12, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5231, 4037, 14, 3, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5232, 4037, 23, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5233, 4036, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5234, 4036, 20, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5235, 4036, 27, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5236, 4036, 29, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5237, 4034, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5238, 4034, 20, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5239, 4034, 25, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5240, 4033, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5241, 4029, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5242, 4029, 25, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5243, 4028, 20, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5244, 4027, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5245, 4026, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5246, 4026, 24, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5247, 4025, 24, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5248, 4025, 25, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5249, 4023, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5250, 4023, 4, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5251, 4023, 25, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5252, 4020, 24, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5253, 4019, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5254, 4019, 12, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5255, 4019, 21, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5256, 4018, 28, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5257, 4015, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5258, 4015, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5259, 4015, 28, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5260, 4014, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5261, 4014, 19, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5262, 4013, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5263, 4013, 27, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5264, 4012, 28, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5265, 4011, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5266, 4009, 27, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5267, 4008, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5268, 4008, 24, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5269, 4006, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5270, 4006, 25, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5271, 4005, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5272, 4005, 8, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5273, 4005, 26, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5274, 4004, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5275, 4004, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5276, 4003, 8, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5277, 4002, 14, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5278, 4000, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5279, 3999, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5280, 3999, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5281, 3998, 12, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5282, 3997, 28, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5283, 3996, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5284, 3995, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5285, 3995, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5286, 3993, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5287, 3992, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5288, 3992, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5289, 3992, 21, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5290, 3992, 22, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5291, 3990, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5292, 3989, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5293, 3988, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5294, 3988, 9, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5295, 3988, 16, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5296, 3988, 23, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5297, 3985, 14, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5298, 3981, 26, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5299, 3980, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5300, 3980, 23, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5301, 3979, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5302, 3979, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5303, 3979, 23, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5304, 3979, 29, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5305, 3978, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5306, 3978, 15, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5307, 3977, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5308, 3977, 25, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5309, 3976, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5310, 3975, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5311, 3975, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5312, 3975, 25, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5313, 3974, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5314, 3974, 9, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5315, 3974, 18, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5316, 3974, 20, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5317, 3974, 28, 5, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5318, 3973, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5319, 3971, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5320, 3970, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5321, 3970, 26, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5322, 3970, 29, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5323, 3969, 15, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5324, 3968, 16, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5325, 3967, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5326, 3967, 13, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5327, 3967, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5328, 3966, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5329, 3966, 3, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5330, 3965, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5331, 3965, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5332, 3965, 24, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5333, 3964, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5334, 3964, 11, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5335, 3964, 20, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5336, 3964, 28, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5337, 3963, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5338, 3963, 20, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5339, 3962, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5340, 3962, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5341, 3961, 16, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5342, 3961, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5343, 3960, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5344, 3959, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5345, 3958, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5346, 3957, 21, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5347, 3956, 27, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5348, 3955, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5349, 3955, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5350, 3954, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5351, 3954, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5352, 3954, 24, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5353, 3953, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5354, 3952, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5355, 3950, 27, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5356, 3949, 15, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5357, 3946, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5358, 3946, 15, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5359, 3945, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5360, 3945, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5361, 3944, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5362, 3944, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5363, 3943, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5364, 3942, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5365, 3942, 27, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5366, 3940, 28, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5367, 3939, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5368, 3939, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5369, 3938, 18, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5370, 3933, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5371, 3933, 15, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5372, 3933, 19, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5373, 3931, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5374, 3931, 4, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5375, 3930, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5376, 3930, 23, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5377, 3930, 25, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5378, 3930, 29, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5379, 3929, 26, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5380, 3928, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5381, 3927, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5382, 3925, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5383, 3924, 22, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5384, 3922, 12, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5385, 3922, 14, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5386, 3922, 22, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5387, 3921, 28, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5388, 3920, 10, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5389, 3920, 25, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5390, 3920, 26, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5391, 3918, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5392, 3918, 12, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5393, 3917, 13, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5394, 3915, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5395, 3915, 6, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5396, 3912, 17, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5397, 3911, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5398, 3911, 21, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5399, 3911, 28, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5400, 3910, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5401, 3910, 6, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5402, 3910, 9, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5403, 3909, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5404, 3909, 27, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5405, 3908, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5406, 3907, 19, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5407, 3906, 11, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5408, 3906, 13, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5409, 3906, 15, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5410, 3905, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5411, 3903, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5412, 3903, 15, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5413, 3902, 11, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5414, 3901, 17, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5415, 3900, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5416, 3900, 22, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5417, 3900, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5418, 3898, 12, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5419, 3898, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5420, 3895, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5421, 3894, 26, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5422, 3893, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5423, 3892, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5424, 3891, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5425, 3890, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5426, 3890, 9, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5427, 3890, 14, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5428, 3890, 22, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5429, 3890, 24, 5, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5430, 3889, 25, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5431, 3886, 16, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5432, 3886, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5433, 3886, 19, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5434, 3886, 20, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5435, 3885, 1, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5436, 3884, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5437, 3884, 28, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5438, 3883, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5439, 3883, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5440, 3882, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5441, 3882, 6, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5442, 3882, 11, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5443, 3882, 16, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5444, 3881, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5445, 3878, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5446, 3878, 19, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5447, 3876, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5448, 3875, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5449, 3875, 28, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5450, 3874, 28, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5451, 3873, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5452, 3873, 7, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5453, 3873, 20, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5454, 3872, 10, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5455, 3872, 19, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5456, 3870, 10, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5457, 3870, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5458, 3870, 21, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5459, 3870, 24, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5460, 3869, 24, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5461, 3869, 27, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5462, 3867, 14, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5463, 3867, 22, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5464, 3865, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5465, 3864, 8, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5466, 3864, 11, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5467, 3863, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5468, 3862, 26, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5469, 3861, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5470, 3861, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5471, 3860, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5472, 3860, 27, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5473, 3859, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5474, 3859, 17, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5475, 3858, 15, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5476, 3858, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5477, 3857, 8, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5478, 3856, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5479, 3854, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5480, 3854, 21, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5481, 3853, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5482, 3850, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5483, 3849, 21, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5484, 3848, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5485, 3848, 26, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5486, 3847, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5487, 3847, 18, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5488, 3846, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5489, 3846, 7, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5490, 3845, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5491, 3843, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5492, 3842, 12, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5493, 3842, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5494, 3842, 15, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5495, 3842, 21, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5496, 3841, 25, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5497, 3840, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5498, 3840, 10, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5499, 3838, 12, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5500, 3838, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5501, 3837, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5502, 3837, 29, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5503, 3835, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5504, 3834, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5505, 3834, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5506, 3833, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5507, 3833, 26, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5508, 3832, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5509, 3831, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5510, 3831, 13, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5511, 3830, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5512, 3830, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5513, 3829, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5514, 3828, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5515, 3828, 23, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5516, 3828, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5517, 3827, 23, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5518, 3826, 14, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5519, 3825, 22, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5520, 3824, 11, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5521, 3824, 23, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5522, 3823, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5523, 3819, 18, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5524, 3819, 20, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5525, 3819, 25, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5526, 3819, 28, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5527, 3815, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5528, 3815, 11, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5529, 3815, 15, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5530, 3815, 22, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5531, 3814, 17, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5532, 3812, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5533, 3810, 24, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5534, 3809, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5535, 3808, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5536, 3808, 18, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5537, 3807, 26, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5538, 3807, 28, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5539, 3806, 27, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5540, 3805, 21, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5541, 3804, 15, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5542, 3803, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5543, 3803, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5544, 3802, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5545, 3802, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5546, 3800, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5547, 3800, 11, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5548, 3800, 12, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5549, 3799, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5550, 3799, 16, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5551, 3799, 23, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5552, 3798, 25, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5553, 3796, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5554, 3795, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5555, 3794, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5556, 3794, 29, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5557, 3793, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5558, 3793, 3, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5559, 3793, 12, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5560, 3793, 28, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5561, 3790, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5562, 3789, 18, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5563, 3788, 18, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5564, 3787, 19, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5565, 3786, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5566, 3784, 11, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5567, 3784, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5568, 3784, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5569, 3783, 26, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5570, 3781, 5, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5571, 3781, 14, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5572, 3781, 19, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5573, 3781, 22, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5574, 3780, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5575, 3779, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5576, 3779, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5577, 3778, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5578, 3778, 6, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5579, 3778, 21, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5580, 3778, 23, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5581, 3778, 25, 5, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5582, 3776, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5583, 3775, 18, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5584, 3775, 23, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5585, 3775, 24, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5586, 3775, 25, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5587, 3774, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5588, 3773, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5589, 3773, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5590, 3772, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5591, 3772, 28, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5592, 3771, 26, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5593, 3770, 12, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5594, 3770, 13, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5595, 3769, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5596, 3766, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5597, 3765, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5598, 3765, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5599, 3764, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5600, 3764, 23, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5601, 3763, 9, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5602, 3763, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5603, 3761, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5604, 3760, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5605, 3758, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5606, 3758, 25, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5607, 3756, 11, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5608, 3756, 12, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5609, 3756, 18, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5610, 3755, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5611, 3755, 11, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5612, 3755, 24, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5613, 3754, 25, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5614, 3753, 28, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5615, 3752, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5616, 3752, 16, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5617, 3751, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5618, 3751, 13, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5619, 3751, 27, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5620, 3750, 21, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5621, 3749, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5622, 3747, 13, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5623, 3747, 20, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5624, 3747, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5625, 3746, 29, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5626, 3744, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5627, 3742, 15, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5628, 3741, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5629, 3741, 9, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5630, 3741, 14, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5631, 3741, 21, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5632, 3741, 26, 5, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5633, 3740, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5634, 3740, 20, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5635, 3740, 24, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5636, 3740, 25, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5637, 3738, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5638, 3737, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5639, 3737, 10, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5640, 3736, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5641, 3735, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5642, 3735, 5, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5643, 3735, 20, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5644, 3734, 13, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5645, 3734, 20, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5646, 3734, 22, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5647, 3734, 27, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5648, 3733, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5649, 3733, 29, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5650, 3732, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5651, 3731, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5652, 3731, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5653, 3730, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5654, 3730, 9, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5655, 3729, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5656, 3725, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5657, 3725, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5658, 3725, 21, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5659, 3723, 13, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5660, 3723, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5661, 3723, 29, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5662, 3722, 17, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5663, 3722, 28, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5664, 3721, 23, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5665, 3721, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5666, 3720, 22, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5667, 3717, 14, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5668, 3716, 25, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5669, 3715, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5670, 3715, 13, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5671, 3715, 28, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5672, 3714, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5673, 3714, 29, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5674, 3712, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5675, 3712, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5676, 3711, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5677, 3709, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5678, 3707, 10, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5679, 3707, 28, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5680, 3706, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5681, 3706, 16, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5682, 3704, 17, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5683, 3703, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5684, 3702, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5685, 3699, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5686, 3698, 13, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5687, 3697, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5688, 3697, 12, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5689, 3696, 10, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5690, 3696, 12, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5691, 3696, 15, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5692, 3696, 19, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5693, 3694, 28, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5694, 3693, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5695, 3693, 15, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5696, 3692, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5697, 3692, 26, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5698, 3691, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5699, 3691, 16, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5700, 3690, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5701, 3689, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5702, 3689, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5703, 3689, 23, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5704, 3687, 3, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5705, 3687, 4, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5706, 3687, 11, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5707, 3687, 21, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5708, 3685, 29, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5709, 3684, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5710, 3684, 7, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5711, 3684, 13, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5712, 3682, 27, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5713, 3681, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5714, 3679, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5715, 3679, 4, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5716, 3679, 9, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5717, 3679, 11, 4, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5718, 3678, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5719, 3678, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5720, 3677, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5721, 3677, 16, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5722, 3676, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5723, 3676, 10, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5724, 3676, 21, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5725, 3676, 24, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5726, 3676, 27, 5, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5727, 3674, 21, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5728, 3673, 16, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5729, 3671, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5730, 3670, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5731, 3670, 26, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5732, 3668, 14, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5733, 3668, 16, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5734, 3667, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5735, 3667, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5736, 3667, 17, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5737, 3666, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5738, 3666, 24, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5739, 3665, 21, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5740, 3665, 22, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5741, 3664, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5742, 3664, 12, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5743, 3664, 21, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5744, 3663, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5745, 3662, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5746, 3661, 29, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5747, 3660, 28, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5748, 3659, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5749, 3658, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5750, 3658, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5751, 3657, 23, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5752, 3656, 5, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5753, 3656, 20, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5754, 3652, 28, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5755, 3651, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5756, 3651, 21, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5757, 3649, 12, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5758, 3649, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5759, 3648, 5, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5760, 3648, 6, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5761, 3647, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5762, 3647, 22, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5763, 3646, 19, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5764, 3646, 21, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5765, 3645, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5766, 3645, 13, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5767, 3645, 22, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5768, 3644, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5769, 3643, 21, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5770, 3642, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5771, 3641, 22, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5772, 3640, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5773, 3640, 25, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5774, 3639, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5775, 3639, 27, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5776, 3637, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5777, 3637, 14, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5778, 3635, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5779, 3634, 23, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5780, 3632, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5781, 3631, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5782, 3631, 7, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5783, 3630, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5784, 3630, 26, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5785, 3629, 17, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5786, 3629, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5787, 3628, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5788, 3628, 6, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5789, 3627, 17, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5790, 3626, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5791, 3626, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5792, 3626, 9, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5793, 3626, 15, 4, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5794, 3626, 20, 5, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5795, 3626, 25, 6, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5796, 3625, 15, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5797, 3624, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5798, 3624, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5799, 3623, 24, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5800, 3622, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5801, 3621, 24, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5802, 3621, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5803, 3619, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5804, 3619, 14, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5805, 3619, 17, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5806, 3618, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5807, 3616, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5808, 3615, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5809, 3615, 17, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5810, 3613, 29, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5811, 3612, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5812, 3611, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5813, 3611, 9, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5814, 3611, 22, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5815, 3610, 12, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5816, 3610, 19, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5817, 3608, 11, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5818, 3608, 12, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5819, 3608, 21, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5820, 3608, 27, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5821, 3608, 28, 5, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5822, 3607, 13, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5823, 3607, 29, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5824, 3606, 17, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5825, 3605, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5826, 3605, 19, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5827, 3605, 24, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5828, 3604, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5829, 3602, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5830, 3601, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5831, 3601, 21, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5832, 3600, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5833, 3599, 23, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5834, 3596, 16, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5835, 3596, 22, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5836, 3596, 28, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5837, 3595, 13, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5838, 3595, 21, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5839, 3594, 28, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5840, 3593, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5841, 3592, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5842, 3592, 18, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5843, 3590, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5844, 3589, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5845, 3589, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5846, 3588, 23, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5847, 3587, 19, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5848, 3587, 25, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5849, 3586, 20, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5850, 3586, 21, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5851, 3585, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5852, 3585, 20, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5853, 3583, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5854, 3583, 6, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5855, 3583, 10, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5856, 3581, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5857, 3581, 3, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5858, 3581, 5, 3, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5859, 3581, 25, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5860, 3580, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5861, 3580, 8, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5862, 3580, 13, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5863, 3579, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5864, 3579, 19, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5865, 3579, 29, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5866, 3578, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5867, 3578, 26, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5868, 3577, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5869, 3574, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5870, 3574, 22, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5871, 3572, 24, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5872, 3569, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5873, 3569, 26, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5874, 3567, 27, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5875, 3566, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5876, 3566, 18, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5877, 3566, 25, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5878, 3566, 28, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5879, 3565, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5880, 3564, 24, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5881, 3563, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5882, 3562, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5883, 3560, 27, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5884, 3559, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5885, 3559, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5886, 3558, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5887, 3557, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5888, 3557, 11, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5889, 3556, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5890, 3556, 15, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5891, 3554, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5892, 3552, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5893, 3549, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5894, 3549, 20, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5895, 3547, 5, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5896, 3547, 19, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5897, 3547, 21, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5898, 3546, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5899, 3546, 11, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5900, 3546, 18, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5901, 3545, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5902, 3545, 14, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5903, 3544, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5904, 3544, 13, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5905, 3544, 21, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5906, 3544, 24, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5907, 3543, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5908, 3541, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5909, 3541, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5910, 3540, 24, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5911, 3539, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5912, 3539, 28, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5913, 3538, 18, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5914, 3536, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5915, 3536, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5916, 3535, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5917, 3534, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5918, 3533, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5919, 3533, 8, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5920, 3532, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5921, 3532, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5922, 3531, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5923, 3529, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5924, 3528, 28, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5925, 3527, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5926, 3526, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5927, 3526, 16, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5928, 3525, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5929, 3525, 7, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5930, 3525, 21, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5931, 3525, 26, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5932, 3523, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5933, 3523, 22, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5934, 3523, 23, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5935, 3522, 18, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5936, 3520, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5937, 3520, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5938, 3520, 23, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5939, 3519, 20, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5940, 3519, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5941, 3518, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5942, 3518, 4, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5943, 3518, 7, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5944, 3518, 18, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5945, 3517, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5946, 3516, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5947, 3516, 7, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5948, 3516, 8, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5949, 3516, 29, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5950, 3515, 21, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5951, 3513, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5952, 3513, 5, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5953, 3513, 9, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5954, 3512, 25, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5955, 3511, 25, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5956, 3510, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5957, 3508, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5958, 3508, 5, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5959, 3508, 27, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5960, 3507, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5961, 3507, 18, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5962, 3506, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5963, 3506, 15, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5964, 3506, 21, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5965, 3505, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5966, 3505, 17, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5967, 3504, 18, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5968, 3503, 23, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5969, 3502, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5970, 3502, 7, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5971, 3502, 12, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5972, 3500, 12, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5973, 3500, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5974, 3499, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5975, 3499, 6, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5976, 3499, 15, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5977, 3499, 16, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5978, 3499, 27, 5, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5979, 3497, 16, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5980, 3496, 19, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5981, 3495, 23, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5982, 3494, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5983, 3493, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5984, 3491, 10, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5985, 3489, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5986, 3489, 5, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5987, 3489, 20, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5988, 3487, 18, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5989, 3487, 22, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5990, 3487, 27, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5991, 3485, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5992, 3485, 24, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5993, 3482, 24, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5994, 3481, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5995, 3481, 11, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5996, 3480, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5997, 3479, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5998, 3477, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (5999, 3477, 11, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6000, 3474, 28, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6001, 3473, 28, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6002, 3472, 10, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6003, 3472, 14, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6004, 3470, 16, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6005, 3469, 15, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6006, 3468, 10, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6007, 3467, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6008, 3467, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6009, 3467, 21, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6010, 3466, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6011, 3466, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6012, 3465, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6013, 3464, 23, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6014, 3463, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6015, 3463, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6016, 3463, 22, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6017, 3462, 28, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6018, 3461, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6019, 3461, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6020, 3460, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6021, 3460, 20, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6022, 3458, 28, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6023, 3457, 29, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6024, 3456, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6025, 3455, 9, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6026, 3454, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6027, 3453, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6028, 3453, 11, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6029, 3453, 19, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6030, 3453, 29, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6031, 3451, 11, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6032, 3451, 12, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6033, 3451, 13, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6034, 3450, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6035, 3450, 7, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6036, 3449, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6037, 3445, 8, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6038, 3444, 25, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6039, 3444, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6040, 3441, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6041, 3441, 29, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6042, 3440, 18, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6043, 3440, 27, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6044, 3439, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6045, 3439, 17, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6046, 3437, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6047, 3437, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6048, 3436, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6049, 3436, 29, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6050, 3434, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6051, 3433, 18, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6052, 3433, 21, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6053, 3432, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6054, 3431, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6055, 3430, 10, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6056, 3429, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6057, 3426, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6058, 3426, 24, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6059, 3423, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6060, 3423, 23, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6061, 3422, 26, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6062, 3419, 10, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6063, 3419, 15, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6064, 3419, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6065, 3418, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6066, 3417, 20, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6067, 3416, 23, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6068, 3416, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6069, 3415, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6070, 3413, 15, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6071, 3413, 19, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6072, 3411, 12, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6073, 3411, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6074, 3410, 5, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6075, 3410, 25, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6076, 3409, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6077, 3409, 2, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6078, 3409, 8, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6079, 3407, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6080, 3407, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6081, 3404, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6082, 3404, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6083, 3404, 28, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6084, 3403, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6085, 3401, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6086, 3401, 29, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6087, 3400, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6088, 3399, 12, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6089, 3399, 19, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6090, 3398, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6091, 3397, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6092, 3397, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6093, 3397, 19, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6094, 3396, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6095, 3396, 12, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6096, 3396, 27, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6097, 3394, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6098, 3394, 12, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6099, 3394, 20, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6100, 3393, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6101, 3392, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6102, 3392, 11, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6103, 3392, 17, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6104, 3392, 21, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6105, 3392, 26, 5, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6106, 3391, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6107, 3391, 26, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6108, 3390, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6109, 3390, 9, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6110, 3388, 5, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6111, 3388, 20, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6112, 3385, 25, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6113, 3384, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6114, 3383, 22, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6115, 3383, 26, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6116, 3383, 28, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6117, 3382, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6118, 3382, 12, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6119, 3382, 18, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6120, 3380, 11, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6121, 3378, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6122, 3377, 9, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6123, 3376, 24, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6124, 3375, 25, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6125, 3375, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6126, 3373, 14, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6127, 3373, 16, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6128, 3373, 21, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6129, 3372, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6130, 3371, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6131, 3371, 17, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6132, 3370, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6133, 3370, 24, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6134, 3369, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6135, 3368, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6136, 3367, 15, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6137, 3367, 24, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6138, 3365, 1, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6139, 3364, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6140, 3363, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6141, 3363, 23, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6142, 3362, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6143, 3362, 23, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6144, 3361, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6145, 3360, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6146, 3359, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6147, 3358, 27, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6148, 3357, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6149, 3356, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6150, 3355, 11, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6151, 3355, 24, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6152, 3354, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6153, 3354, 6, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6154, 3354, 13, 3, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6155, 3354, 28, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6156, 3353, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6157, 3353, 23, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6158, 3353, 24, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6159, 3352, 19, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6160, 3352, 29, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6161, 3346, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6162, 3346, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6163, 3345, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6164, 3345, 26, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6165, 3344, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6166, 3344, 26, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6167, 3343, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6168, 3341, 22, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6169, 3340, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6170, 3339, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6171, 3336, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6172, 3335, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6173, 3335, 29, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6174, 3334, 20, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6175, 3334, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6176, 3333, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6177, 3333, 29, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6178, 3332, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6179, 3332, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6180, 3329, 20, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6181, 3329, 24, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6182, 3329, 26, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6183, 3328, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6184, 3328, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6185, 3327, 27, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6186, 3326, 18, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6187, 3325, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6188, 3325, 13, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6189, 3324, 12, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6190, 3323, 24, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6191, 3322, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6192, 3320, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6193, 3319, 28, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6194, 3317, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6195, 3316, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6196, 3316, 16, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6197, 3315, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6198, 3314, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6199, 3314, 28, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6200, 3313, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6201, 3313, 24, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6202, 3312, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6203, 3310, 25, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6204, 3309, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6205, 3307, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6206, 3307, 16, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6207, 3306, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6208, 3306, 20, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6209, 3305, 13, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6210, 3305, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6211, 3304, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6212, 3304, 14, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6213, 3304, 16, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6214, 3303, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6215, 3298, 23, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6216, 3297, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6217, 3296, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6218, 3295, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6219, 3295, 15, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6220, 3290, 25, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6221, 3289, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6222, 3289, 13, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6223, 3288, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6224, 3288, 7, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6225, 3288, 9, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6226, 3288, 28, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6227, 3287, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6228, 3287, 27, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6229, 3286, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6230, 3286, 5, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6231, 3286, 10, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6232, 3286, 14, 4, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6233, 3286, 24, 5, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6234, 3285, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6235, 3285, 22, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6236, 3284, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6237, 3282, 14, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6238, 3282, 21, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6239, 3282, 27, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6240, 3280, 9, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6241, 3280, 14, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6242, 3280, 15, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6243, 3280, 27, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6244, 3279, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6245, 3278, 25, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6246, 3277, 8, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6247, 3277, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6248, 3277, 22, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6249, 3277, 24, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6250, 3276, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6251, 3276, 18, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6252, 3276, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6253, 3274, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6254, 3274, 11, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6255, 3273, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6256, 3273, 7, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6257, 3273, 16, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6258, 3273, 26, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6259, 3272, 19, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6260, 3271, 28, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6261, 3268, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6262, 3268, 5, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6263, 3266, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6264, 3265, 18, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6265, 3263, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6266, 3263, 10, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6267, 3262, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6268, 3261, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6269, 3260, 21, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6270, 3258, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6271, 3258, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6272, 3257, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6273, 3257, 7, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6274, 3257, 9, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6275, 3257, 12, 4, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6276, 3257, 27, 5, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6277, 3256, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6278, 3255, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6279, 3254, 15, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6280, 3254, 27, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6281, 3253, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6282, 3253, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6283, 3251, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6284, 3250, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6285, 3249, 19, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6286, 3248, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6287, 3247, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6288, 3246, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6289, 3246, 16, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6290, 3245, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6291, 3245, 16, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6292, 3243, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6293, 3243, 13, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6294, 3243, 25, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6295, 3241, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6296, 3241, 11, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6297, 3241, 24, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6298, 3241, 26, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6299, 3240, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6300, 3240, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6301, 3239, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6302, 3238, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6303, 3238, 9, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6304, 3238, 15, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6305, 3238, 20, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6306, 3238, 28, 5, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6307, 3237, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6308, 3234, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6309, 3234, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6310, 3233, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6311, 3233, 21, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6312, 3232, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6313, 3232, 10, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6314, 3231, 29, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6315, 3228, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6316, 3228, 18, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6317, 3228, 23, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6318, 3227, 22, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6319, 3224, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6320, 3224, 9, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6321, 3224, 28, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6322, 3221, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6323, 3221, 27, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6324, 3218, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6325, 3215, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6326, 3215, 4, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6327, 3214, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6328, 3214, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6329, 3214, 17, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6330, 3214, 26, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6331, 3213, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6332, 3211, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6333, 3211, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6334, 3209, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6335, 3209, 20, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6336, 3206, 26, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6337, 3205, 12, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6338, 3204, 20, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6339, 3204, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6340, 3201, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6341, 3201, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6342, 3200, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6343, 3198, 22, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6344, 3197, 23, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6345, 3196, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6346, 3194, 16, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6347, 3194, 24, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6348, 3193, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6349, 3192, 13, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6350, 3192, 28, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6351, 3191, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6352, 3189, 19, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6353, 3188, 5, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6354, 3188, 28, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6355, 3187, 15, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6356, 3185, 3, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6357, 3185, 28, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6358, 3184, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6359, 3184, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6360, 3182, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6361, 3182, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6362, 3182, 20, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6363, 3181, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6364, 3181, 4, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6365, 3181, 6, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6366, 3181, 10, 4, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6367, 3181, 25, 5, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6368, 3180, 9, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6369, 3180, 20, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6370, 3180, 29, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6371, 3179, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6372, 3178, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6373, 3178, 8, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6374, 3178, 28, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6375, 3177, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6376, 3177, 3, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6377, 3176, 17, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6378, 3174, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6379, 3173, 17, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6380, 3171, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6381, 3169, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6382, 3169, 12, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6383, 3169, 15, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6384, 3169, 21, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6385, 3169, 29, 5, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6386, 3168, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6387, 3167, 15, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6388, 3167, 26, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6389, 3165, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6390, 3165, 15, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6391, 3164, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6392, 3164, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6393, 3163, 15, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6394, 3163, 22, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6395, 3162, 19, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6396, 3160, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6397, 3159, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6398, 3159, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6399, 3159, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6400, 3158, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6401, 3157, 16, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6402, 3157, 23, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6403, 3156, 11, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6404, 3155, 24, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6405, 3154, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6406, 3154, 11, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6407, 3152, 12, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6408, 3151, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6409, 3150, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6410, 3150, 23, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6411, 3149, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6412, 3148, 23, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6413, 3147, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6414, 3147, 25, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6415, 3146, 21, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6416, 3145, 17, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6417, 3145, 27, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6418, 3144, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6419, 3144, 25, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6420, 3144, 29, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6421, 3143, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6422, 3143, 8, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6423, 3142, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6424, 3142, 6, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6425, 3141, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6426, 3141, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6427, 3141, 27, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6428, 3140, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6429, 3140, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6430, 3140, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6431, 3139, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6432, 3139, 19, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6433, 3138, 19, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6434, 3138, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6435, 3137, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6436, 3137, 29, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6437, 3136, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6438, 3136, 15, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6439, 3136, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6440, 3135, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6441, 3135, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6442, 3134, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6443, 3134, 6, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6444, 3134, 16, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6445, 3134, 28, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6446, 3133, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6447, 3133, 10, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6448, 3133, 15, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6449, 3131, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6450, 3130, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6451, 3130, 23, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6452, 3130, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6453, 3130, 27, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6454, 3129, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6455, 3128, 29, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6456, 3127, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6457, 3127, 5, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6458, 3126, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6459, 3126, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6460, 3126, 14, 3, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6461, 3124, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6462, 3124, 28, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6463, 3123, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6464, 3122, 23, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6465, 3122, 25, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6466, 3121, 22, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6467, 3121, 25, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6468, 3120, 6, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6469, 3119, 12, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6470, 3119, 27, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6471, 3118, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6472, 3117, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6473, 3117, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6474, 3116, 24, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6475, 3115, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6476, 3115, 8, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6477, 3114, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6478, 3114, 9, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6479, 3113, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6480, 3113, 11, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6481, 3113, 16, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6482, 3112, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6483, 3112, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6484, 3109, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6485, 3109, 17, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6486, 3108, 21, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6487, 3108, 22, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6488, 3107, 29, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6489, 3105, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6490, 3105, 19, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6491, 3103, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6492, 3103, 28, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6493, 3102, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6494, 3102, 8, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6495, 3101, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6496, 3101, 15, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6497, 3100, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6498, 3100, 18, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6499, 3099, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6500, 3099, 10, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6501, 3099, 24, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6502, 3098, 9, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6503, 3098, 10, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6504, 3095, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6505, 3095, 28, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6506, 3095, 29, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6507, 3094, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6508, 3094, 22, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6509, 3094, 24, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6510, 3093, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6511, 3092, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6512, 3091, 25, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6513, 3090, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6514, 3089, 28, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6515, 3088, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6516, 3088, 21, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6517, 3088, 23, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6518, 3088, 29, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6519, 3087, 17, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6520, 3086, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6521, 3086, 6, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6522, 3086, 18, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6523, 3086, 20, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6524, 3086, 28, 5, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6525, 3085, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6526, 3085, 13, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6527, 3085, 22, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6528, 3085, 29, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6529, 3084, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6530, 3084, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6531, 3083, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6532, 3083, 9, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6533, 3083, 13, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6534, 3083, 15, 4, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6535, 3083, 19, 5, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6536, 3082, 23, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6537, 3081, 18, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6538, 3075, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6539, 3075, 11, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6540, 3075, 24, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6541, 3074, 20, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6542, 3074, 25, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6543, 3073, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6544, 3073, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6545, 3071, 17, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6546, 3071, 20, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6547, 3070, 22, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6548, 3069, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6549, 3068, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6550, 3068, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6551, 3068, 21, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6552, 3066, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6553, 3066, 29, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6554, 3065, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6555, 3065, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6556, 3064, 25, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6557, 3063, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6558, 3063, 28, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6559, 3062, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6560, 3062, 9, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6561, 3059, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6562, 3058, 21, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6563, 3058, 27, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6564, 3056, 25, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6565, 3055, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6566, 3055, 29, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6567, 3054, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6568, 3054, 8, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6569, 3054, 29, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6570, 3053, 17, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6571, 3052, 5, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6572, 3052, 6, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6573, 3052, 7, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6574, 3052, 11, 4, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6575, 3052, 13, 5, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6576, 3052, 28, 6, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6577, 3051, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6578, 3048, 25, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6579, 3046, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6580, 3046, 11, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6581, 3046, 21, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6582, 3046, 27, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6583, 3045, 20, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6584, 3043, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6585, 3043, 11, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6586, 3041, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6587, 3041, 24, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6588, 3040, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6589, 3040, 11, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6590, 3039, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6591, 3039, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6592, 3038, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6593, 3038, 13, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6594, 3038, 21, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6595, 3038, 26, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6596, 3035, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6597, 3035, 16, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6598, 3034, 16, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6599, 3033, 10, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6600, 3032, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6601, 3032, 15, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6602, 3032, 19, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6603, 3031, 6, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6604, 3030, 22, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6605, 3028, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6606, 3027, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6607, 3027, 18, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6608, 3025, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6609, 3025, 26, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6610, 3023, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6611, 3023, 12, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6612, 3023, 24, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6613, 3022, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6614, 3022, 9, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6615, 3020, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6616, 3020, 28, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6617, 3018, 3, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6618, 3018, 10, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6619, 3018, 12, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6620, 3018, 13, 4, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6621, 3018, 22, 5, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6622, 3017, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6623, 3017, 12, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6624, 3017, 15, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6625, 3017, 17, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6626, 3016, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6627, 3013, 6, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6628, 3012, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6629, 3012, 27, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6630, 3010, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6631, 3010, 6, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6632, 3010, 28, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6633, 3009, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6634, 3009, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6635, 3008, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6636, 3008, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6637, 3007, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6638, 3007, 21, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6639, 3006, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6640, 3004, 12, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6641, 3003, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6642, 3003, 26, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6643, 3002, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6644, 3000, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6645, 2999, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6646, 2999, 19, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6647, 2999, 21, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6648, 2997, 8, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6649, 2997, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6650, 2997, 10, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6651, 2997, 13, 4, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6652, 2994, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6653, 2994, 18, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6654, 2994, 19, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6655, 2993, 24, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6656, 2992, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6657, 2991, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6658, 2991, 9, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6659, 2991, 23, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6660, 2989, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6661, 2989, 18, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6662, 2987, 23, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6663, 2986, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6664, 2985, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6665, 2985, 11, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6666, 2985, 27, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6667, 2985, 29, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6668, 2984, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6669, 2984, 24, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6670, 2984, 29, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6671, 2983, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6672, 2981, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6673, 2981, 11, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6674, 2981, 13, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6675, 2981, 25, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6676, 2980, 18, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6677, 2980, 29, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6678, 2978, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6679, 2978, 8, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6680, 2978, 22, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6681, 2976, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6682, 2976, 18, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6683, 2976, 22, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6684, 2975, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6685, 2975, 10, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6686, 2974, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6687, 2973, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6688, 2972, 9, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6689, 2971, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6690, 2971, 16, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6691, 2968, 15, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6692, 2966, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6693, 2966, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6694, 2966, 25, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6695, 2965, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6696, 2964, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6697, 2964, 17, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6698, 2963, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6699, 2963, 2, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6700, 2963, 23, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6701, 2962, 15, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6702, 2962, 28, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6703, 2961, 12, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6704, 2961, 15, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6705, 2960, 23, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6706, 2960, 25, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6707, 2959, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6708, 2958, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6709, 2958, 24, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6710, 2957, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6711, 2957, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6712, 2956, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6713, 2956, 17, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6714, 2955, 20, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6715, 2955, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6716, 2954, 17, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6717, 2953, 13, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6718, 2952, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6719, 2951, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6720, 2951, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6721, 2950, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6722, 2950, 15, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6723, 2950, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6724, 2950, 27, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6725, 2948, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6726, 2947, 22, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6727, 2946, 27, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6728, 2945, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6729, 2944, 18, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6730, 2944, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6731, 2943, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6732, 2943, 16, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6733, 2942, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6734, 2941, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6735, 2941, 24, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6736, 2939, 10, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6737, 2938, 25, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6738, 2937, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6739, 2937, 22, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6740, 2934, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6741, 2934, 22, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6742, 2933, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6743, 2933, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6744, 2933, 23, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6745, 2933, 25, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6746, 2931, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6747, 2931, 20, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6748, 2930, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6749, 2929, 26, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6750, 2925, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6751, 2924, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6752, 2924, 28, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6753, 2921, 14, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6754, 2917, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6755, 2917, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6756, 2917, 25, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6757, 2916, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6758, 2916, 26, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6759, 2915, 21, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6760, 2914, 22, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6761, 2913, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6762, 2913, 12, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6763, 2913, 15, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6764, 2913, 16, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6765, 2913, 17, 5, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6766, 2913, 29, 6, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6767, 2912, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6768, 2912, 25, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6769, 2912, 28, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6770, 2911, 21, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6771, 2910, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6772, 2910, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6773, 2910, 28, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6774, 2909, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6775, 2908, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6776, 2908, 29, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6777, 2907, 14, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6778, 2907, 29, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6779, 2906, 17, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6780, 2905, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6781, 2905, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6782, 2905, 23, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6783, 2903, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6784, 2903, 25, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6785, 2902, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6786, 2902, 5, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6787, 2902, 10, 3, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6788, 2902, 18, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6789, 2902, 27, 5, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6790, 2901, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6791, 2901, 28, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6792, 2899, 12, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6793, 2899, 13, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6794, 2899, 16, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6795, 2899, 25, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6796, 2898, 11, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6797, 2898, 15, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6798, 2894, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6799, 2893, 27, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6800, 2892, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6801, 2892, 25, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6802, 2890, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6803, 2889, 10, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6804, 2889, 12, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6805, 2889, 21, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6806, 2887, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6807, 2887, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6808, 2885, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6809, 2885, 20, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6810, 2884, 26, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6811, 2884, 28, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6812, 2883, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6813, 2881, 26, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6814, 2879, 18, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6815, 2879, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6816, 2878, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6817, 2878, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6818, 2878, 11, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6819, 2878, 28, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6820, 2877, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6821, 2877, 9, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6822, 2877, 24, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6823, 2876, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6824, 2876, 8, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6825, 2875, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6826, 2875, 4, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6827, 2874, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6828, 2874, 4, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6829, 2874, 14, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6830, 2874, 15, 4, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6831, 2873, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6832, 2873, 27, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6833, 2872, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6834, 2872, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6835, 2872, 20, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6836, 2868, 20, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6837, 2867, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6838, 2866, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6839, 2865, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6840, 2865, 10, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6841, 2865, 14, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6842, 2864, 1, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6843, 2864, 3, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6844, 2864, 21, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6845, 2864, 26, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6846, 2863, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6847, 2862, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6848, 2861, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6849, 2859, 27, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6850, 2858, 17, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6851, 2858, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6852, 2857, 17, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6853, 2856, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6854, 2856, 21, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6855, 2853, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6856, 2853, 5, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6857, 2853, 19, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6858, 2853, 28, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6859, 2852, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6860, 2852, 7, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6861, 2852, 20, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6862, 2852, 27, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6863, 2851, 19, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6864, 2850, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6865, 2849, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6866, 2847, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6867, 2847, 14, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6868, 2847, 27, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6869, 2846, 10, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6870, 2846, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6871, 2846, 21, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6872, 2845, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6873, 2845, 15, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6874, 2844, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6875, 2843, 21, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6876, 2842, 19, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6877, 2842, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6878, 2841, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6879, 2841, 25, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6880, 2838, 8, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6881, 2836, 21, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6882, 2835, 21, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6883, 2835, 27, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6884, 2834, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6885, 2833, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6886, 2833, 8, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6887, 2833, 22, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6888, 2833, 27, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6889, 2832, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6890, 2831, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6891, 2831, 14, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6892, 2831, 20, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6893, 2830, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6894, 2830, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6895, 2827, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6896, 2827, 25, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6897, 2826, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6898, 2826, 29, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6899, 2825, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6900, 2825, 15, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6901, 2823, 9, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6902, 2823, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6903, 2822, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6904, 2822, 24, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6905, 2822, 25, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6906, 2821, 15, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6907, 2821, 26, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6908, 2821, 28, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6909, 2820, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6910, 2820, 17, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6911, 2818, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6912, 2817, 6, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6913, 2816, 28, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6914, 2814, 23, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6915, 2811, 28, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6916, 2810, 5, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6917, 2810, 8, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6918, 2809, 23, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6919, 2808, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6920, 2808, 6, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6921, 2807, 1, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6922, 2807, 3, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6923, 2807, 6, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6924, 2807, 17, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6925, 2805, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6926, 2804, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6927, 2804, 11, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6928, 2803, 14, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6929, 2803, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6930, 2802, 9, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6931, 2802, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6932, 2801, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6933, 2800, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6934, 2799, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6935, 2797, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6936, 2796, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6937, 2794, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6938, 2794, 10, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6939, 2794, 16, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6940, 2793, 20, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6941, 2793, 28, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6942, 2792, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6943, 2792, 14, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6944, 2791, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6945, 2791, 19, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6946, 2790, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6947, 2789, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6948, 2789, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6949, 2789, 10, 3, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6950, 2789, 17, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6951, 2789, 20, 5, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6952, 2789, 29, 6, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6953, 2788, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6954, 2788, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6955, 2787, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6956, 2786, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6957, 2784, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6958, 2783, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6959, 2783, 9, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6960, 2782, 28, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6961, 2780, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6962, 2779, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6963, 2778, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6964, 2777, 27, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6965, 2776, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6966, 2776, 19, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6967, 2776, 29, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6968, 2775, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6969, 2775, 6, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6970, 2774, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6971, 2772, 24, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6972, 2771, 9, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6973, 2771, 18, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6974, 2771, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6975, 2770, 5, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6976, 2770, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6977, 2768, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6978, 2768, 14, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6979, 2768, 18, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6980, 2766, 20, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6981, 2765, 17, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6982, 2765, 20, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6983, 2765, 21, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6984, 2765, 28, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6985, 2763, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6986, 2762, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6987, 2760, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6988, 2760, 14, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6989, 2760, 22, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6990, 2758, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6991, 2757, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6992, 2757, 21, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6993, 2756, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6994, 2756, 14, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6995, 2755, 4, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6996, 2755, 23, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6997, 2754, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6998, 2754, 13, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (6999, 2753, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7000, 2753, 17, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7001, 2753, 22, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7002, 2752, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7003, 2751, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7004, 2751, 23, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7005, 2747, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7006, 2746, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7007, 2746, 19, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7008, 2745, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7009, 2743, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7010, 2742, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7011, 2742, 8, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7012, 2742, 11, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7013, 2742, 23, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7014, 2742, 24, 5, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7015, 2742, 26, 6, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7016, 2739, 15, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7017, 2738, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7018, 2738, 21, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7019, 2737, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7020, 2737, 15, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7021, 2737, 17, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7022, 2737, 23, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7023, 2737, 25, 5, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7024, 2737, 29, 6, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7025, 2735, 25, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7026, 2734, 5, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7027, 2734, 19, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7028, 2733, 21, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7029, 2732, 20, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7030, 2731, 20, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7031, 2730, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7032, 2729, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7033, 2729, 22, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7034, 2728, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7035, 2728, 11, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7036, 2728, 22, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7037, 2725, 13, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7038, 2724, 19, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7039, 2723, 14, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7040, 2723, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7041, 2723, 21, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7042, 2721, 23, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7043, 2720, 3, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7044, 2720, 12, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7045, 2720, 21, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7046, 2719, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7047, 2718, 20, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7048, 2713, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7049, 2712, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7050, 2712, 10, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7051, 2712, 16, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7052, 2712, 24, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7053, 2711, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7054, 2710, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7055, 2710, 25, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7056, 2709, 28, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7057, 2708, 8, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7058, 2708, 17, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7059, 2708, 24, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7060, 2705, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7061, 2705, 8, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7062, 2704, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7063, 2703, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7064, 2702, 17, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7065, 2702, 23, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7066, 2699, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7067, 2696, 13, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7068, 2696, 24, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7069, 2694, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7070, 2693, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7071, 2693, 29, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7072, 2691, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7073, 2691, 11, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7074, 2691, 28, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7075, 2690, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7076, 2689, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7077, 2688, 13, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7078, 2688, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7079, 2687, 6, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7080, 2687, 21, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7081, 2686, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7082, 2686, 7, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7083, 2686, 23, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7084, 2685, 6, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7085, 2684, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7086, 2684, 15, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7087, 2683, 19, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7088, 2682, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7089, 2682, 26, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7090, 2681, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7091, 2680, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7092, 2680, 11, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7093, 2680, 21, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7094, 2679, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7095, 2677, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7096, 2676, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7097, 2675, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7098, 2675, 12, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7099, 2675, 23, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7100, 2674, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7101, 2674, 7, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7102, 2673, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7103, 2673, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7104, 2673, 17, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7105, 2672, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7106, 2672, 29, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7107, 2671, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7108, 2671, 14, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7109, 2670, 5, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7110, 2670, 19, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7111, 2669, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7112, 2669, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7113, 2669, 29, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7114, 2668, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7115, 2667, 19, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7116, 2666, 1, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7117, 2666, 6, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7118, 2666, 18, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7119, 2665, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7120, 2663, 22, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7121, 2661, 7, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7122, 2660, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7123, 2660, 17, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7124, 2660, 21, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7125, 2660, 28, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7126, 2658, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7127, 2658, 16, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7128, 2658, 20, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7129, 2657, 13, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7130, 2656, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7131, 2656, 27, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7132, 2655, 1, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7133, 2654, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7134, 2654, 10, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7135, 2654, 21, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7136, 2654, 22, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7137, 2653, 20, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7138, 2652, 16, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7139, 2651, 10, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7140, 2650, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7141, 2650, 11, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7142, 2649, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7143, 2646, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7144, 2646, 23, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7145, 2645, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7146, 2645, 6, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7147, 2645, 11, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7148, 2644, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7149, 2644, 17, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7150, 2642, 17, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7151, 2641, 7, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7152, 2641, 26, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7153, 2641, 27, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7154, 2640, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7155, 2640, 16, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7156, 2640, 26, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7157, 2639, 15, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7158, 2639, 19, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7159, 2639, 29, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7160, 2638, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7161, 2637, 24, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7162, 2634, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7163, 2634, 13, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7164, 2634, 14, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7165, 2632, 23, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7166, 2631, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7167, 2631, 29, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7168, 2630, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7169, 2630, 5, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7170, 2629, 29, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7171, 2628, 22, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7172, 2627, 26, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7173, 2626, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7174, 2626, 16, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7175, 2625, 16, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7176, 2624, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7177, 2624, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7178, 2623, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7179, 2623, 13, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7180, 2622, 8, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7181, 2621, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7182, 2621, 19, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7183, 2620, 16, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7184, 2620, 23, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7185, 2620, 29, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7186, 2618, 3, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7187, 2617, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7188, 2617, 20, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7189, 2616, 14, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7190, 2616, 28, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7191, 2615, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7192, 2615, 20, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7193, 2615, 24, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7194, 2614, 14, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7195, 2613, 25, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7196, 2612, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7197, 2612, 7, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7198, 2612, 10, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7199, 2612, 27, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7200, 2611, 18, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7201, 2610, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7202, 2606, 10, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7203, 2606, 29, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7204, 2603, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7205, 2601, 4, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7206, 2601, 27, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7207, 2601, 28, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7208, 2600, 3, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7209, 2600, 11, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7210, 2600, 28, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7211, 2599, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7212, 2598, 24, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7213, 2595, 5, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7214, 2595, 18, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7215, 2591, 13, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7216, 2591, 22, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7217, 2589, 20, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7218, 2588, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7219, 2588, 22, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7220, 2587, 18, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7221, 2586, 2, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7222, 2586, 11, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7223, 2586, 12, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7224, 2585, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7225, 2583, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7226, 2582, 12, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7227, 2582, 24, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7228, 2580, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7229, 2580, 12, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7230, 2580, 23, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7231, 2579, 6, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7232, 2576, 21, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7233, 2576, 26, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7234, 2575, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7235, 2575, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7236, 2575, 16, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7237, 2575, 21, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7238, 2575, 27, 5, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7239, 2574, 16, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7240, 2573, 1, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7241, 2573, 21, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7242, 2573, 26, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7243, 2572, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7244, 2570, 17, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7245, 2569, 28, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7246, 2567, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7247, 2567, 15, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7248, 2567, 22, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7249, 2562, 15, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7250, 2561, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7251, 2559, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7252, 2559, 21, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7253, 2558, 9, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7254, 2558, 10, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7255, 2558, 15, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7256, 2557, 14, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7257, 2557, 29, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7258, 2556, 4, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7259, 2555, 16, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7260, 2555, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7261, 2551, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7262, 2551, 13, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7263, 2551, 19, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7264, 2551, 27, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7265, 2550, 13, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7266, 2550, 15, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7267, 2550, 16, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7268, 2548, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7269, 2548, 8, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7270, 2548, 22, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7271, 2547, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7272, 2544, 4, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7273, 2544, 6, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7274, 2544, 14, 3, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7275, 2544, 19, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7276, 2543, 27, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7277, 2540, 23, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7278, 2539, 10, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7279, 2539, 28, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7280, 2538, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7281, 2538, 26, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7282, 2537, 6, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7283, 2536, 7, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7284, 2536, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7285, 2534, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7286, 2534, 29, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7287, 2532, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7288, 2532, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7289, 2531, 4, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7290, 2531, 11, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7291, 2530, 11, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7292, 2530, 13, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7293, 2530, 17, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7294, 2529, 27, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7295, 2528, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7296, 2528, 28, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7297, 2527, 15, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7298, 2526, 16, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7299, 2526, 22, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7300, 2522, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7301, 2519, 24, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7302, 2515, 12, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7303, 2514, 23, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7304, 2513, 3, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7305, 2513, 25, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7306, 2512, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7307, 2510, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7308, 2510, 18, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7309, 2510, 24, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7310, 2509, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7311, 2509, 17, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7312, 2509, 24, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7313, 2509, 29, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7314, 2508, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7315, 2508, 19, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7316, 2507, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7317, 2507, 7, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7318, 2507, 15, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7319, 2507, 19, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7320, 2505, 24, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7321, 2504, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7322, 2504, 18, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7323, 2503, 16, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7324, 2502, 2, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7325, 2502, 22, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7326, 2501, 24, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7327, 2499, 7, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7328, 2499, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7329, 2498, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7330, 2498, 13, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7331, 2498, 27, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7332, 2497, 10, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7333, 2497, 19, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7334, 2496, 20, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7335, 2496, 22, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7336, 2495, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7337, 2495, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7338, 2495, 29, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7339, 2494, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7340, 2494, 22, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7341, 2493, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7342, 2493, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7343, 2492, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7344, 2491, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7345, 2491, 25, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7346, 2490, 21, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7347, 2489, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7348, 2489, 21, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7349, 2488, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7350, 2488, 25, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7351, 2487, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7352, 2486, 27, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7353, 2484, 1, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7354, 2484, 20, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7355, 2483, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7356, 2483, 10, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7357, 2482, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7358, 2482, 13, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7359, 2482, 21, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7360, 2481, 12, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7361, 2481, 23, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7362, 2480, 13, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7363, 2480, 20, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7364, 2479, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7365, 2478, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7366, 2476, 14, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7367, 2476, 22, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7368, 2476, 25, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7369, 2476, 28, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7370, 2475, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7371, 2474, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7372, 2474, 5, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7373, 2474, 11, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7374, 2473, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7375, 2472, 13, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7376, 2472, 18, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7377, 2472, 20, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7378, 2472, 21, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7379, 2471, 27, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7380, 2470, 24, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7381, 2470, 26, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7382, 2470, 27, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7383, 2468, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7384, 2468, 24, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7385, 2467, 28, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7386, 2467, 29, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7387, 2466, 23, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7388, 2465, 29, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7389, 2464, 11, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7390, 2464, 19, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7391, 2464, 20, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7392, 2463, 19, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7393, 2463, 25, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7394, 2463, 29, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7395, 2462, 18, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7396, 2462, 23, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7397, 2460, 2, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7398, 2460, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7399, 2459, 16, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7400, 2459, 24, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7401, 2458, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7402, 2457, 21, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7403, 2457, 27, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7404, 2456, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7405, 2454, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7406, 2453, 16, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7407, 2453, 29, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7408, 2452, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7409, 2452, 14, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7410, 2452, 25, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7411, 2451, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7412, 2451, 8, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7413, 2451, 9, 3, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7414, 2451, 19, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7415, 2450, 3, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7416, 2450, 28, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7417, 2447, 12, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7418, 2447, 14, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7419, 2445, 22, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7420, 2444, 26, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7421, 2444, 27, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7422, 2443, 8, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7423, 2442, 19, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7424, 2441, 18, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7425, 2441, 21, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7426, 2441, 28, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7427, 2438, 12, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7428, 2437, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7429, 2437, 20, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7430, 2435, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7431, 2432, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7432, 2431, 29, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7433, 2430, 17, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7434, 2430, 20, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7435, 2428, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7436, 2427, 17, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7437, 2426, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7438, 2426, 18, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7439, 2425, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7440, 2425, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7441, 2425, 24, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7442, 2424, 11, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7443, 2424, 25, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7444, 2424, 28, 3, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7445, 2423, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7446, 2423, 26, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7447, 2422, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7448, 2422, 15, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7449, 2421, 12, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7450, 2421, 21, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7451, 2417, 10, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7452, 2414, 15, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7453, 2413, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7454, 2412, 17, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7455, 2411, 9, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7456, 2411, 24, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7457, 2410, 19, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7458, 2409, 8, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7459, 2409, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7460, 2408, 22, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7461, 2407, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7462, 2407, 26, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7463, 2406, 22, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7464, 2406, 26, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7465, 2405, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7466, 2405, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7467, 2405, 10, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7468, 2404, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7469, 2404, 4, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7470, 2404, 10, 3, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7471, 2402, 28, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7472, 2399, 20, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7473, 2397, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7474, 2396, 22, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7475, 2395, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7476, 2394, 15, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7477, 2394, 20, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7478, 2394, 23, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7479, 2394, 29, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7480, 2393, 17, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7481, 2392, 18, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7482, 2392, 19, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7483, 2391, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7484, 2391, 19, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7485, 2390, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7486, 2390, 9, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7487, 2389, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7488, 2389, 18, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7489, 2388, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7490, 2386, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7491, 2386, 26, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7492, 2385, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7493, 2385, 15, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7494, 2384, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7495, 2382, 11, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7496, 2381, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7497, 2380, 5, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7498, 2380, 28, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7499, 2379, 10, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7500, 2379, 21, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7501, 2378, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7502, 2378, 13, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7503, 2378, 17, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7504, 2376, 7, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7505, 2376, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7506, 2375, 11, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7507, 2374, 5, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7508, 2374, 11, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7509, 2374, 25, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7510, 2374, 28, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7511, 2373, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7512, 2372, 23, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7513, 2371, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7514, 2371, 9, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7515, 2371, 14, 3, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7516, 2371, 28, 4, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7517, 2370, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7518, 2369, 14, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7519, 2369, 16, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7520, 2369, 22, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7521, 2369, 26, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7522, 2368, 22, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7523, 2367, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7524, 2367, 24, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7525, 2366, 9, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7526, 2365, 24, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7527, 2363, 21, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7528, 2362, 19, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7529, 2360, 13, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7530, 2360, 16, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7531, 2360, 17, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7532, 2359, 9, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7533, 2359, 19, 2, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7534, 2359, 28, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7535, 2358, 23, 1, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7536, 2357, 4, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7537, 2357, 23, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7538, 2354, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7539, 2353, 22, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7540, 2352, 9, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7541, 2352, 16, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7542, 2352, 19, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7543, 2349, 12, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7544, 2349, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7545, 2348, 1, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7546, 2348, 9, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7547, 2348, 24, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7548, 2346, 9, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7549, 2346, 13, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7550, 2345, 9, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7551, 2345, 24, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7552, 2343, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7553, 2343, 18, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7554, 2343, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7555, 2342, 18, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7556, 2341, 13, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7557, 2340, 9, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7558, 2340, 13, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7559, 2340, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7560, 2340, 26, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7561, 2338, 28, 1, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7562, 2337, 6, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7563, 2337, 19, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7564, 2336, 24, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7565, 2335, 15, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7566, 2335, 22, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7567, 2333, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7568, 2333, 9, 2, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7569, 2333, 18, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7570, 2333, 24, 4, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7571, 2333, 25, 5, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7572, 2332, 4, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7573, 2332, 5, 2, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7574, 2332, 9, 3, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7575, 2332, 16, 4, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7576, 2332, 25, 5, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7577, 2331, 11, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7578, 2331, 14, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7579, 2331, 21, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7580, 2331, 26, 4, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7581, 2331, 28, 5, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7582, 2330, 13, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7583, 2329, 1, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7584, 2329, 24, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7585, 2329, 27, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7586, 2326, 15, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7587, 2326, 20, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7588, 2326, 29, 3, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7589, 2322, 15, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7590, 2322, 27, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7591, 2322, 28, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7592, 2320, 8, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7593, 2320, 16, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7594, 2319, 5, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7595, 2318, 8, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7596, 2318, 28, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7597, 2317, 2, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7598, 2317, 20, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7599, 2312, 29, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7600, 2311, 5, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7601, 2311, 12, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7602, 2311, 20, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7603, 2310, 22, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7604, 2309, 3, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7605, 2307, 6, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7606, 2307, 12, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7607, 2307, 20, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7608, 2306, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7609, 2305, 10, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7610, 2305, 13, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7611, 2305, 24, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7612, 2303, 10, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7613, 2303, 11, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7614, 2303, 20, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7615, 2302, 4, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7616, 2302, 9, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7617, 2301, 24, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7618, 2300, 11, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7619, 2300, 25, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7620, 2298, 27, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7621, 2296, 17, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7622, 2296, 20, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7623, 2293, 15, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7624, 2291, 18, 1, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7625, 2291, 23, 2, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7626, 2290, 8, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7627, 2290, 21, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7628, 2289, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7629, 2288, 17, 1, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7630, 2288, 20, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7631, 2287, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7632, 2287, 23, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7633, 2285, 3, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7634, 2285, 6, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7635, 2285, 26, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7636, 2282, 28, 1, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7637, 2281, 3, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7638, 2281, 12, 2, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7639, 2281, 13, 3, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7640, 2281, 29, 4, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7641, 2280, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7642, 2280, 27, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7643, 2280, 28, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7644, 2279, 5, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7645, 2279, 9, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7646, 2279, 19, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7647, 2278, 19, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7648, 2277, 11, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7649, 2277, 13, 2, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7650, 2277, 18, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7651, 2276, 7, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7652, 2276, 17, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7653, 2275, 15, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7654, 2275, 27, 2, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7655, 2274, 9, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7656, 2273, 7, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7657, 2273, 14, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7658, 2271, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7659, 2271, 10, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7660, 2271, 17, 3, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7661, 2269, 11, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7662, 2268, 10, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7663, 2268, 14, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7664, 2268, 17, 3, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7665, 2268, 27, 4, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7666, 2268, 29, 5, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7667, 2267, 1, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7668, 2267, 16, 2, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7669, 2267, 18, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7670, 2267, 20, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7671, 2267, 23, 5, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7672, 2266, 2, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7673, 2266, 10, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7674, 2266, 22, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7675, 2266, 24, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7676, 2265, 5, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7677, 2262, 2, 1, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7678, 2262, 5, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7679, 2261, 3, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7680, 2259, 4, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7681, 2259, 8, 2, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7682, 2259, 19, 3, 0.7900, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7683, 2259, 21, 4, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7684, 2259, 24, 5, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7685, 2258, 5, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7686, 2257, 14, 1, 0.7700, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7687, 2256, 10, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7688, 2255, 1, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7689, 2255, 11, 2, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7690, 2255, 27, 3, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7691, 2254, 20, 1, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7692, 2254, 25, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7693, 2249, 9, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7694, 2248, 10, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7695, 2248, 16, 2, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7696, 2247, 7, 1, 0.7700, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7697, 2246, 14, 1, 0.7700, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7698, 2245, 15, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7699, 2245, 26, 2, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7700, 2242, 28, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7701, 2241, 17, 1, 0.7900, 5)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7702, 2239, 2, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7703, 2239, 16, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7704, 2239, 20, 3, 0.7900, 8)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7705, 2238, 21, 1, 0.7900, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7706, 2236, 25, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7707, 2236, 27, 2, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7708, 2234, 7, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7709, 2234, 11, 2, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7710, 2234, 20, 3, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7711, 2233, 2, 1, 0.7700, 6)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7712, 2233, 23, 2, 0.7900, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7713, 2230, 2, 1, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7714, 2230, 24, 2, 0.7900, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7715, 2230, 25, 3, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7716, 2230, 27, 4, 0.7900, 3)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7717, 2229, 12, 1, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7718, 2228, 6, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7719, 2228, 10, 2, 0.7700, 7)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7720, 2227, 16, 1, 0.7900, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7721, 2226, 3, 1, 0.7700, 1)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7722, 2226, 7, 2, 0.7700, 4)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7723, 2226, 12, 3, 0.7700, 9)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7724, 2226, 16, 4, 0.7900, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7725, 2224, 6, 1, 0.7700, 2)
GO
INSERT [dbo].[Auftragspositionen] ([AuftragspositionID], [AuftragID], [ArtikelID], [PosNr], [Einzelpreis], [Menge]) VALUES (7726, 2223, 6, 1, 0.7700, 5)
GO
SET IDENTITY_INSERT [dbo].[Auftragspositionen] OFF
GO
SET IDENTITY_INSERT [dbo].[Kontakte] ON 

GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (1, N'K', N'Alfreds Sockenladen', NULL, N'Mauerweg 8', N'Berlin', N'Berlin', N'12209', N'Deutschland', N'030-0074321', N'030-0076545', N'info@alfreds-sockenladen.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (2, N'K', N'Zur blauen Socke', NULL, N'Retterstr. 10', N'Mannheim', N'Baden-Wrttemberg', N'68306', N'Deutschland', N'0621-08460', N'0621-08924', N'zur.blauen.socke@blauesocke.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (3, N'K', N'Socks', NULL, N'Gartenstr. 17', N'Mnchen', N'Bayern', N'80805', N'Deutschland', N'089-039123', N'089-059428', N'socks@socks.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (4, N'K', N'Frank''s Sockenladen', NULL, N'Ideenplatz 9', N'Aachen', N'Nordrhein-Westfalen', N'52066', N'Deutschland', NULL, NULL, N'frank.sockenladen@franksockenladen.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (5, N'K', N'Socks To Go', NULL, N'Pianoweg 11', N'Aschaffenburg', N'Hessen', N'63701', N'Deutschland', N'9876', NULL, N'socks.to.go@socktogo.com')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (6, N'K', N'Lehmanns Socken', NULL, N'Hessengasse 435', N'Frankfurt', N'Hessen', N'60528', N'Deutschland', N'069-0245984', N'069-0245874', N'lehmanns.socken@lehmann.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (7, N'K', N'Morgenstern Socken', NULL, N'Kopperweg 11', N'Leipzig', N'Sachsen', N'04179', N'Deutschland', N'3176', NULL, N'morgenstern.socken@morgenstern.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (8, N'K', N'Ottilies Modeladen', NULL, N'Severinstr. 77', N'Kln', N'Nordrhein-Westfalen', N'50739', N'Deutschland', N'0221-0644327', N'0221-0765721', N'ottilies.modeladen@hotmail.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (9, N'K', N'Socken-Stop', NULL, N'Waldweg 11', N'Cunewalde', N'Cunewald', N'01307', N'Deutschland', N'0372-035188', NULL, N'socken.shop@sockenstop.com')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (10, N'K', N'Toms Socken', NULL, N'Billstrae 88', N'Mnster', N'Nordrhein-Westfalen', N'44087', N'Deutschland', N'0251-031259', N'0251-035695', N'toms.socken@online.com')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (11, N'K', N'Wanderparadies', NULL, N'ttinger Pfad 8', N'Stuttgart', N'Baden-Wrttemberg', N'70563', N'Deutschland', N'0711-020361', N'0711-035428', N'wanderparadies@web.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (12, N'L', N'Textilien Schmitthuber GmbH', NULL, N'Trabantgasse 78', N'Berlin', N'Berlin', N'10785', N'Deutschland', N'9984510', NULL, N'info@schmitthuber.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (13, N'L', N'Sportwaren Kunze AG', NULL, N'Rodgauer Strae 9', N'Frankfurt', N'Hessen', N'60439', N'Deutschland', N'992755', NULL, N'info@sportwaren-kunze.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (14, N'L', N'Karl Meier GmbH ', NULL, N'Am Kai 8', N'Cuxhaven', N'Niedersachsen', N'27478', N'Deutschland', N'8713', NULL, N'info@karlmeier.com')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (15, N'K', N'Modeland Meier', NULL, N'Kirchhof 8', N'Neunkirchen', N'Bayern', N'63930', N'sterreich', N'9967', NULL, N'post@gmx.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (16, N'K', N'Socks & More', NULL, N'Gartenstr. 117', N'Simmern', N'Rheinland-Pfalz', N'55469', N'Deutschland', N'06761 98547112', NULL, N'email@socksandmore.de')
GO
INSERT [dbo].[Kontakte] ([KontaktID], [Kontaktart], [Firma], [Namenszusatz], [Strasse], [Ort], [Region], [PLZ], [Staat], [Telefon], [Telefax], [Email]) VALUES (17, N'K', N'Flo''s Sockenladen', NULL, N'Wiesenweg 9', N'Mnchen ', N'Bayern', N'80808', N'Deutschland', N'978765', NULL, N'flos.sockenladen@toffline.com')
GO
SET IDENTITY_INSERT [dbo].[Kontakte] OFF
GO
SET IDENTITY_INSERT [dbo].[Personal] ON 

GO
INSERT [dbo].[Personal] ([PersonalID], [Nachname], [Vorname], [Position], [Anrede], [Geburtsdatum], [Einstellung], [Durchwahl], [Mobil], [Email], [Foto], [Bemerkungen], [Vorgesetzter]) VALUES (1, N'Schmitt', N'Petra', N'Vertriebsmitarbeiterin', N'Frau', CAST(N'1988-02-08T00:00:00.0000000' AS DateTime2), CAST(N'2011-06-01T00:00:00.0000000' AS DateTime2), N'145', NULL, N'petra.schmitt@coolesocke.com', N'EmpID1.bmp', N'', 8)
GO
INSERT [dbo].[Personal] ([PersonalID], [Nachname], [Vorname], [Position], [Anrede], [Geburtsdatum], [Einstellung], [Durchwahl], [Mobil], [Email], [Foto], [Bemerkungen], [Vorgesetzter]) VALUES (2, N'Fller', N'Andreas', N'Geschftsfhrer', N'Herr', CAST(N'1992-08-19T00:00:00.0000000' AS DateTime2), CAST(N'2000-02-01T00:00:00.0000000' AS DateTime2), N'100', NULL, N'andreas.fueller@coolesocke.com', N'EmpID2.bmp', N'', NULL)
GO
INSERT [dbo].[Personal] ([PersonalID], [Nachname], [Vorname], [Position], [Anrede], [Geburtsdatum], [Einstellung], [Durchwahl], [Mobil], [Email], [Foto], [Bemerkungen], [Vorgesetzter]) VALUES (3, N'Lebering', N'Jutta', N'Vertriebsmitarbeiterin', N'Frau', CAST(N'1993-09-30T00:00:00.0000000' AS DateTime2), CAST(N'2010-12-01T00:00:00.0000000' AS DateTime2), N'146', NULL, N'jutta.lebering@coolesocke.com', N'EmpID3.bmp', N'', 8)
GO
INSERT [dbo].[Personal] ([PersonalID], [Nachname], [Vorname], [Position], [Anrede], [Geburtsdatum], [Einstellung], [Durchwahl], [Mobil], [Email], [Foto], [Bemerkungen], [Vorgesetzter]) VALUES (4, N'Pfau', N'Margarete', N'Vertriebsmitarbeiterin', N'Frau', CAST(N'1998-01-19T00:00:00.0000000' AS DateTime2), CAST(N'2007-01-01T00:00:00.0000000' AS DateTime2), N'147', NULL, N'margarete.pfau@coolesocke.com', N'EmpID4.bmp', N'', 8)
GO
INSERT [dbo].[Personal] ([PersonalID], [Nachname], [Vorname], [Position], [Anrede], [Geburtsdatum], [Einstellung], [Durchwahl], [Mobil], [Email], [Foto], [Bemerkungen], [Vorgesetzter]) VALUES (5, N'Buch', N'Stefan', N'Vertriebsmanager', N'Herr', CAST(N'1987-04-03T00:00:00.0000000' AS DateTime2), CAST(N'2001-05-01T00:00:00.0000000' AS DateTime2), N'141', NULL, N'stefan.buch@coolesocke.com', N'EmpID5.bmp', N'', 2)
GO
INSERT [dbo].[Personal] ([PersonalID], [Nachname], [Vorname], [Position], [Anrede], [Geburtsdatum], [Einstellung], [Durchwahl], [Mobil], [Email], [Foto], [Bemerkungen], [Vorgesetzter]) VALUES (6, N'Sumann', N'Michael', N'Vertriebsmitarbeiter', N'Herr', CAST(N'1986-02-07T00:00:00.0000000' AS DateTime2), CAST(N'2003-04-01T00:00:00.0000000' AS DateTime2), N'142', NULL, N'michael.sumann@coolesocke.com', N'EmpID6.bmp', N'', 8)
GO
INSERT [dbo].[Personal] ([PersonalID], [Nachname], [Vorname], [Position], [Anrede], [Geburtsdatum], [Einstellung], [Durchwahl], [Mobil], [Email], [Foto], [Bemerkungen], [Vorgesetzter]) VALUES (7, N'Knig', N'Patrick', N'Vertriebsmitarbeiter', N'Herr', CAST(N'1996-09-29T00:00:00.0000000' AS DateTime2), CAST(N'2001-01-02T00:00:00.0000000' AS DateTime2), N'143', NULL, N'patrick.koenig@coolesocke.com', N'EmpID7.bmp', N'', 8)
GO
INSERT [dbo].[Personal] ([PersonalID], [Nachname], [Vorname], [Position], [Anrede], [Geburtsdatum], [Einstellung], [Durchwahl], [Mobil], [Email], [Foto], [Bemerkungen], [Vorgesetzter]) VALUES (8, N'Kallaman', N'Laura', N'Vertriebskoordinatorin', N'Frau', CAST(N'1998-09-01T00:00:00.0000000' AS DateTime2), CAST(N'2005-09-01T00:00:00.0000000' AS DateTime2), N'144', NULL, N'laura.kallaman@coolesocke.com', N'EmpID8.bmp', N'', 5)
GO
INSERT [dbo].[Personal] ([PersonalID], [Nachname], [Vorname], [Position], [Anrede], [Geburtsdatum], [Einstellung], [Durchwahl], [Mobil], [Email], [Foto], [Bemerkungen], [Vorgesetzter]) VALUES (9, N'Lebhausen', N'Anna', N'Vertriebsmitarbeiterin', N'Frau', CAST(N'1995-04-22T00:00:00.0000000' AS DateTime2), CAST(N'2002-11-01T00:00:00.0000000' AS DateTime2), N'145', NULL, N'anna.lebhausen@coolesocke.com', N'EmpID9.bmp', N'', 8)
GO
SET IDENTITY_INSERT [dbo].[Personal] OFF
GO
/****** Object:  Index [IX_UQ__dbo_Ansprechpartner_KontaktID_Email]    Script Date: 15.02.2016 17:09:16 ******/
ALTER TABLE [dbo].[Ansprechpartner] ADD  CONSTRAINT [IX_UQ__dbo_Ansprechpartner_KontaktID_Email] UNIQUE NONCLUSTERED 
(
	[AnsprechpartnerID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
SET ANSI_PADDING ON

GO
/****** Object:  Index [IX__dbo_Ansprechpartner_Email]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Ansprechpartner_Email] ON [dbo].[Ansprechpartner]
(
	[Email] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
/****** Object:  Index [IX__dbo_Ansprechpartner_KontaktID]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Ansprechpartner_KontaktID] ON [dbo].[Ansprechpartner]
(
	[KontaktID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
SET ANSI_PADDING ON

GO
/****** Object:  Index [IX__dbo_Ansprechpartner_Nachname]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Ansprechpartner_Nachname] ON [dbo].[Ansprechpartner]
(
	[Nachname] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
SET ANSI_PADDING ON

GO
/****** Object:  Index [IX_UQ__dbo_Artikel_Matchcode]    Script Date: 15.02.2016 17:09:16 ******/
ALTER TABLE [dbo].[Artikel] ADD  CONSTRAINT [IX_UQ__dbo_Artikel_Matchcode] UNIQUE NONCLUSTERED 
(
	[Matchcode] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
SET ANSI_PADDING ON

GO
/****** Object:  Index [IX__dbo_Artikel_Artikel]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Artikel_Artikel] ON [dbo].[Artikel]
(
	[Artikel] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
/****** Object:  Index [IX__dbo_Artikel_ArtikelgruppeID]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Artikel_ArtikelgruppeID] ON [dbo].[Artikel]
(
	[ArtikelgruppeID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
SET ANSI_PADDING ON

GO
/****** Object:  Index [IX_UQ__dbo_Artikelgruppen_Artikelgruppe]    Script Date: 15.02.2016 17:09:16 ******/
ALTER TABLE [dbo].[Artikelgruppen] ADD  CONSTRAINT [IX_UQ__dbo_Artikelgruppen_Artikelgruppe] UNIQUE NONCLUSTERED 
(
	[Artikelgruppe] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
/****** Object:  Index [IX__dbo_Auftraege_Auftragsdatum]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Auftraege_Auftragsdatum] ON [dbo].[Auftraege]
(
	[Auftragsdatum] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
/****** Object:  Index [IX__dbo_Auftraege_KontaktID]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Auftraege_KontaktID] ON [dbo].[Auftraege]
(
	[KontaktID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
/****** Object:  Index [IX__dbo_Auftraege_PersonalID]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Auftraege_PersonalID] ON [dbo].[Auftraege]
(
	[PersonalID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
/****** Object:  Index [IX__dbo_Auftragspositionen_ArtikelID]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Auftragspositionen_ArtikelID] ON [dbo].[Auftragspositionen]
(
	[ArtikelID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
/****** Object:  Index [IX__dbo_Auftragspositionen_AuftragID]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Auftragspositionen_AuftragID] ON [dbo].[Auftragspositionen]
(
	[AuftragID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
/****** Object:  Index [IX_UQ__dbo_Kontakte_Kontaktart_Firma]    Script Date: 15.02.2016 17:09:16 ******/
ALTER TABLE [dbo].[Kontakte] ADD  CONSTRAINT [IX_UQ__dbo_Kontakte_Kontaktart_Firma] UNIQUE NONCLUSTERED 
(
	[KontaktID] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, IGNORE_DUP_KEY = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
SET ANSI_PADDING ON

GO
/****** Object:  Index [IX__dbo_Kontakte_Firma]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Kontakte_Firma] ON [dbo].[Kontakte]
(
	[Firma] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
SET ANSI_PADDING ON

GO
/****** Object:  Index [IX__dbo_Kontakte_Kontaktart]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Kontakte_Kontaktart] ON [dbo].[Kontakte]
(
	[Kontaktart] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
SET ANSI_PADDING ON

GO
/****** Object:  Index [IX__dbo_Personal_Nachname]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Personal_Nachname] ON [dbo].[Personal]
(
	[Nachname] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
/****** Object:  Index [IX__dbo_Personal_Vorgesetzter]    Script Date: 15.02.2016 17:09:16 ******/
CREATE NONCLUSTERED INDEX [IX__dbo_Personal_Vorgesetzter] ON [dbo].[Personal]
(
	[Vorgesetzter] ASC
)WITH (PAD_INDEX = OFF, STATISTICS_NORECOMPUTE = OFF, SORT_IN_TEMPDB = OFF, DROP_EXISTING = OFF, ONLINE = OFF, ALLOW_ROW_LOCKS = ON, ALLOW_PAGE_LOCKS = ON) ON [PRIMARY]
GO
ALTER TABLE [dbo].[Artikel] ADD  CONSTRAINT [Default__dbo_Artikel_Auslaufartikel_0]  DEFAULT ((0)) FOR [Auslaufartikel]
GO
ALTER TABLE [dbo].[Ansprechpartner]  WITH CHECK ADD  CONSTRAINT [FK__dbo_Ansprechpartner__dbo_Kontakte_KontaktID] FOREIGN KEY([KontaktID])
REFERENCES [dbo].[Kontakte] ([KontaktID])
GO
ALTER TABLE [dbo].[Ansprechpartner] CHECK CONSTRAINT [FK__dbo_Ansprechpartner__dbo_Kontakte_KontaktID]
GO
ALTER TABLE [dbo].[Artikel]  WITH CHECK ADD  CONSTRAINT [FK__dbo_Artikel__dbo_Artikelgruppen_ArtikelgruppeID] FOREIGN KEY([ArtikelgruppeID])
REFERENCES [dbo].[Artikelgruppen] ([ArtikelgruppeID])
GO
ALTER TABLE [dbo].[Artikel] CHECK CONSTRAINT [FK__dbo_Artikel__dbo_Artikelgruppen_ArtikelgruppeID]
GO
ALTER TABLE [dbo].[Artikel]  WITH CHECK ADD  CONSTRAINT [FK__dbo_Artikel__dbo_Kontakte_KontaktID_LieferantenNr] FOREIGN KEY([LieferantenNr])
REFERENCES [dbo].[Kontakte] ([KontaktID])
GO
ALTER TABLE [dbo].[Artikel] CHECK CONSTRAINT [FK__dbo_Artikel__dbo_Kontakte_KontaktID_LieferantenNr]
GO
ALTER TABLE [dbo].[Auftraege]  WITH CHECK ADD  CONSTRAINT [FK__dbo_Auftraege__dbo_Personal_PersonalID] FOREIGN KEY([PersonalID])
REFERENCES [dbo].[Personal] ([PersonalID])
GO
ALTER TABLE [dbo].[Auftraege] CHECK CONSTRAINT [FK__dbo_Auftraege__dbo_Personal_PersonalID]
GO
ALTER TABLE [dbo].[Auftraege]  WITH CHECK ADD  CONSTRAINT [FK__dho_Auftraege__dbo_Kontakte_KontaktID] FOREIGN KEY([KontaktID])
REFERENCES [dbo].[Kontakte] ([KontaktID])
GO
ALTER TABLE [dbo].[Auftraege] CHECK CONSTRAINT [FK__dho_Auftraege__dbo_Kontakte_KontaktID]
GO
ALTER TABLE [dbo].[Auftragspositionen]  WITH CHECK ADD  CONSTRAINT [FK__dbo_Auftragspositionen__dbo_Artikel_ArtikelID] FOREIGN KEY([ArtikelID])
REFERENCES [dbo].[Artikel] ([ArtikelID])
GO
ALTER TABLE [dbo].[Auftragspositionen] CHECK CONSTRAINT [FK__dbo_Auftragspositionen__dbo_Artikel_ArtikelID]
GO
ALTER TABLE [dbo].[Auftragspositionen]  WITH CHECK ADD  CONSTRAINT [FK__dbo_Auftragspositionen__dbo_Auftraege_AuftragID] FOREIGN KEY([AuftragID])
REFERENCES [dbo].[Auftraege] ([AuftragID])
GO
ALTER TABLE [dbo].[Auftragspositionen] CHECK CONSTRAINT [FK__dbo_Auftragspositionen__dbo_Auftraege_AuftragID]
GO
ALTER TABLE [dbo].[Auftragspositionen]  WITH NOCHECK ADD  CONSTRAINT [Check__dbo_Auftragspositionen_Einzelpreis_groesser_0] CHECK  (([Einzelpreis]>(0)))
GO
ALTER TABLE [dbo].[Auftragspositionen] CHECK CONSTRAINT [Check__dbo_Auftragspositionen_Einzelpreis_groesser_0]
GO
ALTER TABLE [dbo].[Auftragspositionen]  WITH NOCHECK ADD  CONSTRAINT [Check__dbo_Auftragspositionen_Menge_groesser_0] CHECK  (([Menge]>(0)))
GO
ALTER TABLE [dbo].[Auftragspositionen] CHECK CONSTRAINT [Check__dbo_Auftragspositionen_Menge_groesser_0]
GO
USE [master]
GO
ALTER DATABASE [SNEK] SET  READ_WRITE 
GO
-- Anpassungen fr Beispielskripte
USE SNEK;
GO
-- Schema fr RLS anlegen
CREATE SCHEMA Historie;
GO
-- RLS - Spalte fr SID hinzufgen
ALTER TABLE dbo.Personal ADD BenutzerID varbinary(85);
-- RLS - Anmeldungen zu Datenbank SNEK zuordnen
CREATE USER Kallaman WITHOUT LOGIN;
CREATE USER Lebhausen WITHOUT LOGIN;
GO
-- RLS - Benutzer Datenbankrollen zuordnen
ALTER ROLE [db_datareader] ADD MEMBER Kallaman;
ALTER ROLE [db_datawriter] ADD MEMBER Kallaman;
ALTER ROLE [db_datareader] ADD MEMBER Lebhausen;
ALTER ROLE [db_datawriter] ADD MEMBER Lebhausen;
GO
-- RLS - BenutzerID von Kallaman in Tabelle Personal speichern
EXECUTE AS USER = 'Kallaman';
UPDATE	dbo.Personal 
SET		BenutzerID = SUSER_SID() 
WHERE	Nachname = 'Kallaman';
REVERT;
-- BenutzerID von Kallaman in Tabelle Personal speichern
EXECUTE AS USER = 'Lebhausen';
UPDATE	dbo.Personal 
SET		BenutzerID = SUSER_SID() 
WHERE	Nachname = 'Lebhausen';
REVERT;
-- DDM - Benutzer anlegen
CREATE USER Bundestrojaner WITHOUT LOGIN;
ALTER ROLE [db_datareader] ADD MEMBER Bundestrojaner;
ALTER ROLE [db_datawriter] ADD MEMBER Bundestrojaner;